
#ifndef __DRV_CAN_H__
#define __DRV_CAN_H__

#include "Global.h"

#define CANx                       CAN1
#define CANx_CLK                       RCC_APB1Periph_CAN1
#define CANx_CLK_INIT                  RCC_APB1PeriphClockCmd
#define CANx_IRQn                      USB_LP_CAN1_RX0_IRQn//CAN1_RX0_IRQn
#define CANx_IRQHandler                USB_LP_CAN1_RX0_IRQHandler//CAN1_RX1_IRQHandler

//#define GPIO_Remapping_CAN         GPIO_Remapping_CAN1


#define Can_RX_PIN                    GPIO_Pin_11
#define Can_RX_GPIO_PORT              GPIOA
#define Can_RX_GPIO_CLK               RCC_APB2Periph_GPIOA

#define Can_TX_PIN                    GPIO_Pin_12
#define Can_TX_GPIO_PORT              GPIOA
#define Can_TX_GPIO_CLK               RCC_APB2Periph_GPIOA

extern u8 CanInit(void);

extern void CAN_TxData(char data);


#endif

