
/******************************************************************************
ļ  : Drv_SIM800C.c
  : ̨
  :
޸  : 2014-09-04      

******************************************************************************/

#include "Drv_SIM800C.h"
#include "Memory.h"



/*

+RECEIVE,0,10:
1234567890
*/

typedef enum
{
  eRxSta_0D = 0,
  eRxSta_0A,
  eRxSta_Recv_R,
  eRxSta_Recv_E,
  eRxSta_Recv_C,
  eRxSta_Recv_E2,
  eRxSta_Recv_I,
  eRxSta_Recv_V,
  eRxSta_Recv_E3,
  eRxSta_Recv_Comma,
  eRxSta_Recv_Socket,
  eRxSta_Recv_Comma2,
  eRxSta_Recv_Len,
  eRxSta_Recv_0D,
  eRxSta_Recv_0A,
  eRxSta_Recv_Data,
}EnumModRecvStatus;

/******************************************************************
*    ƣ InternetFrameRecv
*       ȡڽն(FIFO)һ֡
            һ֡EEͷFF FC FF FF βһ֡
*ڲ 
*ڲ 
********************************************************************/
u8 GetSim800cFrame(char *pFrame, u16 MaxLen)
{
  osEvent RecvDataMsg;
  u8 DataTemp;
  u8 FrameLen = 0;
  u8 RecvFlag = 0;//0Ч˿ڣ1Ϊģʽն˿ڣ2Ϊͻģʽն˿
  u16 RecvLen = 0;
  EnumModRecvStatus RecvSta = eRxSta_0D;

  RecvDataMsg = osMessageGet(Gprs.Uart.RecvQ, 23);
  while((osEventMessage == RecvDataMsg.status) && (FrameLen < (MaxLen-1)))
  {
    DataTemp = RecvDataMsg.value.v;
    pFrame[FrameLen] = DataTemp;
    FrameLen++;
    pFrame[FrameLen] = 0;
    switch(RecvSta)
    {
      case eRxSta_0D:
        if(0x0D == DataTemp)//յ0x0D
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)//յַ
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_0A:
        if(0x0A == DataTemp)
        {//յ0x0A,
          pFrame[FrameLen] = 0;
          if(FrameLen > 2)//ݷ
            return FrameLen;
          else
          {//ݣ㣬
            RecvSta = eRxSta_0D;
            FrameLen = 0;
          }
        }
        else if(0x0D == DataTemp)
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_Recv_R:
        if('R' == DataTemp)
          RecvSta = eRxSta_Recv_E;
        else if(0x0D == DataTemp)
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_Recv_E:
        if('E' == DataTemp)
          RecvSta = eRxSta_Recv_C;
        else if(0x0D == DataTemp)
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_Recv_C:
        if('C' == DataTemp)
          RecvSta = eRxSta_Recv_E2;
        else if(0x0D == DataTemp)
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_Recv_E2:
        if('E' == DataTemp)
          RecvSta = eRxSta_Recv_I;
        else if(0x0D == DataTemp)
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_Recv_I:
        if('I' == DataTemp)
          RecvSta = eRxSta_Recv_V;
        else if(0x0D == DataTemp)
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_Recv_V:
        if('V' == DataTemp)
          RecvSta = eRxSta_Recv_E3;
        else if(0x0D == DataTemp)
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_Recv_E3:
        if('E' == DataTemp)
          RecvSta = eRxSta_Recv_Comma;
        else if(0x0D == DataTemp)
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_Recv_Comma:
        if(',' == DataTemp)
          RecvSta = eRxSta_Recv_Socket;
        else if(0x0D == DataTemp)
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_Recv_Socket:
        if((DataTemp >= '0') && (DataTemp <= '5'))
        {
          if((DataTemp - '0') == Gprs.MainScktNum)
            RecvFlag = 1;
          RecvSta = eRxSta_Recv_Comma2;
        }
        else if(0x0D == DataTemp)
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_Recv_Comma2:
        if(',' == DataTemp)
        {
          RecvLen = 0;
          RecvSta = eRxSta_Recv_Len;
        }
        else if(0x0D == DataTemp)
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_Recv_Len:
        if((DataTemp >= '0') && (DataTemp <= '9'))
          RecvLen = (RecvLen * 10) + (DataTemp - '0');
        else if(':' == DataTemp)
          RecvSta = eRxSta_Recv_0D;
        else if(0x0D == DataTemp)
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_Recv_0D:
        if(0x0D == DataTemp)
          RecvSta = eRxSta_Recv_0A;
        else if('+' == DataTemp)
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_Recv_0A:
        if(0x0A == DataTemp)
        {
          if(RecvLen)
            RecvSta = eRxSta_Recv_Data;
          else
            RecvSta = eRxSta_0D;
        }
        else if(0x0D == DataTemp)
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        break;
      case eRxSta_Recv_Data:
        FrameLen--;//ݣpFrame
        if(RecvFlag && Gprs.AppRecvQ)
          osMessagePut(Gprs.AppRecvQ, DataTemp, 0);
        RecvLen--;
        if(0 == RecvLen)
        {
          RecvSta = eRxSta_0D;
          return FrameLen;
        }
        break;
      default:
        if(0x0D == DataTemp)//յ0x0D
          RecvSta = eRxSta_0A;
        else if('+' == DataTemp)//յַ
          RecvSta = eRxSta_Recv_R;
        else
          RecvSta = eRxSta_0D;
        FrameLen = 0;
        pFrame[FrameLen] = DataTemp;
        FrameLen++;
        pFrame[FrameLen] = 0;
        break;
    }
    RecvDataMsg = osMessageGet(Gprs.Uart.RecvQ, 5);
  }

  pFrame[FrameLen]= 0;
  return FrameLen;
}

char ServeAddrStr[64] = {0};

typedef enum
{
  eSim800cProc_At = 0,//0
  eSim800cProc_Ate,//1
  eSim800cProc_Gmm,//2
  eSim800cProc_Cpin,//3
  eSim800cProc_Ccid,//4
  eSim800cProc_Csq,//5
  eSim800cProc_Creg,//6
  eSim800cProc_Cgatt,//7
  eSim800cProc_Cipmux,//8
  eSim800cProc_Cstt,//9
  eSim800cProc_Ciicr,//10
  eSim800cProc_Cifsr,//11
  eSim800cProc_Cipstart,//12
  eSim800cProc_Cipstatus,//13
  eSim800cProc_Cipclose,//14
  eSim800cProc_Cipshut,//15
  eSim800cProc_Error,//16
  eSim800cProc_Idle,//17
  eSim800cProc_Csq_I,//18
  eSim800cProc_Cipstatus_I,//19
  eSim800cProc_Send,//20
}EnumSim800cProc;

void Sim800cProcAt(void)
{
  u8 Ack = 0;

  if(0 == Gprs.Proc.StatusTick)
    Gprs.Proc.StatusTick = GetSystemTick();
  if((GetSystemTick() - Gprs.Proc.StatusTick) > 60000)//60s
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
    return;
  }

  GprsModSendCmd(NULL, "AT\r\n");
  Ack = GprsModWaitAck(3000);
  if(1 == Ack)
  {
    Gprs.Err.Bit.NoMod = 0;
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Ate;
  }
  else
    Gprs.Err.Bit.NoMod = 1;
}

void Sim800cProcAte(void)
{
  u8 Ack = 0;

  GprsModSendCmd(NULL, "ATE0\r\n");
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Gmm;
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcGmm(void)
{
  u8 Ack = 0;
  char *pStr;

  GprsModSendCmd(NULL, "AT+GMM\r\n");
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    pStr = strstr(Gprs.Cmd.RespExBuf,"SIM800");
    if(NULL != pStr)
      Gprs.Err.Bit.NoDrv = 0;
    else
      Gprs.Err.Bit.NoDrv = 1;
    Gprs.Err.Bit.NoMod = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Cpin;
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcCpin(void)
{
  u8 Ack = 0;

  if(0 == Gprs.Proc.StatusTick)
    Gprs.Proc.StatusTick = GetSystemTick();
  if((GetSystemTick() - Gprs.Proc.StatusTick) > 60000)//60s
  {
    Gprs.Err.Bit.NoSim = 1;
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
    return;
  }

  GprsModSendCmd(NULL, "AT+CPIN?\r\n");
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    Gprs.Err.Bit.NoSim = 0;
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Ccid;
  }
  else if(2 == Ack)
  {
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcCcid(void)
{
  u8 Ack = 0;
  char *pStr;

  GprsModSendCmd(NULL, "AT+CCID\r\n");
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    pStr = strstr(Gprs.Cmd.RespExBuf,"\r\n");
    if(NULL != pStr)
    {
      if((&Gprs.Cmd.RespExBuf[20]) == pStr)
        memcpy(Gprs.Ccid, Gprs.Cmd.RespExBuf, 20);
    }
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Csq;
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcCsq(void)
{
  u8 Ack = 0;
  char *pStr;
  u8 Temp;

  GprsModSendCmd("+CSQ: ", "AT+CSQ\r\n");
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    pStr = strstr(Gprs.Cmd.RespExBuf,"+CSQ: ");
    if(NULL != pStr)
    {
      Temp = pStr[6] - '0';
      if((pStr[7] >= '0') && (pStr[7] <= '9'))
        Temp = (Temp * 10) + (pStr[7] - '0');

      Gprs.Csq = Temp;
    }
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Creg;
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcCreg(void)
{
  u8 Ack = 0;

  if(0 == Gprs.Proc.StatusTick)
    Gprs.Proc.StatusTick = GetSystemTick();
  if((GetSystemTick() - Gprs.Proc.StatusTick) > 100000)//100s
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
    return;
  }

  GprsModSendCmd("+CREG", "AT+CREG?\r\n");
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    if((NULL != strstr(Gprs.Cmd.RespExBuf,"+CREG: 0,1"))
        || (NULL != strstr(Gprs.Cmd.RespExBuf,"+CREG: 0,5")))
    {
      Gprs.Err.Bit.NoReg = 0;
      Gprs.Proc.StatusTick = 0;
      Gprs.Proc.ErrCnt = 0;
      Gprs.Proc.Status = eSim800cProc_Cgatt;
    }
    else if((NULL != strstr(Gprs.Cmd.RespExBuf,"+CREG: 0,3"))
        || (NULL != strstr(Gprs.Cmd.RespExBuf,"+CREG: 0,4")))
    {
      Gprs.Err.Bit.NoReg = 1;
      Gprs.Proc.StatusTick = 0;
      Gprs.Proc.ErrCnt = 0;
      Gprs.Proc.Status = eSim800cProc_Error;
    }
    else
    {
      Gprs.Err.Bit.NoReg = 1;
      Gprs.Proc.ErrCnt = 0;
      Gprs.Proc.Status = eSim800cProc_Csq;
      osDelay(800);
    }
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcCgatt(void)
{
  u8 Ack = 0;
  char *pStr;

  if(0 == Gprs.Proc.StatusTick)
    Gprs.Proc.StatusTick = GetSystemTick();
  if((GetSystemTick() - Gprs.Proc.StatusTick) > 100000)//100s
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
    return;
  }

  GprsModSendCmd("+CGATT", "AT+CGATT?\r\n");
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    pStr = strstr(Gprs.Cmd.RespExBuf,"+CGATT: 1");
    if(NULL != pStr)
    {
      Gprs.Proc.StatusTick = 0;
      Gprs.Proc.ErrCnt = 0;
      Gprs.Proc.Status = eSim800cProc_Cipmux;
    }
    else
    {
      GprsModSendCmd(NULL, "AT+CGATT=1\r\n");
      Ack = GprsModWaitAck(15000);//15
      if(1 == Ack)
        Gprs.Proc.ErrCnt = 0;
      else if (2 == Ack)
      {
      }
      else
      {
        osDelay(5000);
        Gprs.Proc.ErrCnt++;
      }
    }
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 5)
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcCipmux(void)
{
  u8 Ack = 0;

  GprsModSendCmd(NULL, "AT+CIPMUX=1\r\n");
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Cstt;
  }
  else if(2 == Ack)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Cipshut;
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcCstt(void)
{
  u8 Ack = 0;
  char *pApn;

  GprsModSendCmd("+COPS", "AT+COPS?\r\n");
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    if((NULL != strstr(Gprs.Cmd.RespExBuf,"CHN-UNICOM"))
        || (NULL != strstr(Gprs.Cmd.RespExBuf,"UNICOM"))
        || (NULL != strstr(Gprs.Cmd.RespExBuf,"46001")))
    {
      Gprs.Err.Bit.NoCop = 0;
      pApn = "UNINET";
    }
    else if((NULL != strstr(Gprs.Cmd.RespExBuf,"CHINA MOBILE"))
        || (NULL != strstr(Gprs.Cmd.RespExBuf,"CMCC"))
        || (NULL != strstr(Gprs.Cmd.RespExBuf,"46000")))
    {
      Gprs.Err.Bit.NoCop = 0;
      pApn = "CMNET";
    }
    else
    {
      Gprs.Err.Bit.NoCop = 1;
      pApn = "CMNET";
    }

    GprsModSendCmd(NULL, "AT+CSTT=\"%s\"\r\n", pApn);
    Ack = GprsModWaitAck(300);
    if(1 == Ack)
    {
      Gprs.Proc.ErrCnt = 0;
      Gprs.Proc.Status = eSim800cProc_Ciicr;
    }
    else if(2 == Ack)
    {
      Gprs.Proc.ErrCnt = 0;
      Gprs.Proc.Status = eSim800cProc_Cipshut;
    }
    else
      Gprs.Proc.ErrCnt++;
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcCiicr(void)
{
  u8 Ack = 0;

  if(0 == Gprs.Proc.StatusTick)
    Gprs.Proc.StatusTick = GetSystemTick();
  if((GetSystemTick() - Gprs.Proc.StatusTick) > 90000)//90s
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
    return;
  }

  GprsModSendCmd(NULL, "AT+CIICR\r\n");
  Ack = GprsModWaitAck(90000);//90
  if(1 == Ack)
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Cifsr;
  }
  else if(2 == Ack)
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Cipshut;
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcCifsr(void)
{
  u8 Ack = 0;
  char *pStr;
  char *pTemp;
  u8 i;

  GprsModSendCmd(".", "AT+CIFSR\r\n");
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    Gprs.Proc.ErrCnt++;
  }
  else if(2 == Ack)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Cipshut;
  }
  else
  {
    i = 0;
    pStr = strstr(Gprs.Cmd.RespExBuf, ".");
    while((NULL != pStr) && (i < 3))
    {
      i++;
      pTemp = pStr + 1;
      pStr = strstr(pTemp, ".");
      if((NULL != pStr))
      {
        i++;
        pTemp = pStr + 1;
      }
    }
    if(i >= 3)
    {
      Gprs.Proc.ErrCnt = 0;
      Gprs.Proc.Status = eSim800cProc_Cipstart;
    }
    else
      Gprs.Proc.ErrCnt++;
  }

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcCipstart(void)
{
  u8 Ack = 0;

  if(0 == HadSigned)
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_At;
    return;
  }

  snprintf(ServeAddrStr, sizeof(ServeAddrStr), "\"%d.%d.%d.%d\",\"%d\"",
              ServerAddr.Ip[0], ServerAddr.Ip[1], ServerAddr.Ip[2], ServerAddr.Ip[3], ServerAddr.Port);

  Gprs.MainScktNum = 0;
  GprsModSendCmd(NULL, "AT+CIPSTART=%d,\"TCP\",\"%d.%d.%d.%d\",\"%d\"\r\n", Gprs.MainScktNum,
              ServerAddr.Ip[0], ServerAddr.Ip[1], ServerAddr.Ip[2], ServerAddr.Ip[3], ServerAddr.Port);
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Cipstatus;
  }
  else if(2 == Ack)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Cipshut;
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcCipstatus(void)
{
  u8 Ack = 0;

  if(0 == Gprs.Proc.StatusTick)
    Gprs.Proc.StatusTick = GetSystemTick();
  if((GetSystemTick() - Gprs.Proc.StatusTick) > 80000)//80s
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Cipstart;
    return;
  }

  GprsModSendCmd(NULL, "AT+CIPSTATUS\r\n");
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    Gprs.Proc.ErrCnt = 0;
    osDelay(750);
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcCipclose(void)
{
  u8 Ack = 0;

  GprsModSendCmd(NULL, "AT+CIPCLOSE=%d\r\n", Gprs.MainScktNum);
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Cipstart;
  }
  else if(2 == Ack)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Cipstart;
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcCipshut(void)
{
  u8 Ack = 0;

  if(0 == Gprs.Proc.StatusTick)
    Gprs.Proc.StatusTick = GetSystemTick();
  if((GetSystemTick() - Gprs.Proc.StatusTick) > 100000)//100s
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
    return;
  }

  GprsModSendCmd(NULL, "AT+CIPSHUT\r\n", Gprs.MainScktNum);
  Ack = GprsModWaitAck(70000);//70
  if(1 == Ack)
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_At;
  }
  else if(2 == Ack)
  {
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.StatusTick = 0;
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcError(void)
{
  GPIO_ResetBits(GprsPowerCtrl_PORT, GprsPowerCtrl_PIN);
  osDelay(10000);
  GPIO_SetBits(GprsPowerCtrl_PORT, GprsPowerCtrl_PIN);
  osDelay(2000);

  Gprs.Proc.StatusTick = 0;
  Gprs.Proc.ErrCnt = 0;
  Gprs.Proc.Status = eSim800cProc_At;
}

void Sim800cProcIdle(void)
{
  switch(Gprs.SelCtrl)
  {
    case eSelfCtrl_None:
      switch(Gprs.Send.Ctrl)
      {
        case eSendCtrl_SendReq:
          Gprs.Proc.StatusTick = 0;
          Gprs.Proc.ErrCnt = 0;
          Gprs.Proc.Status = eSim800cProc_Send;
          break;
        default:
          if(0 == Gprs.Proc.StatusTick)
            Gprs.Proc.StatusTick = GetSystemTick();
          if((0 != Gprs.Proc.StatusTick) && ((GetSystemTick() - Gprs.Proc.StatusTick) > 5000))
          {
            Gprs.Proc.StatusTick = 0;
            Gprs.Proc.ErrCnt = 0;
            Gprs.Proc.Status = eSim800cProc_Csq_I;
          }
          break;
      }
      break;
    case eSelfCtrl_CloseSckt:
      Gprs.SelCtrl = eSelfCtrl_None;
      Gprs.Proc.StatusTick = 0;
      Gprs.Proc.ErrCnt = 0;
      Gprs.Proc.Status = eSim800cProc_Cipclose;
      break;
    case eSelfCtrl_ShutPpp:
      Gprs.SelCtrl = eSelfCtrl_None;
      Gprs.Proc.StatusTick = 0;
      Gprs.Proc.ErrCnt = 0;
      Gprs.Proc.Status = eSim800cProc_Cipshut;
      break;
    case eSelfCtrl_Error:
      Gprs.SelCtrl = eSelfCtrl_None;
      Gprs.Proc.StatusTick = 0;
      Gprs.Proc.ErrCnt = 0;
      Gprs.Proc.Status = eSim800cProc_At;
      break;
  }
}

void Sim800cProcCsq_I(void)
{
  u8 Ack = 0;
  char *pStr;
  u8 Temp;

  GprsModSendCmd("+CSQ: ", "AT+CSQ\r\n");
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    pStr = strstr(Gprs.Cmd.RespExBuf,"+CSQ: ");
    if(NULL != pStr)
    {
      Temp = pStr[6] - '0';
      if((pStr[7] >= '0') && (pStr[7] <= '9'))
        Temp = (Temp * 10) + (pStr[7] - '0');

      Gprs.Csq = Temp;
    }
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Cipstatus_I;
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

void Sim800cProcCipstatus_I(void)
{
  u8 Ack = 0;

  GprsModSendCmd(NULL, "AT+CIPSTATUS\r\n");
  Ack = GprsModWaitAck(300);
  if(1 == Ack)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Idle;
  }
  else
    Gprs.Proc.ErrCnt++;

  if(Gprs.Proc.ErrCnt > 3)
  {
    Gprs.Proc.ErrCnt = 0;
    Gprs.Proc.Status = eSim800cProc_Error;
  }
}

//0ͳɹ 1SocketϿ 0xFFģ
void Sim800cProcCipsend(void)
{
  u8 Ack = 0;
  u16 SendLen = 0;
  u8  SendCnt = 0;
  u16 SendSingle = 0;
  u16 i = 0;
  char *pStr;

  SendCnt = Gprs.Send.BufLen/1024;
  SendSingle = Gprs.Send.BufLen%1024;
  SendLen = 0;
  Gprs.Send.Ctrl = eSendCtrl_Sending;
  while(SendCnt)
  {
    GprsModSendCmd(">", "AT+CIPSEND=%d,1024\r\n", Gprs.Send.ScktNum);
    Ack = GprsModWaitAck(100);
    if((1 == Ack) || (2 == Ack))
    {
      if(eSelfCtrl_None == Gprs.SelCtrl)
        Gprs.SelCtrl = eSelfCtrl_CloseSckt;
      Gprs.Send.Ctrl = eSendCtrl_SendErr;
      Gprs.Proc.ErrCnt = 0;
      Gprs.Proc.Status = eSim800cProc_Idle;
      return;
    }
    else
    {
      pStr = strstr(Gprs.Cmd.RespExBuf,">");
//      if(NULL != pStr)
      {
        Gprs.Cmd.Sta = 0;
        Gprs.Cmd.Ack = 0;
        memset(Gprs.Cmd.RespExBuf, 0, sizeof(Gprs.Cmd.RespExBuf));
        Gprs.Cmd.pRespExFlag = "+CME ERROR";
        Gprs.Cmd.pResp_1 = "OK";
        Gprs.Cmd.pResp_2 = "ERROR";
        for(i=0; i<sizeof(Gprs.Send.Buf); i++)
          GprsModSendByte(Gprs.Send.Buf[SendLen+i]);
        Gprs.Cmd.Sta = 1;

        Ack = GprsModWaitAck(5000);

        if(1 == Ack)
        {
          SendCnt--;
          SendLen += 1024;
        }
        else if(2 == Ack)
        {
          if(eSelfCtrl_None == Gprs.SelCtrl)
            Gprs.SelCtrl = eSelfCtrl_CloseSckt;
          Gprs.Send.Ctrl = eSendCtrl_SendErr;
          Gprs.Proc.ErrCnt = 0;
          Gprs.Proc.Status = eSim800cProc_Idle;
          return;
        }
        else
        {
          SendCnt--;
          SendLen += 1024;
        }
        #if 0
        {
          Gprs.Send.Ctrl = eSendCtrl_SendErr;
          Gprs.Proc.ErrCnt = 0;
          Gprs.Proc.Status = eSim800cProc_Idle;
          return;
        }
        #endif
      }
    }
  }

  while(SendSingle)
  {
    GprsModSendCmd(">", "AT+CIPSEND=%d,%d\r\n", Gprs.Send.ScktNum, SendSingle);
    Ack = GprsModWaitAck(150);
    if((1 == Ack) || (2 == Ack))
    {
      if(eSelfCtrl_None == Gprs.SelCtrl)
        Gprs.SelCtrl = eSelfCtrl_CloseSckt;
      Gprs.Send.Ctrl = eSendCtrl_SendErr;
      Gprs.Proc.ErrCnt = 0;
      Gprs.Proc.Status = eSim800cProc_Idle;
      return;
    }
    else
    {
      pStr = strstr(Gprs.Cmd.RespExBuf,">");
//      if(NULL != pStr)
      {
        Gprs.Cmd.Sta = 0;
        Gprs.Cmd.Ack = 0;
        memset(Gprs.Cmd.RespExBuf, 0, sizeof(Gprs.Cmd.RespExBuf));
        Gprs.Cmd.pRespExFlag = "+CME ERROR";
        Gprs.Cmd.pResp_1 = "OK";
        Gprs.Cmd.pResp_2 = "ERROR";
        for(i=0; i<SendSingle; i++)
          GprsModSendByte(Gprs.Send.Buf[SendLen+i]);
        Gprs.Cmd.Sta = 1;

        Ack = GprsModWaitAck(5000);

        if(1 == Ack)
        {
          SendLen += SendSingle;
          SendSingle = 0;
        }
        else if(2 == Ack)
        {
          if(eSelfCtrl_None == Gprs.SelCtrl)
            Gprs.SelCtrl = eSelfCtrl_CloseSckt;
          Gprs.Send.Ctrl = eSendCtrl_SendErr;
          Gprs.Proc.ErrCnt = 0;
          Gprs.Proc.Status = eSim800cProc_Idle;
          return;
        }
        else
        {
          SendLen += SendSingle;
          SendSingle = 0;
        }
        #if 0
        {
          Gprs.Send.Ctrl = eSendCtrl_SendErr;
          Gprs.Proc.ErrCnt = 0;
          Gprs.Proc.Status = eSim800cProc_Idle;
          return;
        }
        #endif
      }
    }
  }

  Gprs.Send.Ctrl = eSendCtrl_SendDone;
  Gprs.Proc.ErrCnt = 0;
  Gprs.Proc.Status = eSim800cProc_Idle;
}

pGprsProcHandle Sim800cProcHandle[] =
{
  Sim800cProcAt,
  Sim800cProcAte,
  Sim800cProcGmm,
  Sim800cProcCpin,
  Sim800cProcCcid,
  Sim800cProcCsq,
  Sim800cProcCreg,
  Sim800cProcCgatt,
  Sim800cProcCipmux,
  Sim800cProcCstt,
  Sim800cProcCiicr,
  Sim800cProcCifsr,
  Sim800cProcCipstart,
  Sim800cProcCipstatus,
  Sim800cProcCipclose,
  Sim800cProcCipshut,
  Sim800cProcError,
  Sim800cProcIdle,
  Sim800cProcCsq_I,
  Sim800cProcCipstatus_I,
  Sim800cProcCipsend
};

void Sim800cSend(void)
{
  if(Gprs.Proc.Status < (sizeof(Sim800cProcHandle)/sizeof(pGprsProcHandle)))
    Sim800cProcHandle[Gprs.Proc.Status]();
  else
    Gprs.Proc.Status = 0;
}

/******************************************************************************
  : Thread_Lcd
  : ˻߳
  : argument - ̴߳
  : 
******************************************************************************/
void Sim800cRecv(void)
{
  char Frame[128];
  char *pStr;

//  snprintf(ServeAddrStr, sizeof(ServeAddrStr), "\"%d.%d.%d.%d\",\"%d\"",
//              ServerAddr.Ip[0], ServerAddr.Ip[1], ServerAddr.Ip[2], ServerAddr.Ip[3], ServerAddr.Port);
  if(0 != GetSim800cFrame(Frame, sizeof(Frame)))
  {
    if(1 == Gprs.Cmd.Sta)
    {
      if(NULL != Gprs.Cmd.pRespExFlag)
      {
        pStr = strstr(Frame, Gprs.Cmd.pRespExFlag);
        if(pStr)
        {
          memcpy(Gprs.Cmd.RespExBuf, pStr, sizeof(Gprs.Cmd.RespExBuf));
          Gprs.Cmd.RespExBuf[sizeof(Gprs.Cmd.RespExBuf)-1] = 0;
          pStr = strstr(Gprs.Cmd.pRespExFlag, "+CME ERROR");
          if(!pStr)
            return;
        }
      }

      if(NULL != Gprs.Cmd.pResp_1)
      {
        pStr = strstr(Frame, Gprs.Cmd.pResp_1);
        if(pStr)
        {
          Gprs.Cmd.Ack = 1;
          Gprs.Cmd.Sta = 2;
          return;
        }
      }

      if(NULL != Gprs.Cmd.pResp_2)
      {
        pStr = strstr(Frame, Gprs.Cmd.pResp_2);
        if(pStr)
        {
          Gprs.Cmd.Ack = 2;
          Gprs.Cmd.Sta = 2;
          return;
        }
      }
      if(NULL == Gprs.Cmd.pRespExFlag)
      {
        memcpy(Gprs.Cmd.RespExBuf, Frame, sizeof(Gprs.Cmd.RespExBuf));
        Gprs.Cmd.RespExBuf[sizeof(Gprs.Cmd.RespExBuf)-1] = 0;
      }
    }

    pStr = strstr(Frame, "+CPIN: NOT READY");
    if(pStr)
    {
      if(Gprs.Proc.Status >= eSim800cProc_Idle)
        Gprs.SelCtrl = eSelfCtrl_Error;
      return;
    }

    pStr = strstr(Frame, "PDP: DEACT");
    if(pStr)
    {
      if(Gprs.Proc.Status >= eSim800cProc_Idle)
        Gprs.SelCtrl = eSelfCtrl_ShutPpp;
      return;
    }

    pStr = strstr(Frame, "STATE: ");
    if(pStr)
    {
      pStr = strstr(Frame, "IP PROCESSING");
      if((NULL == pStr) && (Gprs.Proc.Status >= eSim800cProc_Idle))
        Gprs.SelCtrl = eSelfCtrl_CloseSckt;
      return;
    }

    pStr = strstr(Frame, ServeAddrStr);
    if(pStr)
    {
      if(eSim800cProc_Cipstatus == Gprs.Proc.Status)
      {
        pStr = strstr(Frame, "CONNECTED");
        if(pStr)
        {
          Gprs.Send.ScktNum = Gprs.MainScktNum;
          Gprs.SelCtrl = eSelfCtrl_None;
          Gprs.Proc.Status = eSim800cProc_Idle;
        }
      }
      else if(Gprs.Proc.Status >= eSim800cProc_Idle)
      {
        pStr = strstr(Frame, "CONNECTED");
        if(NULL == pStr)
          Gprs.SelCtrl = eSelfCtrl_CloseSckt;
      }
      return;
    }
  }
}

u8 Sim800cNetAvail(void)
{
  if((eSelfCtrl_None == Gprs.SelCtrl) && (Gprs.Proc.Status >= eSim800cProc_Idle))
    return TRUE;
  return FALSE;
}

StructGprsDrv Sim800cDrv =
{
  .pModName = "SIM800",
  .SendHandle = Sim800cSend,
  .RecvHandle = Sim800cRecv,
  .NetAvail = Sim800cNetAvail
};


