
#include "Thd_Charge.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"


void ChgProCommBeak_AB(StructChargeCtrl *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CEM_SendTick = 0;
  u32 CurrtCheckTick = 0;
  u32 ChgReStartTick = 0;
  u32 CcStatusChkTick = 0;

  if(0 == CommErrorCount)
  {
    CommErrFrame[0] = BemMsg.Bem.Mult;
    CommErrFrame[1] = CemMsg.Cem.Mult;
  }
  else if(1 == CommErrorCount)
  {
    CommErrFrame[2] = BemMsg.Bem.Mult;
    CommErrFrame[3] = CemMsg.Cem.Mult;
  }

  CommErrorCount++;
  if(CommErrorCount > 2)
  {
    CstMsg.StopReason.Value.Truble = 1;//ֹͣ
    CstMsg.StopTruble.Value.Other = 1;//  ͨųʱ
    ChargeStopType = eChgStop_ComBreak_CommError;
    pChargeCtrl->CurProcess = eChgPro_AB_CommError;
    pChargeCtrl->Param = 0;
    return;
  }

  BstMsg.Valid = 0;
  BmsCanInit();
  osDelay(20);

  ChargeTimerSet(eSwSta_Off);
  BmsPowerSet_AB(eSwSta_On);
  LockSet_AB(eSwSta_On);
  FanSet_AB(eSwSta_On);
  ImdWorkSet_AB(eSwSta_Off);
  DrainResistSet_AB(eSwSta_Off);
  //DcOutSet_AB(eSwSta_On);
  DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));

  if(0 != CemMsg.Cem.Mult)
    CEM_Send(&CemMsg);
  CEM_SendTick = GetSystemTick();

  CurrtCheckTick = GetSystemTick();
  ChgReStartTick = 0;

  while(1)
  {
    if((0 != CEM_SendTick) && ((GetSystemTick() - CEM_SendTick) > 250))
    {
      if(0 != CemMsg.Cem.Mult)//ͨŹ
        CEM_Send(&CemMsg);
      CEM_SendTick = GetSystemTick();
    }

    ChgPgnRecv(&PgnRecv);

    if(GetDcModuleCurrt_AB() < 50)//С5A
    {
      CurrtCheckTick = 0;
      if(0 == ChgReStartTick)
      {
        DcOutSet_AB(eSwSta_Off);//k1 k2
        ChgReStartTick = GetSystemTick();
      }
    }
    else
    {
      if((0 != CurrtCheckTick) && ((GetSystemTick() - CurrtCheckTick) > 5000))
      {
        DcOutSet_AB(eSwSta_Off);//k1 k2
        CurrtCheckTick = 0;
        CstMsg.StopReason.Value.Truble = 1;//ֹͣ
        CstMsg.StopTruble.Value.Other = 1;//  
        CstMsg.StopFault.Value.Currt = 1;//ƥ
        ChargeStopType = eChgStop_ComBreak_CurtError;
        pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
        pChargeCtrl->Param = 0;
      }
    }

    if((0 != ChgReStartTick) && ((GetSystemTick() - ChgReStartTick) > 3500))
    {
      pChargeCtrl->CurProcess = eChgPro_AB_ChgRecognize;
      pChargeCtrl->Param = 0;
    }

    if(0 != BstMsg.Valid)
    {
      CstMsg.StopReason.Value.BmsStop = 1;
      ChargeStopType = eChgStop_ComBreak_BmsStop;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgStop;
      pChargeCtrl->Param = 0;
    }
    if(0 == ChargeEnable_AB)
    {//ⲿƽ
      CstMsg.StopReason.Value.Manual = 1;
      ChargeStopType = eChgStop_ComBreak_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_AB())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick))
    {
      DcOutSet_AB(eSwSta_Off);
      CcStatusChkTick = 0;
      ChargeStopType = eChgStop_ComBreak_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Emergency) || (0 != PillarError_B.Value.Emergency))
    {
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_ComBreak_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Door) || (0 != PillarError_B.Value.Door))
    {
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_ComBreak_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Contactor) || (0 != PillarError_B.Value.Contactor))
    {
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_ComBreak_Contactor;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.UniContactor) || (0 != PillarError_B.Value.UniContactor))
    {
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_ComBreak_Contactor;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.InVolt) || (0 != PillarError_B.Value.InVolt))
    {
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_ComBreak_InVolt;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.NoDcmod) || (0 != PillarError_B.Value.NoDcmod))
    {
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_ComBreak_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Meter) || (0 != PillarError_B.Value.Meter))
    {
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_ComBreak_InVolt;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_AB_CommBreak != pChargeCtrl->CurProcess)
      return;
    osDelay(25);
  }
}


