
#include "Thd_Charge.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Drv_Meter.h"
#include "Memory.h"
#include "Drv_ImdJyc.h"

void ChgProShakeHand_AB(StructChargeCtrl *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CHM_SendTick = 0;
  u32 CcStatusChkTick = 0;
  u32 BHM_FirstRecv = 0;

//////Щô????
  PillarError.Value.Insulation = 0;
  PillarError.Value.ImdDev = 0;
  PillarError.Value.DrainResist = 0;

  PillarError_B.Value.Insulation = 0;
  PillarError_B.Value.ImdDev = 0;
  PillarError_B.Value.DrainResist = 0;

  ChargeError.Value.DrainResist = 0;
  ChargeError.Value.IsolateWarn = 0;//Ե
  ChargeError.Value.IsolateError = 0;
  ChargeError.Value.VoltOutError = 0;
  ChargeError.Value.CurrtOutError = 0;

  memset(&BemMsg, 0, sizeof(BemMsg));
  memset(&CemMsg, 0, sizeof(CemMsg));
  memset(&BstMsg, 0, sizeof(BstMsg));
  memset(&CstMsg, 0, sizeof(CstMsg));
  memset(&BsdMsg, 0, sizeof(BsdMsg));
  memset(&CsdMsg, 0, sizeof(CsdMsg));

  CommErrorCount = 0;
  CommErrFrame[0] = 0;
  CommErrFrame[1] = 0;
  CommErrFrame[2] = 0;
  CommErrFrame[3] = 0;

  StartChgEnergy = MeterValue.Energy + MeterValue_B.Energy;
  StopChgEnergy  = MeterValue.Energy + MeterValue_B.Energy;

  ChargeStopType = eChgStop_None;

  BhmMsg.Valid = 0;
  BhmMsg.RecvTick = GetSystemTick();
  BHM_FirstRecv = 0;

  ChargeTimerSet(eSwSta_Off);
  CleanChgTimeCnt();
  BmsPowerSet_AB(eSwSta_On);
  LockSet_AB(eSwSta_On);
  FanSet_AB(eSwSta_On);
  ImdWorkSet_AB(eSwSta_On);
  DrainResistSet_AB(eSwSta_Off);
  DcOutSet_AB(eSwSta_Off);
  DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));

  BmsCanInit();
  osDelay(20);

  CHM_Send();
  CHM_SendTick = GetSystemTick();

  while(1)
  {
    if((0 != CHM_SendTick) && ((GetSystemTick() - CHM_SendTick) > 250))
    {
      CHM_Send();
      CHM_SendTick = GetSystemTick();
    }

    ChgPgnRecv(&PgnRecv);


    if(eChgVer_2011 != UserParam.ChgVer)
    {
      if(0 != BhmMsg.Valid)//¹
      {//ѾյBHMģ
        ChgVer = eChgVer_2015;
        if(0 == BHM_FirstRecv)
          BHM_FirstRecv = GetSystemTick();
        if(0 != ImdValue.Vaild)
        {
          pChargeCtrl->CurProcess = eChgPro_AB_ImdCheck;
          pChargeCtrl->Param = 0;
        }
        else
        {
          if((GetSystemTick() - BHM_FirstRecv) > MsgTimeout_5S)
          {
            ChargeError.Value.IsolateWarn = 1;//Ե
            pChargeCtrl->CurProcess = eChgPro_AB_ChgRecognize;
            pChargeCtrl->Param = 0;
          }
        }
      }
      else if((GetSystemTick() - BhmMsg.RecvTick) > MsgTimeout_5S)
      {//ɹ꣬ȶϿBmsپԵ
        ChgVer = eChgVer_2011;
        BmsPowerSet_AB(eSwSta_Off);
        CHM_SendTick = 0;
        if(0 != ImdValue.Vaild)
        {
          pChargeCtrl->CurProcess = eChgPro_AB_ImdCheck;
          pChargeCtrl->Param = 0;
        }
        else if((GetSystemTick() - BhmMsg.RecvTick) > (MsgTimeout_5S*3/2))
        {
          BmsPowerSet_AB(eSwSta_On);
          pChargeCtrl->CurProcess = eChgPro_AB_ChgRecognize;
          pChargeCtrl->Param = 0;
        }
      }
    }
    else
    {
      if(0 != BhmMsg.Valid)//¹
      {
        ChgVer = eChgVer_2015;
        if(0 == BHM_FirstRecv)
          BHM_FirstRecv = GetSystemTick();
        if((GetSystemTick() - BHM_FirstRecv) > MsgTimeout_5S)
        {
          pChargeCtrl->CurProcess = eChgPro_AB_ChgRecognize;
          pChargeCtrl->Param = 0;
        }
      }
      else if((GetSystemTick() - BhmMsg.RecvTick) > (MsgTimeout_5S/2))
      {//ɹ
        ChgVer = eChgVer_2011;
        pChargeCtrl->CurProcess = eChgPro_AB_ChgRecognizeEx;
        pChargeCtrl->Param = 0;
      }
    }

    if(0 == ChargeEnable_AB)
    {//ⲿƽ
      ChargeStopType = eChgStop_Shake_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_AB())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick * 2))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_AB(eSwSta_Off);
      CcStatusChkTick = 0;
      ChargeStopType = eChgStop_Shake_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Emergency || 0 != PillarError_B.Value.Emergency)
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_Shake_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Door || 0 != PillarError_B.Value.Door )
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_Shake_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Contactor || 0 != PillarError_B.Value.Contactor )
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_Shake_Contactor;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.UniContactor || 0 != PillarError_B.Value.UniContactor )
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_Shake_Contactor;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.InVolt || 0 != PillarError_B.Value.InVolt )
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_Shake_InVolt;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.NoDcmod || 0 != PillarError_B.Value.NoDcmod )
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_Shake_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Meter || 0 != PillarError_B.Value.Meter )
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_AB(eSwSta_Off);
      ChargeStopType = eChgStop_Shake_Meter;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_AB_ShakeHand != pChargeCtrl->CurProcess)
      return;

    osDelay(25);
  }
}

