

#include "Thd_Charge.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Drv_ImdJyc.h"
#include "Memory.h"

void ChgProChgRecognizeEx(StructChargeCtrl *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CRM_SendTick = 0;
  u8  CrmRecog;
  u32 CcStatusChkTick = 0;

//  if(ImdValue.Vaild)
//    ImdWrite(0x0017, 0x0003);

  memset(&BemMsg, 0, sizeof(BemMsg));
  memset(&CemMsg, 0, sizeof(CemMsg));
  memset(&BstMsg, 0, sizeof(BstMsg));
  memset(&CstMsg, 0, sizeof(CstMsg));

  BrmMsg.Valid = 0;
  BemMsg.Valid = 0;
  BmsCanInit();
  osDelay(20);
//  if(ImdValue.Vaild)
//    ImdWrite(0x0017, 0x0003);

  ChargeTimerSet(eSwSta_Off);
  BmsPowerSet(eSwSta_On);
  LockSet(eSwSta_On);
  FanSet(eSwSta_On);
  ImdWorkSet(eSwSta_Off);
  DrainResistSet(eSwSta_Off);
  DcOutSet(eSwSta_Off);
  DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);

  CrmRecog = 0x00;
  CRM_Send(CrmRecog);
  CRM_SendTick = GetSystemTick();
  BrmMsg.RecvTick = GetSystemTick();
  CemMsg.Cem.Value.Brm = 0;

  while(1)
  {
    if((0 != CRM_SendTick) && ((GetSystemTick() - CRM_SendTick) > 250))
    {
      CRM_Send(CrmRecog);
      CRM_SendTick = GetSystemTick();
    }

    ChgPgnRecv(&PgnRecv);

    if(0 != BrmMsg.Valid)
    {//յBrm
      pChargeCtrl->CurProcess = eChgPro_ChgConfigure;
      pChargeCtrl->Param = 0;
    }
    else if((GetSystemTick() - BrmMsg.RecvTick) < (MsgTimeout_5S/2))
    {

    }
    else if((GetSystemTick() - BrmMsg.RecvTick) < (MsgTimeout_10S))
    {
     // BmsPowerSet(eSwSta_Off);
      CRM_SendTick = 0;
    }
    else
    {
      pChargeCtrl->CurProcess = eChgPro_ChgRecognize;
      pChargeCtrl->Param = 0;
    }

    if(0 == TCUCurChgRecd.TCUChargeEnable)
    {//ⲿƽ
      ChargeStopType = eChgStop_Reco_UserCancle;
      pChargeCtrl->CurProcess = eChgPro_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick * 2))
    {
      CcStatusChkTick = 0;
      ChargeStopType = eChgStop_Reco_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Emergency)
    {
      ChargeStopType = eChgStop_Reco_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Door)
    {
      ChargeStopType = eChgStop_Reco_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Contactor)
    {
      ChargeStopType = eChgStop_Reco_Contactor;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.UniContactor)
    {
      ChargeStopType = eChgStop_Reco_Contactor;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.InVolt)
    {
      ChargeStopType = eChgStop_Reco_InVolt;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.NoDcmod)
    {
      ChargeStopType = eChgStop_Reco_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Meter)
    {
      ChargeStopType = eChgStop_Reco_Meter;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_ChgRecognizeEx != pChargeCtrl->CurProcess)
      return;

    osDelay(25);
  }
}


