

#include "Thd_Charge_B.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"


void ChgProChgConfigure_B(StructChargeCtrl_B *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CRM_SendTick = 0;
  u8  CrmRecog;
  u32 CcStatusChkTick = 0;

  BemMsg_B.Valid = 0;
  BcpMsg_B.Valid = 0;
  BmsCanInit_B();
  osDelay(20);

  ChargeTimerSet_B(eSwSta_Off);
  BmsPowerSet_B(eSwSta_On);
  LockSet_B(eSwSta_On);
  FanSet_B(eSwSta_On);
  ImdWorkSet_B(eSwSta_Off);
  DrainResistSet_B(eSwSta_Off);
  DcOutSet_B(eSwSta_Off);
  DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);

  CrmRecog = 0xAA;
  CRM_Send_B(CrmRecog);
  CRM_SendTick = GetSystemTick();
  BcpMsg_B.RecvTick = GetSystemTick();

  while(1)
  {
    if((GetSystemTick() - CRM_SendTick) > 250)
    {
      CRM_Send_B(CrmRecog);
      CRM_SendTick = GetSystemTick();
    }

    ChgPgnRecv_B(&PgnRecv);

    if((GetSystemTick() - BcpMsg_B.RecvTick) > MsgTimeout_B_5S)
    {
      CemMsg_B.Cem.Value.Bcp = 1;
      pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
      pChargeCtrl->Param = 0;
    }
    else
      CemMsg_B.Cem.Value.Bcp = 0;

    if(0 != BcpMsg_B.Valid)
    {//յBrm
///////////////////////////////////////////////////////////////////////////////////////
/*      if(BcpMsg_B.StartSoc > 980)
      {
        ChargeStopType_B = eChgStop_Conf_StartSoc98;
        pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
        pChargeCtrl->Param = 0;
      }
      else */
      if(BcpMsg_B.StartVolt > BcpMsg_B.ChgMaxVolt)
      {
        CstMsg_B.StopReason.Value.Truble = 1;
        CstMsg_B.StopTruble.Value.Other = 1;
        CstMsg_B.StopFault.Value.Volt = 1;
        ChargeStopType_B = eChgStop_Conf_BatVoltOverPermitMax;
        pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
        pChargeCtrl->Param = 0;
      }
      else if(BcpMsg_B.StartVolt > DcModuleAbility.MaxVolt)
      {
        CstMsg_B.StopReason.Value.Truble = 1;
        CstMsg_B.StopTruble.Value.Other = 1;
        CstMsg_B.StopFault.Value.Volt = 1;
        ChargeStopType_B = eChgStop_Conf_StartVoltOverPillarMax;
        pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
        pChargeCtrl->Param = 0;
      }
      else if(DcModuleAbility.MinVolt > BcpMsg_B.ChgMaxVolt)
      {
        CstMsg_B.StopReason.Value.Truble = 1;
        CstMsg_B.StopTruble.Value.Other = 1;
        CstMsg_B.StopFault.Value.Volt = 1;
        ChargeStopType_B = eChgStop_Conf_ChgMaxVoltLessPillarMinVolt;
        pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
        pChargeCtrl->Param = 0;
      }
//////////////////////////////////////////////////////////////////////////////////////
      else
      {
        pChargeCtrl->CurProcess = eChgPro_B_WaitBmsReady;
        pChargeCtrl->Param = 0;
      }
    }

    if(0 != BemMsg_B.Valid)
    {
      pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
      pChargeCtrl->Param = 0;
    }

    if(0 == TCUCurChgRecd_B.TCUChargeEnable)
    {//ⲿƽ
      ChargeStopType_B = eChgStop_Conf_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_B())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick_B * 2))
    {
      CcStatusChkTick = 0;
      ChargeStopType_B = eChgStop_Conf_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Emergency)
    {
      ChargeStopType_B = eChgStop_Conf_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Door)
    {
      ChargeStopType_B = eChgStop_Conf_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Contactor)
    {
      ChargeStopType_B = eChgStop_Conf_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.UniContactor)
    {
      ChargeStopType_B = eChgStop_Conf_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.InVolt)
    {
      ChargeStopType_B = eChgStop_Conf_InVolt;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.NoDcmod)
    {
      ChargeStopType_B = eChgStop_Conf_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Meter)
    {
      ChargeStopType_B = eChgStop_Conf_Meter;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_B_ChgConfigure != pChargeCtrl->CurProcess)
      return;
    osDelay(25);
  }
}

