

#include "Thd_Charge_B.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Memory.h"

void ChgProChgIdle_B(StructChargeCtrl_B *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CcStatusChkTick = 0;

  ChargeError_B.Value.DrainResist = 0;
  ChargeError_B.Value.IsolateWarn = 0;//Ե
  ChargeError_B.Value.IsolateError = 0;
  ChargeError_B.Value.VoltOutError = 0;
  ChargeError_B.Value.CurrtOutError = 0;

  ChargeTimerSet_B(eSwSta_Off);
  CleanChgTimeCnt_B();
  BmsPowerSet_B(eSwSta_Off);
  LockSet_B(eSwSta_Off);
  FanSet_B(eSwSta_Off);
  //ɫԵģoff--ɫon
  ImdWorkSet_B(eSwSta_Off);
  DrainResistSet_B(eSwSta_Off);
  DcOutSet_B(eSwSta_Off);
  DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);

  BmsCanInit_B();
  osDelay(20);

  while(1)
  {
    if(0 == UserParam.ChgFun.Value.Num_B)
    {
      osDelay(1000);
      continue;
    }

    ChgPgnRecv_B(&PgnRecv);

    if(eSwSta_On == CcStatusRead_B())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;

    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > 1500))
    {
      CcStatusChkTick = 0;
      if(0 != TCUCurChgRecd_B.TCUChargeEnable)
      {
        pChargeCtrl->CurProcess = eChgPro_B_ShakeHand;
        pChargeCtrl->Param = 0;
      }
    }

    if(
        (0 != PillarError_B.Value.Emergency)
        || (0 != PillarError_B.Value.NoDcmod)
        || (0 != PillarError_B.Value.Meter)
        || (0 != PillarError_B.Value.Memory)
        || (0 != PillarError_B.Value.Lcd)
        || (0 != PillarError_B.Value.Door)
        || (0 != PillarError_B.Value.Contactor)
        || (0 != PillarError_B.Value.UniContactor)
        || (0 != PillarError_B.Value.InVolt)
      )
    {
      pChargeCtrl->CurProcess = eChgPro_B_ChgIdle;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_B_ChgIdle != pChargeCtrl->CurProcess)
      return;

    osDelay(100);
  }
}

