
#include "Thd_Charge_B.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"


void ChgProCommBeak_B(StructChargeCtrl_B *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CEM_SendTick = 0;
  u32 CurrtCheckTick = 0;
  u32 ChgReStartTick = 0;
  u32 CcStatusChkTick = 0;

  if(0 == CommErrorCount_B)
  {
    CommErrFrame_B[0] = BemMsg_B.Bem.Mult;
    CommErrFrame_B[1] = CemMsg_B.Cem.Mult;
  }
  else if(1 == CommErrorCount_B)
  {
    CommErrFrame_B[2] = BemMsg_B.Bem.Mult;
    CommErrFrame_B[3] = CemMsg_B.Cem.Mult;
  }

  CommErrorCount_B++;
  if(CommErrorCount_B > 2)
  {
    CstMsg_B.StopReason.Value.Truble = 1;//ֹͣ
    CstMsg_B.StopTruble.Value.Other = 1;//  ͨųʱ
    ChargeStopType_B = eChgStop_ComBreak_CommError;
    pChargeCtrl->CurProcess = eChgPro_B_CommError;
    pChargeCtrl->Param = 0;
    return;
  }

  BstMsg_B.Valid = 0;
  BmsCanInit_B();
  osDelay(20);

  ChargeTimerSet_B(eSwSta_Off);
  BmsPowerSet_B(eSwSta_On);
  LockSet_B(eSwSta_On);
  FanSet_B(eSwSta_On);
  ImdWorkSet_B(eSwSta_Off);
  DrainResistSet_B(eSwSta_Off);
  //DcOutSet_B(eSwSta_On);
  DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);

  if(0 != CemMsg_B.Cem.Mult)
    CEM_Send_B(&CemMsg_B);
  CEM_SendTick = GetSystemTick();

  CurrtCheckTick = GetSystemTick();
  ChgReStartTick = 0;

  while(1)
  {
    if((0 != CEM_SendTick) && ((GetSystemTick() - CEM_SendTick) > 250))
    {
      if(0 != CemMsg_B.Cem.Mult)//ͨŹ
        CEM_Send_B(&CemMsg_B);
      CEM_SendTick = GetSystemTick();
    }

    ChgPgnRecv_B(&PgnRecv);

    if(GetDcModuleCurrt_B() < 50)//С5A
    {
      CurrtCheckTick = 0;
      if(0 == ChgReStartTick)
      {
        DcOutSet_B(eSwSta_Off);//k1 k2
        ChgReStartTick = GetSystemTick();
      }
    }
    else
    {
      if((0 != CurrtCheckTick) && ((GetSystemTick() - CurrtCheckTick) > 5000))
      {
        DcOutSet_B(eSwSta_Off);//k1 k2
        CurrtCheckTick = 0;
        CstMsg_B.StopReason.Value.Truble = 1;//ֹͣ
        CstMsg_B.StopTruble.Value.Other = 1;//  
        CstMsg_B.StopFault.Value.Currt = 1;//ƥ
        ChargeStopType_B = eChgStop_ComBreak_CurtError;
        pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
        pChargeCtrl->Param = 0;
      }
    }

    if((0 != ChgReStartTick) && ((GetSystemTick() - ChgReStartTick) > 3500))
    {
      pChargeCtrl->CurProcess = eChgPro_B_ChgRecognize;
      pChargeCtrl->Param = 0;
    }

    if(0 != BstMsg_B.Valid)
    {
      CstMsg_B.StopReason.Value.BmsStop = 1;
      ChargeStopType_B = eChgStop_ComBreak_BmsStop;
      pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
      pChargeCtrl->Param = 0;
    }
    if(0 == TCUCurChgRecd_B.TCUChargeEnable)
    {//ⲿƽ
      CstMsg_B.StopReason.Value.Manual = 1;
      ChargeStopType_B = eChgStop_ComBreak_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_B())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick_B))
    {
      DcOutSet_B(eSwSta_Off);
      CcStatusChkTick = 0;
      ChargeStopType_B = eChgStop_ComBreak_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Emergency)
    {
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_ComBreak_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Door)
    {
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_ComBreak_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Contactor)
    {
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_ComBreak_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.UniContactor)
    {
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_ComBreak_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.InVolt)
    {
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_ComBreak_InVolt;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.NoDcmod)
    {
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_ComBreak_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Meter)
    {
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_ComBreak_Meter;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_B_CommBreak != pChargeCtrl->CurProcess)
      return;
    osDelay(25);
  }
}


