
#include "Thd_Lcd.h"


#define ScrnCnctDetect_AB          ((u16)7)  //Aǹ  ״̬

#define BtnCnctDetect_AB_Cancle     ((u16)0x0701)
#define DataCnctDetect_AB_Counter   ((u16)0x0002)

#define TxtCnctDetect_AB_CardNum    ((u16)0x4020)
#define VarCnctDetect_AB_CardMoney  ((u16)0x0003)

#define VarCnctDetect_AB_Position   ((u16)0x003C)
void CnctDetectPaint_AB(void)
{
  char Str[64];
  LcdShowData16(VarCnctDetect_AB_Position, 3);


  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", pCurChgRecd_AB->CardNum[0],pCurChgRecd_AB->CardNum[1],
    pCurChgRecd_AB->CardNum[2], pCurChgRecd_AB->CardNum[3], pCurChgRecd_AB->CardNum[4], pCurChgRecd_AB->CardNum[5],
    pCurChgRecd_AB->CardNum[6], pCurChgRecd_AB->CardNum[7], pCurChgRecd_AB->CardNum[8], pCurChgRecd_AB->CardNum[9]);
  LcdShowStr(TxtCnctDetect_AB_CardNum, (u8*)Str, strlen(Str)+1);

  LcdShowData32(VarCnctDetect_AB_CardMoney, pCurChgRecd_AB->CardRespMoney);

  LcdShowNum(DataCnctDetect_AB_Counter, 60);
  LcdShowPage(ScrnCnctDetect_AB);
}

void CnctDetectIdle_AB(void)
{

}

#define CnnctTime   (2*1000)//2

void LcdProCnctDetect_AB(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u8 Time = 0,i,j;
  u32 CcStatusChkTick = 0;

  pCurChgRecd_AB = &CurChgRecd;

  TimeOutTick = 610;//1810*100ms = 180;
  CnctDetectPaint_AB();

  while(1)
  {
    if(TimeOutTick > 0)
      TimeOutTick--;

    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnCnctDetect_AB_Cancle:    //"·ذ"
                pLcdCtrl->CurScreen = eLcdPro_MainMenu;
                //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnCnctDetect_AB);
                break;
            }
          }
          else
            LcdShowPage(ScrnCnctDetect_AB);
          break;

        default:
          break;
      }
    }

    if(eSwSta_On == CcStatusRead_AB())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CnnctTime))
    {
      CcStatusChkTick = 0;
      if((0x88 == pCurChgRecd_AB->CardNum[0]) && (0x80 == (pCurChgRecd_AB->CardNum[1] & 0x80))
      && (0 != UserParam.LockCard))
      {
        pLcdCtrl->CurScreen = eLcdPro_AB_LockCard;
        pLcdCtrl->Param = 0;
      }
      else
      {
        for(i=0;i<3;i++)
        {
         LockSet_AB(eSwSta_On);
         osDelay(500);
         for(j=0;j<10;j++)
         {
          if(1 == UserParam.ChgFun.Value.EleLock)
            if(LockGet_AB()!=eSwSta_On) break;
          osDelay(10);
         }
          if(j>=10) break;
          LockSet_AB(eSwSta_Off);
          osDelay(500);
        }
        if(i>=3)
        {
          pLcdCtrl->CurScreen = eLcdPro_AB_ElectLock;
          pLcdCtrl->Param = 0;
        }
        else
        {
         pLcdCtrl->CurScreen = eLcdPro_AB_BuildComm;
         pLcdCtrl->Param = 0;
        }
      }
    }

    if(eLcdPro_AB_CnctDetect != pLcdCtrl->CurScreen)
      return;

    if((TimeOutTick) < 1)
    {
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
//      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    Temp = TimeOutTick/10;
    if(Time != Temp)
    {
      Time = Temp;
      LcdShowNum(DataCnctDetect_AB_Counter, Time);
    }

    CnctDetectIdle_AB();

    osDelay(100);
  }
}








