

#include "Thd_Lcd.h"

#define ScrnLockCard_AB      ((u16)8) //Aǹˢ

#define BtnLockCard_AB_Cancle     ((u16)0x0801)
#define TextLockCard_AB_Tip       ((u16)0x4000)

#define TextLockCard_AB_CardNum   ((u16)0x4020)
#define DataLockCard_AB_CardMoney ((u16)0x0003)

#define DataLockCard_AB_Counter      ((u16)0x0002)

#define VarLockCard_AB_Position    ((u16)0x003C)
void LockCardPaint_AB(void)
{
  char Str[64] = {0};
  LcdShowData16(VarLockCard_AB_Position, 3);

  LcdShowNum(DataLockCard_AB_Counter, 15);

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", CardData.CardNum[0],CardData.CardNum[1],
    CardData.CardNum[2], CardData.CardNum[3], CardData.CardNum[4], CardData.CardNum[5],
    CardData.CardNum[6], CardData.CardNum[7], CardData.CardNum[8], CardData.CardNum[9]);
  LcdShowStr(TextLockCard_AB_CardNum, (u8*)Str, strlen(Str)+1);

  LcdShowData32(DataLockCard_AB_CardMoney, CardData.CardMoney);

  snprintf(Str, sizeof(Str), "磬ˢ");
  LcdShowStr(TextLockCard_AB_Tip, (u8*)Str, strlen(Str)+1);
  LcdShowPage(ScrnLockCard_AB);
}

void LockCardIdle_AB(void)
{

}

#define GetCardTime   (2*1000)
#define TimeOutTime   (40*1000)

void LcdProLockCard_AB(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  EnumCardError CardRtn;
  u32 GetCardTick;
  u32 TimeOutTick;
  char Str[64] = {0};

  u8 Time = 0;

  pCurChgRecd_AB = &CurChgRecd;

  GetCardTick = GetSystemTick();
  TimeOutTick = 255;
  LockCardPaint_AB();

  while(1)
  {
    if(TimeOutTick > 0)
      TimeOutTick--;

    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnLockCard_AB_Cancle:  //A ǹ"" 
                pLcdCtrl->CurScreen = eLcdPro_MainMenu;
//                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnLockCard_AB);
                break;
            }
          }
          break;

        default:
          break;
      }
    }
    if((GetSystemTick() - GetCardTick) > GetCardTime)
    {
      CardRtn = ReaderLockCard(&CardData);
      switch(CardRtn)
      {
        case eCardErr_CheckId_0:                 //
        case eCardErr_ReadCardNum:
        case eCardErr_CheckId_1:
        case eCardErr_ReadValue:
        case eCardErr_ValueDec:
        case eCardErr_CheckId_2:
          GetCardTick = GetSystemTick();
          snprintf(Str, sizeof(Str), "ˢʧܣˢ");
          LcdShowStr(TextLockCard_AB_Tip, (u8*)Str, strlen(Str)+1);
          BuzzerRun(2, 80, 80);
          break;

        case eCardErr_Ok:                      //Ƭ֤OK
          GetCardTick = GetSystemTick();
          memset(pCurChgRecd_AB, 0, sizeof(StructChgRecd));
          memcpy(pCurChgRecd_AB->CardNum, CardData.CardNum, 16);
          memcpy(pCurChgRecd_AB->CardPwd, CardData.CardPwd, 6);
          pCurChgRecd_AB->CardRespMoney = CardData.CardMoney;
          pCurChgRecd_AB->StartCardMoney = CardData.CardMoney;
          pCurChgRecd_AB->StopCardMoney = CardData.CardMoney;
          pCurChgRecd_AB->CardValidFlag = 1;
          BuzzerRun(1, 80, 80);

          pLcdCtrl->CurScreen = eLcdPro_AB_BuildComm;
          pLcdCtrl->Param = 0;
          break;
        case eCardErr_CardNumDiffer:
          GetCardTick = GetSystemTick();
          snprintf(Str, sizeof(Str), "Ųһ£ˢ");
          LcdShowStr(TextLockCard_AB_Tip, (u8*)Str, strlen(Str)+1);
          BuzzerRun(2, 80, 80);
          break;
        default:
          break;
      }
    }

    if(eLcdPro_AB_LockCard != pLcdCtrl->CurScreen)
      return;

    if((TimeOutTick) < 1)
    {
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
//      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    Temp = TimeOutTick/10;
    if(Time != Temp)
    {
      Time = Temp;
      LcdShowNum(DataLockCard_AB_Counter, Time);
    }

    LockCardIdle_AB();

    osDelay(100);
  }
}



