
#include "Thd_Lcd.h"

#define ScrnSwipeCard_AB               ((u16)12) //Aǹˢ

#define BtnSwipeCard_AB_Cancel         ((u16)0x1201)
#define BtnSwipeCard_Enter             ((u16)0x1202)


#define TextSwipeCard_AB_CardNum       ((u16)0x4020)

#define DataSwipeCard_AB_ChgMin        ((u16)0x0006)
#define DataSwipeCard_AB_ChgEnergy     ((u16)0x0005)
#define DataSwipeCard_AB_Soc           ((u16)0x0023)

#define DataSwipeCard_AB_EmployMoney   ((u16)0x002F)
#define DataSwipeCard_AB_EnergyMoney   ((u16)0x0010)
#define DataSwipeCard_AB_ServeMoney    ((u16)0x000F)
#define DataSwipeCard_AB_TotalMoney    ((u16)0x0007)

#define TextSwipeCard_AB_Tip           ((u16)0x4000)

#define InputSwipeCard_AB_Pwd      ((u16)0x3008)

#define VarSwipeCard_AB_Position   ((u16)0x003C)
void SwipeCardPaint_AB(void)
{
  char Str[64];
  u16 TempU16;

  LcdShowData16(VarSwipeCard_AB_Position, 3);

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", pCurChgRecd_AB->CardNum[0],pCurChgRecd_AB->CardNum[1],
            pCurChgRecd_AB->CardNum[2], pCurChgRecd_AB->CardNum[3], pCurChgRecd_AB->CardNum[4], pCurChgRecd_AB->CardNum[5],
            pCurChgRecd_AB->CardNum[6], pCurChgRecd_AB->CardNum[7], pCurChgRecd_AB->CardNum[8], pCurChgRecd_AB->CardNum[9]);
  LcdShowStr(TextSwipeCard_AB_CardNum, (u8*)&Str[0], 20);

  TempU16 = pCurChgRecd_AB->ChgTime/60;//GetChgMin();
  LcdShowData16(DataSwipeCard_AB_ChgMin, TempU16);
  TempU16 = pCurChgRecd_AB->ChgEnergy/10;
  LcdShowData16(DataSwipeCard_AB_ChgEnergy, TempU16);
  TempU16 = BcsMsg.CurSoc;
  LcdShowData16(DataSwipeCard_AB_Soc, TempU16);

  LcdShowData16(DataSwipeCard_AB_EmployMoney, pCurChgRecd_AB->EmployMoney);
  LcdShowData16(DataSwipeCard_AB_EnergyMoney, pCurChgRecd_AB->EnergyMoney);
  LcdShowData16(DataSwipeCard_AB_ServeMoney, pCurChgRecd_AB->ServeMoney);
  LcdShowData16(DataSwipeCard_AB_TotalMoney, pCurChgRecd_AB->TotalMoney);

  snprintf(Str, sizeof(Str), "ˢ㡣");
  LcdShowStr(TextSwipeCard_AB_Tip, (u8*)Str, (strlen(Str)+1));

  LcdShowPage(ScrnSwipeCard_AB);
}

void SwipeCardIdle_AB(void)
{

}

extern void CloseKeyBoard(void);

#define GetCardTime   (2*1000)     //ȴˢʱ
#define TimeOutTime   (15*1000)    //15S  ˢ

void LcdProSwipeCard_AB(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  EnumCardError CardRtn;
  u32 GetCardTick;
  u32 TimeOutTick;
  u32 ScreenChkTick;

  char Str[64];

  StructCardData CardDataTemp = {0};

  pCurChgRecd_AB = &CurChgRecd;

  ChargePauseFlag = 1;

  //IdleLedSet(eSwSta_Off);

  //ChgLedSet(eSwSta_On);

  GetCardTick = GetSystemTick();
  TimeOutTick = GetSystemTick();
  SwipeCardPaint_AB();//лҳ

  ScreenChkTick = GetSystemTick();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnSwipeCard_AB != Temp)
              LcdShowPage(ScrnSwipeCard_AB);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSwipeCard_AB_Cancel:   //Aǹ簴ť  ذť
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_AB_ChargeScreen;
                //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_AB_ChargeSummary);
                pLcdCtrl->Param = 0;
                break;
            case BtnSwipeCard_Enter:
             pCurChgRecd_AB->ChgStopType = 1;//ûֹͣ
             ChargeEnable_AB = 0;
             pLcdCtrl->CurScreen = eLcdPro_AB_PutBack;
             pLcdCtrl->Param = 0;
             break;
              default:
                LcdShowPage(ScrnSwipeCard_AB);
                break;
            }
          }
          else if(InputSwipeCard_AB_Pwd == Temp)
          {
            /*if((Frame.Ctrl.RdVar.Len < 4) || ((4 == Frame.Ctrl.RdVar.Len) &&  (00 == Frame.Ctrl.RdVar.Data[7])))
            {
            }
            else*/
            {
              /*snprintf(Str, sizeof(Str), "%02X%02X", pCurChgRecd_AB->CardNum[0], pCurChgRecd_AB->CardNum[1]);
              snprintf(&Str[4], sizeof(Str)-3, "%02X%02X", pCurChgRecd_AB->CardNum[8], pCurChgRecd_AB->CardNum[9]);
              Str[3] = Str[5];
              Str[4] = Str[6];
              Str[6] = Str[7];*/
              if(0 == (memcmp("848", Frame.Ctrl.RdVar.Data, 3)))
              {
                GetCardTick = GetSystemTick();
                TimeOutTick = GetSystemTick();

                if(0 == pCurChgRecd_AB->ChgStopType)
                  pCurChgRecd_AB->ChgStopType = 1;//9;//Աֹͣ	Աֹͣ磬	9

                pLcdCtrl->CurScreen = eLcdPro_AB_PutBack;
                //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_AB_PutBack);

                pLcdCtrl->Param = 0;
              }
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - GetCardTick) > GetCardTime)  //ѯƬ״̬
    {
      if((0x88 == pCurChgRecd_AB->CardNum[0]) && (0x80 == (pCurChgRecd_AB->CardNum[1] & 0x80)))
      {
        CardRtn = ReaderMoneyDec(pCurChgRecd_AB);
        switch(CardRtn)
        {
          case eCardErr_CheckId_0:
          case eCardErr_ReadCardNum:
          case eCardErr_CheckId_1:
          case eCardErr_ReadValue:
          case eCardErr_ValueDec:
          case eCardErr_CheckId_2:
            GetCardTick = GetSystemTick();
            TimeOutTick = GetSystemTick();
            snprintf(Str, sizeof(Str), "ˢʧܣԡ");
            LcdShowStr(TextSwipeCard_AB_Tip, (u8*)Str, (strlen(Str)+1));
            BuzzerRun(2, 80, 80);
            break;
          case eCardErr_CardNumDiffer:
            GetCardTick = GetSystemTick();
            TimeOutTick = GetSystemTick();
            BuzzerRun(2, 80, 80);
            snprintf(Str, sizeof(Str), "Ųһ£ԡ");
            LcdShowStr(TextSwipeCard_AB_Tip, (u8*)Str, (strlen(Str)+1));
            break;

          case eCardErr_WriteStatus:
          case eCardErr_Ok:
            GetCardTick = GetSystemTick();
            TimeOutTick = GetSystemTick();
            if(eCardErr_Ok == CardRtn)
              BuzzerRun(1, 80, 80);
            else
              BuzzerRun(3, 80, 80);

            if(0 == pCurChgRecd_AB->ChgStopType)
              pCurChgRecd_AB->ChgStopType = 1;//ûֹͣ	ûͨˢֶֹͣѡֹͣ	1

            pCurChgRecd_AB->MoneyDecFlag = 1;//½

            pCurChgRecd_AB->WipeStopTime = RtcGetTime();

            pLcdCtrl->CurScreen = eLcdPro_AB_PutBack;
            //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_AB_PutBack);
            pLcdCtrl->Param = 0;
            break;
          default:
            break;
        }
      }
      else
      {
        CardRtn = ReaderGetCard(&CardDataTemp);
        switch(CardRtn)
        {
          case eCardErr_CheckId_0:
          case eCardErr_ReadCardNum:
          case eCardErr_CheckId_1:
          case eCardErr_ReadValue:
          case eCardErr_ValueDec:
          case eCardErr_CheckId_2:
            GetCardTick = GetSystemTick();
            TimeOutTick = GetSystemTick();
            snprintf(Str, sizeof(Str), "ˢʧܣԡ");
            LcdShowStr(TextSwipeCard_AB_Tip, (u8*)Str, (strlen(Str)+1));
            BuzzerRun(2, 80, 80);
            break;
          case eCardErr_CardNumDiffer:
            GetCardTick = GetSystemTick();
            TimeOutTick = GetSystemTick();
            snprintf(Str, sizeof(Str), "Ųһ£ԡ");
            LcdShowStr(TextSwipeCard_AB_Tip, (u8*)Str, (strlen(Str)+1));
            BuzzerRun(2, 80, 80);
            break;

          //case eCardErr_WriteStatus:
          case eCardErr_Ok:                       //Ƭȷ
            GetCardTick = GetSystemTick();
            TimeOutTick = GetSystemTick();
            if(0 != memcmp(pCurChgRecd_AB->CardNum, CardDataTemp.CardNum, 10))
            {
              snprintf(Str, sizeof(Str), "Ųһ£ԡ");
              LcdShowStr(TextSwipeCard_AB_Tip, (u8*)Str, (strlen(Str)+1));
              BuzzerRun(2, 80, 80);
            }
            else
            {
              BuzzerRun(1, 80, 80);

              if(0 == pCurChgRecd_AB->ChgStopType)
                pCurChgRecd_AB->ChgStopType = 1;//ûֹͣ	ûͨˢֶֹͣѡֹͣ	1

              pCurChgRecd_AB->WipeStopTime = RtcGetTime();

              pLcdCtrl->CurScreen = eLcdPro_AB_PutBack;
              //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_AB_PutBack);
              pLcdCtrl->Param = 0;
            }
            break;
          default:
            break;
        }
      }
    }

    if(eLcdPro_AB_SwipeCard != pLcdCtrl->CurScreen)
    {
      ChargePauseFlag = 0;
      return;
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_AB_ChargeScreen;
      //pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_AB_ChargeSummary);
      pLcdCtrl->Param = 0;
    }

    SwipeCardIdle_AB();

    osDelay(200);
  }
}




