
#include "Thd_Lcd.h"
#include "Drv_LcdDwin.h"

#define ScrnFactoryTestTwo_B  ((u16)59)
#define BtnFactoryTestTwo_B_Cancel        ((u16)0x5901)

#define BtnFactoryTestTwo_B_Next        ((u16)0x000B)
#define BtnFactoryTestTwo_B_Last        ((u16)0x000A)

#define BtnFactoryTestTwoAddr_B_IdeLed  ((u16)0x0147)
#define BtnFactoryTestTwoValue_B_IdeLedOff ((u16)0x0000)
#define BtnFactoryTestTwo_B_IdeLedOff      ((u32)BtnFactoryTestTwoAddr_B_IdeLed*65536+BtnFactoryTestTwoValue_B_IdeLedOff)
#define BtnFactoryTestTwoValue_B_IdeLedOn  ((u16)0x0001)
#define BtnFactoryTestTwo_IdeLedOn       ((u32)BtnFactoryTestTwoAddr_B_IdeLed*65536+BtnFactoryTestTwoValue_B_IdeLedOn)

#define BtnFactoryTestTwoAddr_B_DcOutNeg  ((u16)0x0149)
#define BtnFactoryTestTwoValue_B_DcOutNegOff ((u16)0x0000)
#define BtnFactoryTestTwo_B_DcOutNegOff      ((u32)BtnFactoryTestTwoAddr_B_DcOutNeg*65536+BtnFactoryTestTwoValue_B_DcOutNegOff)
#define BtnFactoryTestTwoValue_B_DcOutNegOn  ((u16)0x0001)
#define BtnFactoryTestTwo_B_DcOutNegOn       ((u32)BtnFactoryTestTwoAddr_B_DcOutNeg*65536+BtnFactoryTestTwoValue_B_DcOutNegOn)

#define BtnFactoryTestTwoAddr_B_eLock  ((u16)0x013F)
#define BtnFactoryTestTwoValue_B_eLockOff ((u16)0x0000)
#define BtnFactoryTestTwo_B_eLockOff      ((u32)BtnFactoryTestTwoAddr_B_eLock*65536+BtnFactoryTestTwoValue_B_eLockOff)
#define BtnFactoryTestTwoValue_B_eLockOn  ((u16)0x0001)
#define BtnFactoryTestTwo_B_eLockOn       ((u32)BtnFactoryTestTwoAddr_B_eLock*65536+BtnFactoryTestTwoValue_B_eLockOn)

#define BtnFactoryTestTwoAddr_Uni_DcOutPos  ((u16)0x0170)
#define BtnFactoryTestTwoValue_Uni_DcOutPosOff ((u16)0x0000)
#define BtnFactoryTestTwo_Uni_DcOutPosOff      ((u32)BtnFactoryTestTwoAddr_Uni_DcOutPos*65536+BtnFactoryTestTwoValue_Uni_DcOutPosOff)
#define BtnFactoryTestTwoValue_Uni_DcOutPosOn  ((u16)0x0001)
#define BtnFactoryTestTwo_Uni_DcOutPosOn       ((u32)BtnFactoryTestTwoAddr_Uni_DcOutPos*65536+BtnFactoryTestTwoValue_Uni_DcOutPosOn)

#define BtnFactoryTestTwoAddr_Uni_DcOutNeg  ((u16)0x0172)
#define BtnFactoryTestTwoValue_Uni_DcOutNegOff ((u16)0x0000)
#define BtnFactoryTestTwo_Uni_DcOutNegOff      ((u32)BtnFactoryTestTwoAddr_Uni_DcOutNeg*65536+BtnFactoryTestTwoValue_Uni_DcOutNegOff)
#define BtnFactoryTestTwoValue_Uni_DcOutNegOn  ((u16)0x0001)
#define BtnFactoryTestTwo_Uni_DcOutNegOn       ((u32)BtnFactoryTestTwoAddr_Uni_DcOutNeg*65536+BtnFactoryTestTwoValue_Uni_DcOutNegOn)



#define IconFactoryTestTwoAddr_B_DoorSta  ((u16)0x0148)
#define IconFactoryTestTwoAddr_B_DcOutNegSta   ((u16)0x014A)
#define IconFactoryTestTwoAddr_B_eLockSta   ((u16)0x0162)
#define IconFactoryTestTwoAddr_Uni_DcOutPosSta   ((u16)0x0171)
#define IconFactoryTestTwoAddr_Uni_DcOutNegSta   ((u16)0x0173)


#define TextFactoryTestTwoAddr           ((u16)0x4000)


void FactoryTestTwoPaint_B(void)
{
  //char Str[64] = {0};
  u16 TempU16;

  LcdShowData16(BtnFactoryTestTwoAddr_B_IdeLed, 0);
  LcdShowData16(BtnFactoryTestTwoAddr_B_DcOutNeg, 0);
  LcdShowData16(BtnFactoryTestTwoAddr_B_eLock, 0);
  LcdShowData16(BtnFactoryTestTwoAddr_Uni_DcOutPos, 0);
  LcdShowData16(BtnFactoryTestTwoAddr_Uni_DcOutNeg, 0);

  if(eSwSta_Off == DoorChkGet())
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestTwoAddr_B_DoorSta, TempU16);

  if(eSwSta_On == DcOutNegGet_B())
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestTwoAddr_B_DcOutNegSta, TempU16);

  if(eSwSta_On == LockGet_B())
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestTwoAddr_B_eLockSta, TempU16);

  if(eSwSta_On == DcOutPosGet_Uni())
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestTwoAddr_Uni_DcOutPosSta, TempU16);

  if(eSwSta_On == DcOutNegGet_Uni())
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestTwoAddr_Uni_DcOutNegSta, TempU16);

  /*snprintf(Str, sizeof(Str), "/¶:%04f/%04f/tʪ:%04f",
    Adc_GetNtcTemp()/100,Dht12Data.Dht12Temp/100,Dht12Data.Dht12Humity/100);
  LcdShowStr(TextFactoryTestTwoAddr, (u8*)Str, strlen(Str)+1);
  LcdShowData16(VarFactoryTestTwo_EnviTemp, Adc_GetNtcTemp());
  LcdShowData16(VarFactoryTestTwo_Humi, Dht12_GetHumi());
  LcdShowData16(VarFactoryTestTwo_Temp, Dht12_GetTemp());*/


  LcdShowPage(ScrnFactoryTestTwo_B);
}

typedef struct
{
  u32 RePaintTick;
}StructFactoryTestTwoUpdate;

void FactoryTestTwoUpdate_B(StructFactoryTestTwoUpdate *pUpdate)
{
  //char Str[64] = {0};
  u16 TempU16;

  if((GetSystemTick() - pUpdate->RePaintTick) >= 1000)
  {
    pUpdate->RePaintTick = GetSystemTick();
    if(eSwSta_Off == DoorChkGet())
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestTwoAddr_B_DoorSta, TempU16);

    if(eSwSta_On == DcOutNegGet_B())
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestTwoAddr_B_DcOutNegSta, TempU16);

    if(eSwSta_On == LockGet_B())
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestTwoAddr_B_eLockSta, TempU16);

    if(eSwSta_On == DcOutPosGet_Uni())
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestTwoAddr_Uni_DcOutPosSta, TempU16);

    if(eSwSta_On == DcOutNegGet_Uni())
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestTwoAddr_Uni_DcOutNegSta, TempU16);


    /*snprintf(Str, sizeof(Str), "/¶:%04f/%04f/tʪ:%04f",
      Adc_GetNtcTemp()/100,Dht12Data.Dht12Temp/100,Dht12Data.Dht12Humity/100);
    LcdShowStr(TextFactoryTestTwoAddr, (u8*)Str, strlen(Str)+1);
    LcdShowData16(VarFactoryTestTwo_EnviTemp, Adc_GetNtcTemp());
    LcdShowData16(VarFactoryTestTwo_Humi, Dht12_GetHumi());
    LcdShowData16(VarFactoryTestTwo_Temp, Dht12_GetTemp());*/

  }
}

void LcdProFactoryTestTwo_B(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 KeyValue;
  StructFactoryTestTwoUpdate Update;

  IdleLedSet_B(eSwSta_Off);
  DcOutNegSet_B(eSwSta_Off);
  DrainResistSet_B(eSwSta_Off);
  LockSet_B(eSwSta_Off);

  ScreenChkTick = GetSystemTick();
  Update.RePaintTick = GetSystemTick();
  FactoryTestTwoPaint_B();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            KeyValue = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnFactoryTestTwo_B != KeyValue)
              LcdShowPage(ScrnFactoryTestTwo_B);
          }
          break;
        case eLcdCmd_RdVar:
          KeyValue  = Frame.Ctrl.RdVar.AddrH << 24;
          KeyValue += Frame.Ctrl.RdVar.AddrL << 16;
          KeyValue += Frame.Ctrl.RdVar.Data[0] << 8;
          KeyValue += Frame.Ctrl.RdVar.Data[1];
          switch(KeyValue)
          {
            case BtnFactoryTestTwo_B_Cancel:
              pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
              pLcdCtrl->Param = 0;
              break;

            case BtnFactoryTestTwo_B_Next:
              pLcdCtrl->CurScreen = eLcdPro_B_FactoryChgSet;
              pLcdCtrl->Param = 0;
              break;
            case BtnFactoryTestTwo_B_Last:
              pLcdCtrl->CurScreen = eLcdPro_B_FactoryTest;
              pLcdCtrl->Param = 0;
              break;

            case BtnFactoryTestTwo_B_IdeLedOff:
              IdleLedSet_B(eSwSta_Off);
              break;
            case BtnFactoryTestTwo_IdeLedOn:
              IdleLedSet_B(eSwSta_On);
              break;
            case BtnFactoryTestTwo_B_DcOutNegOff:
              DcOutNegSet_B(eSwSta_Off);
              break;
            case BtnFactoryTestTwo_B_DcOutNegOn:
              DcOutNegSet_B(eSwSta_On);
              break;
            case BtnFactoryTestTwo_B_eLockOff:
              LockSet_B(eSwSta_Off);
              break;
            case BtnFactoryTestTwo_B_eLockOn:
              LockSet_B(eSwSta_On);
              break;

            case BtnFactoryTestTwo_Uni_DcOutPosOff:
              DcOutPosSet_Uni(eSwSta_Off);
              break;
            case BtnFactoryTestTwo_Uni_DcOutPosOn:
              DcOutPosSet_Uni(eSwSta_On);
              break;

            case BtnFactoryTestTwo_Uni_DcOutNegOff:
              DcOutNegSet_Uni(eSwSta_Off);
              break;
            case BtnFactoryTestTwo_Uni_DcOutNegOn:
              DcOutNegSet_Uni(eSwSta_On);
              break;

            default:
              LcdShowPage(ScrnFactoryTestTwo_B);
              break;
          }
          break;
        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_B_FactoryTestTwo != pLcdCtrl->CurScreen)
    {
      IdleLedSet_B(eSwSta_Off);
      DcOutNegSet_B(eSwSta_Off);
      DrainResistSet_B(eSwSta_Off);
      LockSet_B(eSwSta_Off);
      return;
    }

    FactoryTestTwoUpdate_B(&Update);

    osDelay(100);
  }
}


