
#ifndef __DRV_BOARDIO_H__
#define __DRV_BOARDIO_H__

#include "Global.h"

#if 1
#define BmsPower_Pin           GPIO_Pin_6
#define BmsPower_Port          GPIOG
#define BmsPower_RCC           RCC_AHB1Periph_GPIOG

#define DrainResist_Pin        GPIO_Pin_5
#define DrainResist_Port       GPIOG
#define DrainResist_RCC        RCC_AHB1Periph_GPIOG

#define DcOutPos_Pin           GPIO_Pin_4
#define DcOutPos_Port          GPIOG
#define DcOutPos_RCC           RCC_AHB1Periph_GPIOG

#define DcOutNeg_Pin           GPIO_Pin_3
#define DcOutNeg_Port          GPIOG
#define DcOutNeg_RCC           RCC_AHB1Periph_GPIOG


#define DcOutChkPos_Pin        GPIO_Pin_1
#define DcOutChkPos_Port       GPIOE
#define DcOutChkPos_RCC        RCC_AHB1Periph_GPIOE

#define DcOutChkNeg_Pin        GPIO_Pin_0
#define DcOutChkNeg_Port       GPIOE
#define DcOutChkNeg_RCC        RCC_AHB1Periph_GPIOE


#define Lock_Pin             GPIO_Pin_13
#define Lock_Port            GPIOD
#define Lock_RCC             RCC_AHB1Periph_GPIOD

#define LockChk_Pin             GPIO_Pin_15
#define LockChk_Port            GPIOD
#define LockChk_RCC             RCC_AHB1Periph_GPIOD

#define ChgLed_Pin             GPIO_Pin_10
#define ChgLed_Port            GPIOE
#define ChgLed_RCC             RCC_AHB1Periph_GPIOE

#define FaultLed_Pin             GPIO_Pin_11
#define FaultLed_Port            GPIOE
#define FaultLed_RCC             RCC_AHB1Periph_GPIOE

#define IdleLed_Pin             GPIO_Pin_12
#define IdleLed_Port            GPIOE
#define IdleLed_RCC             RCC_AHB1Periph_GPIOE


/********************************************************/

#define DcOutPos_B_Pin           GPIO_Pin_7
#define DcOutPos_B_Port          GPIOF
#define DcOutPos_B_RCC           RCC_AHB1Periph_GPIOF

#define DcOutNeg_B_Pin           GPIO_Pin_6
#define DcOutNeg_B_Port          GPIOF
#define DcOutNeg_B_RCC           RCC_AHB1Periph_GPIOF

#define DrainResist_B_Pin        GPIO_Pin_5
#define DrainResist_B_Port       GPIOF
#define DrainResist_B_RCC        RCC_AHB1Periph_GPIOF

#define BmsPower_B_Pin           GPIO_Pin_4
#define BmsPower_B_Port          GPIOF
#define BmsPower_B_RCC           RCC_AHB1Periph_GPIOF

#define ShortCirCheck_Pin           GPIO_Pin_3
#define ShortCirCheck_Port          GPIOF
#define ShortCirCheck_RCC           RCC_AHB1Periph_GPIOF



#define DcOutChkPos_B_Pin        GPIO_Pin_5
#define DcOutChkPos_B_Port       GPIOE
#define DcOutChkPos_B_RCC        RCC_AHB1Periph_GPIOE

#define DcOutChkNeg_B_Pin        GPIO_Pin_4
#define DcOutChkNeg_B_Port       GPIOE
#define DcOutChkNeg_B_RCC        RCC_AHB1Periph_GPIOE


#define Lock_B_Pin             GPIO_Pin_12
#define Lock_B_Port            GPIOD
#define Lock_B_RCC             RCC_AHB1Periph_GPIOD

#define LockChk_B_Pin             GPIO_Pin_14
#define LockChk_B_Port            GPIOD
#define LockChk_B_RCC             RCC_AHB1Periph_GPIOD

#define ChgLed_B_Pin             GPIO_Pin_13
#define ChgLed_B_Port            GPIOE
#define ChgLed_B_RCC             RCC_AHB1Periph_GPIOE

#define FaultLed_B_Pin             GPIO_Pin_14
#define FaultLed_B_Port            GPIOE
#define FaultLed_B_RCC             RCC_AHB1Periph_GPIOE

#define IdleLed_B_Pin             GPIO_Pin_15
#define IdleLed_B_Port            GPIOE
#define IdleLed_B_RCC             RCC_AHB1Periph_GPIOE


/**********************************************************/

#define DcOutPos_Uni_Pin           GPIO_Pin_2
#define DcOutPos_Uni_Port          GPIOF
#define DcOutPos_Uni_RCC           RCC_AHB1Periph_GPIOF

#define DcOutNeg_Uni_Pin           GPIO_Pin_7
#define DcOutNeg_Uni_Port          GPIOG
#define DcOutNeg_Uni_RCC           RCC_AHB1Periph_GPIOG

#define DcOutChkPos_Uni_Pin        GPIO_Pin_2
#define DcOutChkPos_Uni_Port       GPIOE
#define DcOutChkPos_Uni_RCC        RCC_AHB1Periph_GPIOE

#define DcOutChkNeg_Uni_Pin        GPIO_Pin_4
#define DcOutChkNeg_Uni_Port       GPIOD
#define DcOutChkNeg_Uni_RCC        RCC_AHB1Periph_GPIOD

//˶˿ں͸Ӵ
#define Dehumidifier_Pin             GPIO_Pin_7
#define Dehumidifier_Port            GPIOG
#define Dehumidifier_RCC             RCC_AHB1Periph_GPIOG

#define Emergence_Pin             GPIO_Pin_3
#define Emergence_Port            GPIOD
#define Emergence_RCC             RCC_AHB1Periph_GPIOD

#define DoorChk_Pin             GPIO_Pin_3
#define DoorChk_Port            GPIOE
#define DoorChk_RCC             RCC_AHB1Periph_GPIOE

#define SPD_Pin             GPIO_Pin_6
#define SPD_Port            GPIOE
#define SPD_RCC             RCC_AHB1Periph_GPIOE

#define RunLed_Pin             GPIO_Pin_13
#define RunLed_Port            GPIOC
#define RunLed_RCC             RCC_AHB1Periph_GPIOC

#define Fan_Pin             GPIO_Pin_8
#define Fan_Port            GPIOG
#define Fan_RCC             RCC_AHB1Periph_GPIOG

#define Fan_Top_Pin             GPIO_Pin_3
#define Fan_Top_Port            GPIOF
#define Fan_Top_RCC             RCC_AHB1Periph_GPIOF

#else
#define BmsPower_Pin        GPIO_Pin_5
#define BmsPower_Port       GPIOF
#define BmsPower_RCC        RCC_AHB1Periph_GPIOF

#define DcOut_Pin           GPIO_Pin_4
#define DcOut_Port          GPIOF
#define DcOut_RCC           RCC_AHB1Periph_GPIOF

#define DcOutChk_Pin        GPIO_Pin_4
#define DcOutChk_Port       GPIOD
#define DcOutChk_RCC        RCC_AHB1Periph_GPIOD


#define Fan_Pin             GPIO_Pin_3
#define Fan_Port            GPIOF
#define Fan_RCC             RCC_AHB1Periph_GPIOF

#define DrainResist_Pin             GPIO_Pin_2
#define DrainResist_Port            GPIOF
#define DrainResist_RCC             RCC_AHB1Periph_GPIOF

#define Lock_Pin             GPIO_Pin_13
#define Lock_Port            GPIOD
#define Lock_RCC             RCC_AHB1Periph_GPIOD

#define Emergence_Pin             GPIO_Pin_3
#define Emergence_Port            GPIOD
#define Emergence_RCC             RCC_AHB1Periph_GPIOD


#define ChgLed_Pin             GPIO_Pin_10
#define ChgLed_Port            GPIOE
#define ChgLed_RCC             RCC_AHB1Periph_GPIOE

#define FaultLed_Pin             GPIO_Pin_11
#define FaultLed_Port            GPIOE
#define FaultLed_RCC             RCC_AHB1Periph_GPIOE
#endif

#define RELAY_K1K2_Pin				GPIO_Pin_7
#define RELAY_K1K2_Port				GPIOG
#define RELAY_K1K2_RCC				RCC_AHB1Periph_GPIOG

#define RELAY_K3K4_Pin				GPIO_Pin_5
#define RELAY_K3K4_Port				GPIOG
#define RELAY_K3K4_RCC				RCC_AHB1Periph_GPIOG

#define RELAY_K5K6_Pin				GPIO_Pin_6
#define RELAY_K5K6_Port				GPIOF
#define RELAY_K5K6_RCC				RCC_AHB1Periph_GPIOF

#define RELAY_K7K8_Pin				GPIO_Pin_3
#define RELAY_K7K8_Port				GPIOF
#define RELAY_K7K8_RCC				RCC_AHB1Periph_GPIOF

#define RELAY_K9K10_Pin				GPIO_Pin_2
#define RELAY_K9K10_Port			GPIOF
#define RELAY_K9K10_RCC				RCC_AHB1Periph_GPIOF

#define ACContactor_Pin        GPIO_Pin_9
#define ACContactor_Port       GPIOE
#define ACContactor_RCC        RCC_AHB1Periph_GPIOE


extern EnumSwitchStatus EleLockSta;
extern EnumSwitchStatus EleLockSta_B;

extern EnumSwitchStatus DcOutPosSta;
extern EnumSwitchStatus DcOutNegSta;
extern EnumSwitchStatus DcOutPosSta_B;
extern EnumSwitchStatus DcOutNegSta_B;
extern EnumSwitchStatus DcOutPosSta_Uni;
extern EnumSwitchStatus DcOutNegSta_Uni;

extern void BmsPowerInit(void);
extern void BmsPowerSet(EnumSwitchStatus Set);

extern void DcOutInit(void);
extern void DcOutPosSet(EnumSwitchStatus Set);
extern void DcOutNegSet(EnumSwitchStatus Set);
extern void DcOutSet(EnumSwitchStatus Set);
extern EnumSwitchStatus DcOutNegGet(void);
extern EnumSwitchStatus DcOutPosGet(void);
extern EnumSwitchStatus DcOutNegGetSet(void);
extern EnumSwitchStatus DcOutPosGetSet(void);
extern EnumSwitchStatus DcOutGet(void);

extern void DrainResistInit(void);
extern void DrainResistSet(EnumSwitchStatus Set);
extern void ACContactorSet(EnumSwitchStatus Set);


extern void LockInit(void);
extern void LockSet(EnumSwitchStatus Set);
extern EnumSwitchStatus LockGet(void);

extern void ImdWorkSet(EnumSwitchStatus Set);

extern void ChgLedInit(void);
extern void ChgLedSet(EnumSwitchStatus Set);
extern void FaultLedInit(void);
extern void FaultLedSet(EnumSwitchStatus Set);
extern void IdleLedInit(void);
extern void IdleLedSet(EnumSwitchStatus Set);


extern void BmsPowerInit_B(void);
extern void BmsPowerSet_B(EnumSwitchStatus Set);

extern void DcOutInit_B(void);
extern void DcOutPosSet_B(EnumSwitchStatus Set);
extern void DcOutNegSet_B(EnumSwitchStatus Set);
extern void DcOutSet_B(EnumSwitchStatus Set);
extern EnumSwitchStatus DcOutNegGet_B(void);
extern EnumSwitchStatus DcOutPosGet_B(void);
extern EnumSwitchStatus DcOutNegGetSet_B(void);
extern EnumSwitchStatus DcOutPosGetSet_B(void);
extern EnumSwitchStatus DcOutGet_B(void);

extern void DrainResistInit_B(void);
extern void DrainResistSet_B(EnumSwitchStatus Set);

extern void LockInit_B(void);
extern void LockSet_B(EnumSwitchStatus Set);
extern EnumSwitchStatus LockGet_B(void);

extern void ImdWorkSet_B(EnumSwitchStatus Set);

extern void ChgLedInit_B(void);
extern void ChgLedSet_B(EnumSwitchStatus Set);
extern void FaultLedInit_B(void);
extern void FaultLedSet_B(EnumSwitchStatus Set);
extern void IdleLedInit_B(void);
extern void IdleLedSet_B(EnumSwitchStatus Set);
extern void ShortCirCheck(void);


extern void FanInit(void);
extern void FanInit_Top(void);
extern void FanSet(EnumSwitchStatus Set);
extern void FanSet_B(EnumSwitchStatus Set);
extern void FanSetExt(EnumSwitchStatus Set);
extern void FanSetExt_Top(EnumSwitchStatus Set);


extern void DcOutInit_Uni(void);
extern void DcOutPosSet_Uni(EnumSwitchStatus Set);
extern void DcOutNegSet_Uni(EnumSwitchStatus Set);
extern void DcOutSet_Uni(EnumSwitchStatus Set);
extern EnumSwitchStatus DcOutNegGet_Uni(void);
extern EnumSwitchStatus DcOutPosGet_Uni(void);
extern EnumSwitchStatus DcOutNegGetSet_Uni(void);
extern EnumSwitchStatus DcOutPosGetSet_Uni(void);
extern EnumSwitchStatus DcOutGet_Uni(void);

extern void DehumidifierInit(void);
extern void DehumidifierSet(EnumSwitchStatus Set);

extern void EmergenceInit(void);
extern EnumSwitchStatus EmergenceGet(void);

extern void DoorChkInit(void);
extern EnumSwitchStatus DoorChkGet(void);

extern void SPDInit(void);
extern EnumSwitchStatus SPDGet(void);


extern void BmsPowerSet_AB(EnumSwitchStatus Set);
extern void DcOutSet_AB(EnumSwitchStatus Set);
extern void DrainResistSet_AB(EnumSwitchStatus Set);
extern void FanSet_AB(EnumSwitchStatus Set);
extern void ImdWorkSet_AB(EnumSwitchStatus Set);
extern void LockSet_AB(EnumSwitchStatus Set);
extern EnumSwitchStatus LockGet_AB(void);
extern void RunLedInit(void);
extern void RunLedSet(EnumSwitchStatus Set);
extern void ShortCirCheckSet(EnumSwitchStatus Set);
extern EnumSwitchStatus ACContactorGet(void);
extern EnumSwitchStatus ACContactorSta;




extern void SystemReboot(void);
extern void ACContactorInit(void);

#endif


