
/******************************************************************************
ļ  : Drv_Can.c
  : Canշ
  :
޸  : 2014-09-04      

******************************************************************************/

#include "Drv_Can.h"


/******************************************************************************
  : InternetInit
  : ͨŽӿڳʼ
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
u8 CanInit(void)
{
  CAN_InitTypeDef CAN_InitStructure;
  NVIC_InitTypeDef NVIC_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;
  CAN_FilterInitTypeDef CAN_FilterInitStructure;

  /* Enable GPIO clock */
  /* Configure USART Tx and Rx as alternate function push-pull */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Pin = Can_TX_PIN;
  RCC_APB2PeriphClockCmd(Can_TX_GPIO_CLK, ENABLE);
  GPIO_Init(Can_TX_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Pin = Can_RX_PIN;
  RCC_APB2PeriphClockCmd(Can_RX_GPIO_CLK, ENABLE);
  GPIO_Init(Can_RX_GPIO_PORT, &GPIO_InitStructure);

  /* CAN register init */
  //CAN_DeInit(CANx);

  /* Enable Can clock */
  CANx_CLK_INIT(CANx_CLK, ENABLE);
  CAN_StructInit(&CAN_InitStructure);

  /* CAN cell init */
  CAN_InitStructure.CAN_TTCM = DISABLE;//ֹʱ䴥ͨģʽ
  CAN_InitStructure.CAN_ABOM = DISABLE;//CAN_MCR ĴINRQ λ1 0 һӲ
  //128 11 λλ˳״̬
  CAN_InitStructure.CAN_AWUM = DISABLE;//˯ģʽͨCAN_MCR ĴSLEEP λ
  CAN_InitStructure.CAN_NART = ENABLE;//DISABLE; CAN ֻ1 Σܷ͵ĽΣɹٲöʧ
  CAN_InitStructure.CAN_RFLM = DISABLE;//ڽʱFIFO δFIFO ıδһյıĻḲԭеı
  CAN_InitStructure.CAN_TXFP = DISABLE;//FIFO ȼɱĵıʶ

  CAN_InitStructure.CAN_Mode = CAN_Mode_Normal;//CAN_Mode_LoopBack;//CAN_Mode_Normal; //CAN Ӳģʽ
  CAN_InitStructure.CAN_SJW = CAN_SJW_1tq;//ͬԾ1 ʱ䵥λ
  CAN_InitStructure.CAN_BS1 = CAN_BS1_8tq;//ʱ1 Ϊ8 ʱ䵥λ
  CAN_InitStructure.CAN_BS2 = CAN_BS2_7tq;//ʱ2 Ϊ7 ʱ䵥λ
  CAN_InitStructure.CAN_Prescaler = 9; //(pclk1/((1+8+7)*9)) = 36Mhz/16/9 = 250Kbits 趨һʱ䵥λĳ9
  CAN_Init(CANx, &CAN_InitStructure);

  CAN_FilterInitStructure.CAN_FilterNumber = 0;//ָ˴ʼĹ0
  CAN_FilterInitStructure.CAN_FilterMode = CAN_FilterMode_IdMask;//ָ˹ʼģʽʶλģʽ
  CAN_FilterInitStructure.CAN_FilterScale = CAN_FilterScale_16bit;//CAN_FilterScale_32bit;//˹λ1 32 λ
  CAN_FilterInitStructure.CAN_FilterIdHigh = 0x0000;//趨ʶ32 λλʱΪ߶λ16 λλʱΪһ
  CAN_FilterInitStructure.CAN_FilterIdLow = 0x0000;//趨ʶ32 λλʱΪͶλ16 λλʱΪڶ
  CAN_FilterInitStructure.CAN_FilterMaskIdHigh = 0x0000;//趨αʶ߹ʶ32 λλʱΪ߶λ16 λλʱΪһ)
  CAN_FilterInitStructure.CAN_FilterMaskIdLow = 0x0000;//趨αʶ߹ʶ32 λλʱΪͶλ16 λλʱΪڶ
  CAN_FilterInitStructure.CAN_FilterFIFOAssignment = CAN_FIFO0;//趨ָFIFO0
  CAN_FilterInitStructure.CAN_FilterActivation = ENABLE;//ʹܹ
  CAN_FilterInit(&CAN_FilterInitStructure);

  NVIC_InitStructure.NVIC_IRQChannel = CANx_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = configLIBRARY_MAX_SYSCALL_INTERRUPT_PRIORITY + 1;;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);


//  CAN_ITConfig(CAN_IT_FMP0, ENABLE);//ʹָCAN ж


  return TRUE;
}


void CAN_TxData(char data)
{
  CanTxMsg TxMessage;
  u32 i = 0;
  u8 TransmitMailbox = 0;

  TxMessage.StdId = 0x55;// 趨׼ʶ
  TxMessage.ExtId = 0x1234;// 趨չʶ
  TxMessage.IDE = CAN_ID_EXT;// 趨Ϣʶ
  TxMessage.RTR = CAN_RTR_DATA;// 趨Ϣ֡
  TxMessage.DLC = 8; //趨Ϣ֡
  TxMessage.Data[0] = data;// ˴
  TxMessage.Data[1] = data;// ˴
  TxMessage.Data[2] = data;// ˴
  TxMessage.Data[3] = data;// ˴
  TxMessage.Data[4] = data;// ˴
  TxMessage.Data[5] = data;// ˴
  TxMessage.Data[6] = data;// ˴
  TxMessage.Data[7] = data;// ˴
  TransmitMailbox = CAN_Transmit(CANx, &TxMessage);//ʼһϢĴ
  i = 0;
  while((CAN_TransmitStatus(CANx, TransmitMailbox) != CAN_TxStatus_Ok) && (i != 0xFF))//ͨCANTXOK λȷϷǷɹ
  {
    i++;
  }

}

