
/******************************************************************************
ļ  : Drv_DtuActR1.c
  : гۿ޹˾ACT-R1
  :
޸  : 2014-08-26      

******************************************************************************/

#include "Drv_DtuG7710.h"
#include "Memory.h"


static StructDtuSta Dtu;

/******************************************************************************
  : DtuModSendByte
  : ֽ
  : Data - յֽ
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
static u8 DtuModSendByte(u8 Data)
{
#if 0
    osStatus EvenStatus;

    EvenStatus = osMessagePut(Dtu.Uart.SendQ, Data, 0);//portMAX_DELAY);
    if(osOK == EvenStatus)
    {
      UART_IER(Reader_Uart) |= IER_THRE;
      return TRUE;
    }

    return FALSE;
#endif

  u8 LSRValue;

  UART_THR(Dtu_Uart) = Data;

  do
  {
    LSRValue = UART_LSR(Dtu_Uart);    /* Check status in the LSR to see if valid data in U0THR or not */
  }while(LSR_TEMT != (LSRValue & LSR_TEMT));

  return TRUE;
}

#if 0
static int DtuModPrintf(char *Fmt, ...)
{
  char Buf[256];
  char *pData;
  int Count;
  va_list Args;

  va_start(Args, Fmt);
  Count = vsnprintf(Buf, sizeof(Buf), Fmt, Args);
  pData = Buf;
  while(Count)
  {
    DtuModSendByte(*(u8*)pData);
    pData++;
    Count--;
  }
  va_end(Args);

  return (int)(pData-Buf);
}



/******************************************************************
*    ƣ InternetFrameRecv
*       ȡڽն(FIFO)һ֡
            һ֡EEͷFF FC FF FF βһ֡
*ڲ 
*ڲ 
********************************************************************/
static u8 DtuModGetFrame(char *pFrame, u16 MaxLen)
{
  typedef enum
  {
    eDtuRespSta_0D = 0,
    eDtuRespSta_0A,
  }EnumDtuResp;

  osEvent RecvDataMsg;
  u8 DataTemp;
  u8 FrameLen = 0;
  EnumDtuResp RecvSta = eDtuRespSta_0D;

  RecvDataMsg = osMessageGet(Dtu.Uart.RecvQ, 23);
  while((osEventMessage == RecvDataMsg.status) && (FrameLen < (MaxLen-1)))
  {
    DataTemp = RecvDataMsg.value.v;
    pFrame[FrameLen] = DataTemp;
    FrameLen++;
    pFrame[FrameLen] = 0;
    switch(RecvSta)
    {
      case eDtuRespSta_0D:
        if(0x0D == DataTemp)//յ0x0D
          RecvSta = eDtuRespSta_0A;
        else
          RecvSta = eDtuRespSta_0D;
        break;
      case eDtuRespSta_0A:
        if(0x0A == DataTemp)
        {//յ0x0A,
          pFrame[FrameLen] = 0;
          if(FrameLen > 2)//ݷ
            return FrameLen;
          else
          {//ݣ㣬
            RecvSta = eDtuRespSta_0D;
            FrameLen = 0;
          }
        }
        else if(0x0D == DataTemp)
          RecvSta = eDtuRespSta_0A;
        else
          RecvSta = eDtuRespSta_0D;
        break;

      default:
        if(0x0D == DataTemp)//յ0x0D
          RecvSta = eDtuRespSta_0A;
        else
          RecvSta = eDtuRespSta_0D;
        FrameLen = 0;
        pFrame[FrameLen] = DataTemp;
        FrameLen++;
        pFrame[FrameLen] = 0;
        break;
    }
    RecvDataMsg = osMessageGet(Dtu.Uart.RecvQ, 5);
  }

  pFrame[FrameLen]= 0;
  return FrameLen;
}

static void DtuCleanRecvBuff(void)
{
  osEvent RecvMsg;

  do
  {/*սջ*/
    RecvMsg = osMessageGet(Dtu.Uart.RecvQ, 1);
  }while(osEventMessage == RecvMsg.status);
}

static int DtuModWaitAck(u32 Ms)
{
  u32 StartTick = GetSystemTick();
  char *pStr;
  do
  {
    if(DtuModGetFrame(Dtu.Resp, sizeof(Dtu.Resp)))
    {
      pStr = strstr(Dtu.Resp, "OK\r\n");
      if(NULL != pStr)
        return 0;
      pStr = strstr(Dtu.Resp, "+CME ERROR");
      if(NULL != pStr)
        return 1;
      pStr = strstr(Dtu.Resp, "ERROR\r\n");
      if(NULL != pStr)
        return 1;
      pStr = strstr(Dtu.Resp, "+UNKNOW:\r\n");
      if(NULL != pStr)
        return 1;
    }
  }while((GetSystemTick() - StartTick) < Ms);

  return -1;//ʱ
}
#endif

static void ModReboot(void)
{
  const u8 ResetCmd[] =
  {
    0x68,0x72,0x00,0x72,0x00,
    0x68,
    0x41,0xFF,0xFF,0xFF,0xFF,0x20,0x01,
    0x65,
    0x00,0x00,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0xC4,
    0x16
  };
  u8 i;

  for(i=0; i<sizeof(ResetCmd); i++)
    DtuModSendByte(ResetCmd[i]);
}

static void ModSetCommParam(void)
{
  const u8 Cmd[] =
  {
    0x68,0x8A,0x00,0x8A,0x00,
    0x68,0x4A,0xFF,0xFF,0xFF,0xFF,0x20,0x04,
    0x68,
    0x00,0x00,0x01,0x00,0x14,0x01,0x1E,0x30,0x00,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x3B,
    0x16
  };
  u8 i;

  for(i=0; i<sizeof(Cmd); i++)
    DtuModSendByte(Cmd[i]);
}

static void ModSetCommType(void)
{
  const u8 Cmd[] =
  {
    0x68,0x92,0x00,0x92,0x00,
    0x68,
    0x4A,0xFF,0xFF,0xFF,0xFF,0x20,0x04,
    0x6A,
    0x00,0x00,0x80,0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x64,
    0x16
  };
  u8 i;

  for(i=0; i<sizeof(Cmd); i++)
    DtuModSendByte(Cmd[i]);
}


static u8 CheckSumByte(u8 *pBuf, u16 size)
{
  u8 chkSum;

  chkSum = 0;
  while(size--)
  {
    chkSum += *pBuf;
    pBuf++;
  }
  return chkSum;
}

static void ModSetServerIp(StructServerAddr *pServerIp)
{
  //У鿪ʼCmd[6],У鳤56,
  //IPʼCmd[18],portL Cmd[22], portH Cmd[23]
  //ipظCmd[24],portL Cmd[28], portH Cmd[29]
  //APN Cmd[30] 16ֽ
  //APN  Cmd[46] 16ֽ
  //У Cmd[62]
  // Cmd[63]
  const u8 IpSetCmd[64] =
  {
    0x68,0xE2,0x00,0xE2,0x00,
    0x68,
    0x4A,0xFF,0xFF,0xFF,0xFF,0x20,0x04,
    0x61,
    0x00,0x00,0x04,0x00,
    0x01,0xCA,0xFE,0x06,0x0B,0x20,
    0x01,0xCA,0xFE,0x06,0x0B,0x20,
    0x43,0x4D,0x4E,0x45,0x54,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x3A,
    0x16
  };

  u8 Buf[80];
  u8 i;

  memcpy(Buf, IpSetCmd, sizeof(IpSetCmd));
  Buf[18] = pServerIp->Ip[0];
  Buf[19] = pServerIp->Ip[1];
  Buf[20] = pServerIp->Ip[2];
  Buf[21] = pServerIp->Ip[3];
  Buf[22] = (u8)(pServerIp->Port);
  Buf[23] = (u8)((pServerIp->Port)>>8);
  Buf[24] = pServerIp->Ip[0];
  Buf[25] = pServerIp->Ip[1];
  Buf[26] = pServerIp->Ip[2];
  Buf[27] = pServerIp->Ip[3];
  Buf[28] = (u8)(pServerIp->Port);
  Buf[29] = (u8)((pServerIp->Port)>>8);

  Buf[62] = CheckSumByte(&Buf[6], 56);

  for(i=0; i<sizeof(IpSetCmd); i++)
    DtuModSendByte(Buf[i]);
}

typedef enum
{
  eDtuProc_PowerOn = 0,
  eDtuProc_Start,//0
  eDtuProc_WaitReBoot,
  eDtuProc_Error,
  eDtuProc_Idle,
}EnumDtuProc;

static void DtuProcPowerOn(void)
{
  osDelay(5000);

  Dtu.Err.Bit.NoMod = 0;
  Dtu.Proc.StatusTick = 0;
  Dtu.Proc.ErrCnt = 0;
  Dtu.Proc.Status = eDtuProc_Start;
}

static void DtuProcStart(void)
{
  ModSetServerIp(&UserParam.ServerAddr);
  osDelay(3500);
  ModSetCommType();
  osDelay(3500);
  ModSetCommParam();
  osDelay(3500);
  ModSetServerIp(&UserParam.ServerAddr);
  osDelay(3500);
  ModSetCommType();
  osDelay(3500);
  ModReboot();
  osDelay(2000);

  Dtu.Err.Bit.NoMod = 0;
  Dtu.Proc.StatusTick = 0;
  Dtu.Proc.ErrCnt = 0;
  Dtu.Proc.Status = eDtuProc_WaitReBoot;
}

static void DtuProcWaitReBoot(void)
{
  osDelay(15000);

  Dtu.LastRecvTime = GetSystemTick();

  Dtu.Err.Bit.NoMod = 0;
  Dtu.Proc.StatusTick = 0;
  Dtu.Proc.ErrCnt = 0;
  Dtu.Proc.Status = eDtuProc_Idle;
}

static void DtuProcError(void)
{
  ModReboot();
  osDelay(2000);

  Dtu.Proc.StatusTick = 0;
  Dtu.Proc.ErrCnt = 0;
  Dtu.Proc.Status = eDtuProc_PowerOn;
}

static void DtuProcIdle(void)
{
  if((GetSystemTick() - Dtu.LastRecvTime) > (3*60*1000))
    Dtu.Proc.Status = eDtuProc_Error;
  if(eDtuSelfCtrl_CloseSckt == Dtu.SelCtrl)
  {
    Dtu.SelCtrl = eDtuSelfCtrl_None;
    Dtu.Proc.Status = eDtuProc_Error;
  }
}

static pDtuProcHandle DtuProcHandle[] =
{
  DtuProcPowerOn,
  DtuProcStart,
  DtuProcWaitReBoot,
  DtuProcError,
  DtuProcIdle
};

static void Thd_DtuProcess(void const *argument)
{
  Dtu.Proc.Status = 0;

  while(1)
  {
    if(Dtu.Proc.Status < (sizeof(DtuProcHandle)/sizeof(pDtuProcHandle)))
      DtuProcHandle[Dtu.Proc.Status]();
    else
      Dtu.Proc.Status = 0;

    osDelay(37);
  }
}

/******************************************************************************
  : Dtu_A_USARTx_IRQHandler
  : ܱڽж
  : 
  : 
******************************************************************************/
static void DtuIrqHandler(int vector, void* param)
{
  u8 IIRValue, LSRValue;
  u8 Data;
  osEvent SendDataMsg;

  IIRValue = UART_IIR(Dtu_Uart);

  IIRValue >>= 1;      /* skip pending bit in IIR */
  IIRValue &= 0x07;      /* check bit 1~3, interrupt identification */

  if((IIR_CTI == IIRValue) || (IIR_RDA == IIRValue))  /* Receive Data Available */
  {
    Data = UART_RBR(Dtu_Uart);
    if(eDtuProc_Idle == Dtu.Proc.Status)
    {
      if(NULL != Dtu.AppRecvQ)
        osMessagePut(Dtu.AppRecvQ, Data, 0);
      Dtu.LastRecvTime = GetSystemTick();
    }
    else
    {
      if(0 != Dtu.Uart.RecvQ)
        osMessagePut(Dtu.Uart.RecvQ, Data, 0);
    }
  }
  else if ( IIRValue == IIR_THRE )  /* THRE, transmit holding register empty */
  {
    /* THRE interrupt */
    LSRValue = UART_LSR(Dtu_Uart);    /* Check status in the LSR to see if valid data in U0THR or not */
    if(LSRValue & LSR_THRE)
    {
      if(0 != Dtu.Uart.SendQ)
        SendDataMsg = osMessageGet(Dtu.Uart.SendQ, 0);
      else
        SendDataMsg.status = osErrorParameter;
      if(osEventMessage == SendDataMsg.status)
        UART_THR(Dtu_Uart) = SendDataMsg.value.v;
      else
        UART_IER(Dtu_Uart) &= ~IER_THRE;
    }
  }

  VICVectAddr = 0;    /* Acknowledge Interrupt */
}

/******************************************************************************
  : DtuInit
  : ܱͨŽӿڳʼ
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
u8 DtuInit(osMessageQId AppRecvQ)
{
  StructPinParam PinParam;
  StructUartParam UartParam;

  PinParam.Dir = ePinDir_Out;
  PinParam.Mode = ePinMode_PullNone;
  PinParam.Func = DtuTx_PinFunc;
  PinParam.Pin = DtuTx_Pin;
  PinInit(DtuTx_Port, &PinParam);

  PinParam.Dir = ePinDir_In;
  PinParam.Mode = ePinMode_PullNone;
  PinParam.Func = DtuRx_PinFunc;
  PinParam.Pin = DtuRx_Pin;
  PinInit(DtuRx_Port, &PinParam);

  PeriphPowerSet(Dtu_UartPower, ENABLE);
  PeriphClkSet(Dtu_UartClk, ePclkDiv_CclkDiv_1);

  Dtu.AppRecvQ = AppRecvQ;

  /* Create Storage Message Queue */
  Dtu.Uart.RecvQ = NULL;
  //osMessageQDef(RecvQ, 128, u8);
  //Dtu.Uart.RecvQ = osMessageCreate(osMessageQ(RecvQ), NULL);

  Dtu.Uart.SendQ = NULL;
  //osMessageQDef(SendQ, 512, u8);
  //Dtu.Uart.SendQ = osMessageCreate(osMessageQ(SendQ), NULL);

  osMutexDef(Mutex);
  Dtu.SendMutex = osMutexCreate(osMutex(Mutex));

  osThreadDef(Thd_DtuProcess, osPriorityNormal, 0, configMINIMAL_STACK_SIZE);
  if(NULL == osThreadCreate(osThread(Thd_DtuProcess), NULL))
    return FALSE;

  rt_hw_interrupt_install(Dtu_UartInt, DtuIrqHandler, RT_NULL, "Dtu");
  rt_hw_interrupt_umask(Dtu_UartInt);

  UartParam.Clok = Fcclk;
  UartParam.Baud = Dtu_BaudRate;
  UartParam.Mode.Mult = 0;
  UartParam.Mode.Bits.NumLen = 8;
  UartParam.Mode.Bits.StopBit = 1;
  UartParam.Mode.Bits.Parity = 0;//żУ
  UartParam.Mode.Bits.IntMode = 1;//ж
  UartParam.Mode.Bits.FifoSize = 7;
  UartInit(Dtu_Uart, &UartParam);

  return TRUE;
}

u8 DtuNetAvail(void)
{
  if(eDtuProc_Idle != Dtu.Proc.Status)
    return FALSE;

  return TRUE;
}

int DtuTcpSend(u8 *pData, u16 Len)
{
  u16 i;

  if(FALSE == DtuNetAvail())
    return -1;

  if(osOK != osMutexWait(Dtu.SendMutex, 5000))//5
    return -2;

  if(FALSE == DtuNetAvail())
  {
    osMutexRelease(Dtu.SendMutex);
    return -3;
  }

  for(i=0; i<Len; i++)
    DtuModSendByte(pData[i]);

  osMutexRelease(Dtu.SendMutex);

  osDelay(200);
  return 0;
}

void DtuTcpClose(void)
{
  Dtu.SelCtrl = eDtuSelfCtrl_CloseSckt;
}



