
#ifndef __DRV_SPIFLASH_H__
#define __DRV_SPIFLASH_H__

/* Includes ------------------------------------------------------------------*/
#include "Global.h"

#define sFLASH_SECTION_SIZE       (0x1000)//4K
extern osMutexId SpiFlashMutex;

/* Exported functions ------------------------------------------------------- */
/* High layer functions  */
extern void sFLASH_Init(void);
extern void sFLASH_EraseSector(u32 SectorAddr);
extern void sFLASH_EraseBulk(void);
//extern void sFLASH_WritePage(u8* pBuffer, u32 WriteAddr, u16 NumByteToWrite);
extern void sFLASH_WriteBuffer(u8* pBuffer, u32 WriteAddr, u32 NumByteToWrite);
extern void sFLASH_ReadBuffer(u8* pBuffer, u32 ReadAddr, u32 NumByteToRead);
extern u32 sFLASH_ReadID(void);

#endif /* #ifndef __DRV_SPIFLASH_H__ */

