
/******************************************************************************
ļ  : Global.c
  : ͨϵͳ
  :
޸  : 2014-09-26      

******************************************************************************/

#include "Global.h"

UnionPillarError PillarError = {0};
UnionChgError ChargeError = {0};

UnionPillarError PillarError_B = {0};
UnionChgError ChargeError_B = {0};

/******************************************************************************
  : GetSystemTick
  : ȡϵͳTickⷵ0ʹĳЩܷ0Ӧó
  : 
  : ϵͳTick
******************************************************************************/
u32 GetSystemTick(void)
{
  u32 Tick = osKernelSysTick();

  if(0 == Tick)
    return 1;
  return Tick;
}


int CopyCode(u32 Des, u32 Scr, u32 Len)
{
  u32 DesAddr;
  u32 ScrAddr;
  u32 i;

  FLASH_Unlock();/* Flash unlock */

  DesAddr = Des;
  ScrAddr = Scr;
  for(i=0; i<Len; )
  {
    if(0 == (DesAddr%McnRomSectionSize))
      FLASH_EraseSector(DesAddr, VoltageRange_1);
    FLASH_ProgramHalfWord(DesAddr, *(u16*)ScrAddr);
    DesAddr += 2;
    ScrAddr += 2;
    i += 2;
  }
  FLASH_Lock();

  return memcmp((void*)Des, (void*)Scr, Len);
}

int UpdateFlagSet(u32 Status)
{
  FLASH_Unlock();/* Flash unlock */
  FLASH_EraseSector(UpdateFlagAddr, VoltageRange_1);
  FLASH_ProgramWord(UpdateFlagAddr, 0x414E4D4D);
  FLASH_ProgramWord(UpdateFlagAddr+4, Status);
  FLASH_ProgramWord(UpdateFlagAddr+8, 0x414E4C50);
  FLASH_Lock();

  return 0;
}
//*:BcDToHex
//*: BCDת16
//*: bcd_data  ҪתBCD(0-100)
//*: ת16
u8 BcdToHex(u8 Bcd)
{
  return ((Bcd>>4)*10 + (Bcd&0x0F));
}

//*ƣ HexToBcd
//*ܣ  16תBCD
//*  hex_data  Ҫת16(0-100)
//*أ  תBCD
u8 HexToBcd(u8 Hex)
{
  u8 Temp;
  u8 Bcd;

  Temp = Hex%100;
  Bcd = (Temp/10<<4) | (Temp%10);

  return Bcd;
}
