#ifndef __DRV_SMARTALLOCATION_H__
#define __DRV_SMARTALLOCATION_H__

#include "Global.h"

typedef enum
{
  Invalid	= 0,	//无效
  Valid		= 1,	//有效且空闲
  Hold_A	= 2,	//A枪占用
  Hold_B	= 3,	//B枪占用
}StructDcModuleUsedStatus;

typedef struct
{
  u8 addr;
  u8 status;
  u32 Voltage;
  u32 Current;
}StructDcModule;

typedef struct
{
  u8 num;
  u8 ValidNum;
  StructDcModule modules[2];
  StructDcModuleUsedStatus status;
  u32 Voltage;
  u32 Current;
}StructDcModuleGroup;


typedef struct
{
  u8 num;
  u16 NeedVolt;//0.1V/Bit;
  u16 NeedCurrt;//0.1A/Bit;
  u16 ActualVolt;//0.1V/Bit;
  u16 ActualCurrt;//0.1A/Bit;
}StructDcModuleGroupCtrl;

extern StructDcModuleGroup DcModuleGroup[];

#endif /*__DRV_SMARTALLOCATION_H__*/
