

#include "Thd_Charge.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"


void ChgProChgConfigure_AB(StructChargeCtrl *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CRM_SendTick = 0;
  u8  CrmRecog;
  u32 CcStatusChkTick = 0;

  BemMsg.Valid = 0;
  BcpMsg.Valid = 0;
  BmsCanInit();
  osDelay(20);

  ChargeTimerSet(eSwSta_Off);
  BmsPowerSet_AB(eSwSta_On);
  LockSet_AB(eSwSta_On);
  FanSet_AB(eSwSta_On);
  ImdWorkSet_AB(eSwSta_Off);
  DrainResistSet_AB(eSwSta_Off);
  DcOutSet_AB(eSwSta_Off);
  DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));

  CrmRecog = 0xAA;
  CRM_Send(CrmRecog);
  CRM_SendTick = GetSystemTick();
  BcpMsg.RecvTick = GetSystemTick();

  while(1)
  {
    if((GetSystemTick() - CRM_SendTick) > 250)
    {
      CRM_Send(CrmRecog);
      CRM_SendTick = GetSystemTick();
    }

    ChgPgnRecv(&PgnRecv);

    if((GetSystemTick() - BcpMsg.RecvTick) > MsgTimeout_5S)
    {
      CemMsg.Cem.Value.Bcp = 1;
      pChargeCtrl->CurProcess = eChgPro_AB_CommBreak;
      pChargeCtrl->Param = 0;
    }
    else
      CemMsg.Cem.Value.Bcp = 0;

    if(0 != BcpMsg.Valid)
    {//յBrm
///////////////////////////////////////////////////////////////////////////////////////
/*      if(BcpMsg.StartSoc > 980)
      {
        ChargeStopType = eChgStop_Conf_StartSoc98;
        pChargeCtrl->CurProcess = eChgPro_AB_ChgStop;
        pChargeCtrl->Param = 0;
      }
      else */
      /*if(BcpMsg.StartVolt > BcpMsg.ChgMaxVolt)
      {
        CstMsg.StopReason.Value.Truble = 1;
        CstMsg.StopTruble.Value.Other = 1;
        CstMsg.StopFault.Value.Volt = 1;
        ChargeStopType = eChgStop_Conf_BatVoltOverPermitMax;
        pChargeCtrl->CurProcess = eChgPro_AB_ChgStop;
        pChargeCtrl->Param = 0;
      }
      else*/ if(BcpMsg.StartVolt > DcModuleAbility.MaxVolt*10)
      {
        CstMsg.StopReason.Value.Truble = 1;
        CstMsg.StopTruble.Value.Other = 1;
        CstMsg.StopFault.Value.Volt = 1;
        ChargeStopType = eChgStop_Conf_StartVoltOverPillarMax;
        pChargeCtrl->CurProcess = eChgPro_AB_ChgStop;
        pChargeCtrl->Param = 0;
      }
      else if(DcModuleAbility.MinVolt > BcpMsg.ChgMaxVolt)
      {
        CstMsg.StopReason.Value.Truble = 1;
        CstMsg.StopTruble.Value.Other = 1;
        CstMsg.StopFault.Value.Volt = 1;
        ChargeStopType = eChgStop_Conf_ChgMaxVoltLessPillarMinVolt;
        pChargeCtrl->CurProcess = eChgPro_AB_ChgStop;
        pChargeCtrl->Param = 0;
      }
//////////////////////////////////////////////////////////////////////////////////////
      else
      {
        pChargeCtrl->CurProcess = eChgPro_AB_WaitBmsReady;
        pChargeCtrl->Param = 0;
      }
    }

    if(0 != BemMsg.Valid)
    {
      pChargeCtrl->CurProcess = eChgPro_AB_CommBreak;
      pChargeCtrl->Param = 0;
    }

    if(0 == ChargeEnable_AB)
    {//ⲿƽ
      ChargeStopType = eChgStop_Conf_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_AB())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick * 2))
    {
      CcStatusChkTick = 0;
      ChargeStopType = eChgStop_Conf_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Emergency) || (0 != PillarError_B.Value.Emergency))
    {
      ChargeStopType = eChgStop_Conf_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Door) || (0 != PillarError_B.Value.Door))
    {
      ChargeStopType = eChgStop_Conf_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Contactor) || (0 != PillarError_B.Value.Contactor))
    {
      ChargeStopType = eChgStop_Conf_Contactor;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.UniContactor) || (0 != PillarError_B.Value.UniContactor))
    {
      ChargeStopType = eChgStop_Conf_Contactor;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.InVolt) || (0 != PillarError_B.Value.InVolt))
    {
      ChargeStopType = eChgStop_Conf_InVolt;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.NoDcmod) || (0 != PillarError_B.Value.NoDcmod))
    {
      ChargeStopType = eChgStop_Conf_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if((0 != PillarError.Value.Meter) || (0 != PillarError_B.Value.Meter))
    {
      ChargeStopType = eChgStop_Conf_Meter;
      pChargeCtrl->CurProcess = eChgPro_AB_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_AB_ChgConfigure != pChargeCtrl->CurProcess)
      return;
    osDelay(25);
  }
}

