
#include "Thd_Charge.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Drv_Meter.h"


void ChgProChgStop_AB(StructChargeCtrl *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CST_SendTick = 0;
  u32 CSD_SendTick = 0;
  u32 CEM_SendTick = 0;
  u32 CurrtCheckTick = 0;
  u32 DrainResistTick = 0;
  u32 CcStatusChkTick = 0;
  u8 ChgEndFlag = 0;

  u32 Bst_RecvTick= 0;
  u32 Bsd_RecvTick= 0;
  u32 CsdCemSendCnt = 0;

  BsdMsg.Valid = 0;
  BmsCanInit();
  osDelay(5);

  ChargeTimerSet(eSwSta_Off);
  BmsPowerSet_AB(eSwSta_On);
  LockSet_AB(eSwSta_On);
  FanSet_AB(eSwSta_On);
  ImdWorkSet_AB(eSwSta_Off);
  DrainResistSet_AB(eSwSta_Off);
  //DcOutSet_AB(eSwSta_On);//пǳͨʧܵȴԭ״̬
  DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));

  CST_Send(&CstMsg);
  CST_SendTick = GetSystemTick();

  CemMsg.Cem.Value.Bst = 0;
  CemMsg.Cem.Value.Bsd = 0;
  CEM_SendTick = 0;

  CsdCemSendCnt = 0;
  CurrtCheckTick = GetSystemTick();
  DrainResistTick = 0;

  CSD_SendTick = 0;

  if(BstMsg.Valid)
    Bst_RecvTick = 0;
  else
    Bst_RecvTick = GetSystemTick();
  Bsd_RecvTick = GetSystemTick();

  while(1)
  {
    if((0 != CST_SendTick) && ((GetSystemTick() - CST_SendTick) > 10))
    {
      CST_Send(&CstMsg);
      CST_SendTick = GetSystemTick();
    }

    if((0 != CSD_SendTick) && ((GetSystemTick() - CSD_SendTick) > 250))//ʱ䵽
    {
      CsdMsg.ChgMin = GetChgMin();
      StopChgEnergy  = MeterValue.Energy + MeterValue_B.Energy;
      CsdMsg.ChgEnergy = (StopChgEnergy - StartChgEnergy)/10;
      CSD_Send(&CsdMsg);
      CSD_SendTick = GetSystemTick();
      CsdCemSendCnt++;
      if(CsdCemSendCnt > 5)
      {
        BmsPowerSet_AB(eSwSta_Off);
        CSD_SendTick = 0;
      }
    }

    if((0 != CEM_SendTick) && ((GetSystemTick() - CEM_SendTick) > 250))
    {
      CEM_SendTick = GetSystemTick();
      if(0 != CemMsg.Cem.Mult)//ͨŹ
      {
        CEM_Send(&CemMsg);
        CsdCemSendCnt++;
        if(CsdCemSendCnt > 5)
        {
          BmsPowerSet_AB(eSwSta_Off);
          CEM_SendTick = 0;
        }
      }
    }

    ChgPgnRecv(&PgnRecv);

    if(0 != Bst_RecvTick)
    {
      if(0 != BstMsg.Valid)
      {
        CemMsg.Cem.Value.Bst = 0;
        Bst_RecvTick = 0;
      }
      else if((GetSystemTick() - Bst_RecvTick) > MsgTimeout_5S)
      {
        CemMsg.Cem.Value.Bst = 1;
        CEM_SendTick = GetSystemTick();
        Bst_RecvTick = 0;
      }
    }

    if(0 != Bsd_RecvTick)
    {
      if(0 != BsdMsg.Valid)
      {
        CemMsg.Cem.Value.Bsd = 0;
        CSD_SendTick = GetSystemTick();
        Bsd_RecvTick = 0;
        CST_SendTick = 0;
      }
      else if((GetSystemTick() - Bsd_RecvTick) > MsgTimeout_10S)
      {
        if(0 == CemMsg.Cem.Value.Bst)
        {
          CemMsg.Cem.Value.Bsd = 1;
          CEM_SendTick = GetSystemTick();
        }
        Bsd_RecvTick = 0;
        CST_SendTick = 0;
      }
    }

    if(0 != CurrtCheckTick)
    {
      if((GetDcModuleCurrt_AB() < 50) || ((GetSystemTick() - CurrtCheckTick) > 120))
      {//С5A
        DcOutSet_AB(eSwSta_Off);//k1 k2
        DrainResistSet_AB(eSwSta_On);//йŵ
        DrainResistTick = GetSystemTick();
        CurrtCheckTick = 0;
      }
    }

    if(0 != DrainResistTick)
    {
      if((GetDcModuleVolt_AB() < 600) || ((GetSystemTick() - DrainResistTick) > 4000))//С60V
      {
        DrainResistSet_AB(eSwSta_Off);
        ChgEndFlag = 1;
        DrainResistTick = 0;
      }
    }

    if((0 != ChgEndFlag) && (CsdCemSendCnt > 5))
    {
      LockSet_AB(eSwSta_Off);
      FanSet_AB(eSwSta_Off);
    }

    if((0 == ChargeEnable_AB) && (0 != ChgEndFlag) && (CsdCemSendCnt > 5))
    {//ⲿƽ
      pChargeCtrl->CurProcess = eChgPro_ChgIdle;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_AB())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
      CcStatusChkTick = 0;
    }

    if((0 != PillarError.Value.Emergency) || (0 != PillarError_B.Value.Emergency))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
    }
    if((0 != PillarError.Value.Door) || (0 != PillarError_B.Value.Door))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
    }

    if((0 != PillarError.Value.Contactor) || (0 != PillarError_B.Value.Contactor))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
    }

    if((0 != PillarError.Value.UniContactor) || (0 != PillarError_B.Value.UniContactor))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
    }

    if((0 != PillarError.Value.InVolt) || (0 != PillarError_B.Value.InVolt))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
    }

    if((0 != PillarError.Value.NoDcmod) || (0 != PillarError_B.Value.NoDcmod))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
    }

    if((0 != PillarError.Value.Meter) || (0 != PillarError_B.Value.Meter))
    {
      DcModuleSet_AB(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*(DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
      DcOutSet_AB(eSwSta_Off);
    }

    if(eChgPro_AB_ChgStop != pChargeCtrl->CurProcess)
      return;

    osDelay(5);
  }
}





