

#include "Thd_Charge.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Drv_Meter.h"


void ChgProChgIdle(StructChargeCtrl *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CcStatusChkTick = 0;
  u32 CcStatusChkTick_AB = 0;

  ChargeError.Value.DrainResist = 0;
  ChargeError.Value.IsolateWarn = 0;//Ե
  ChargeError.Value.IsolateError = 0;
  ChargeError.Value.VoltOutError = 0;
  ChargeError.Value.CurrtOutError = 0;

  ChargeTimerSet(eSwSta_Off);
  CleanChgTimeCnt();
  BmsPowerSet(eSwSta_Off);
  LockSet(eSwSta_Off);
  FanSet(eSwSta_Off);
  //ɫԵģoff--ɫon
  ImdWorkSet(eSwSta_Off);
  DrainResistSet(eSwSta_Off);
  DcOutSet(eSwSta_Off);
  DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);

  BmsCanInit();
  osDelay(20);
  while(1)
  {
    ChgPgnRecv(&PgnRecv);
    
    if(eSwSta_On == CcStatusRead())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;

    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > 1500))
    {
      CcStatusChkTick = 0;
      if(0 != TCUCurChgRecd.TCUChargeEnable)
      {
        pChargeCtrl->CurProcess = eChgPro_ShakeHand;
        pChargeCtrl->Param = 0;
      }
    }
    if(
        (0 != PillarError.Value.Emergency)
        || (0 != PillarError.Value.NoDcmod)
        || (0 != PillarError.Value.Meter)
        || (0 != PillarError.Value.Memory)
        || (0 != PillarError.Value.Lcd)
        || (0 != PillarError.Value.Door)
        || (0 != PillarError.Value.Contactor)
        || (0 != PillarError.Value.UniContactor)
        || (0 != PillarError.Value.InVolt)
      )
    {
      pChargeCtrl->CurProcess = eChgPro_ChgIdle;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On == CcStatusRead_AB())
    {
      if(0 == CcStatusChkTick_AB)
        CcStatusChkTick_AB = GetSystemTick();
    }
    else
      CcStatusChkTick_AB = 0;

    if((0 != CcStatusChkTick_AB) && ((GetSystemTick() - CcStatusChkTick_AB) > 1500))
    {
      CcStatusChkTick_AB = 0;
      if(0 != ChargeEnable_AB)
      {
        pChargeCtrl->CurProcess = eChgPro_AB_ShakeHand;
        pChargeCtrl->Param = 0;
        if( (0 != PillarError.Value.Emergency)
          || (0 != PillarError.Value.NoDcmod)
          || (0 != PillarError.Value.Meter)
          || (0 != PillarError.Value.Memory)
          || (0 != PillarError.Value.Lcd)
          || (0 != PillarError.Value.Door)
          || (0 != PillarError.Value.Contactor)
          || (0 != PillarError.Value.UniContactor)
          || (0 != PillarError.Value.InVolt)
          || (0 != PillarError_B.Value.Emergency)
          || (0 != PillarError_B.Value.NoDcmod)
          || (0 != PillarError_B.Value.Meter)
          || (0 != PillarError_B.Value.Memory)
          || (0 != PillarError_B.Value.Lcd)
          || (0 != PillarError_B.Value.Door)
          || (0 != PillarError_B.Value.Contactor)
          || (0 != PillarError_B.Value.UniContactor)
          || (0 != PillarError_B.Value.InVolt)
        )
        {
          pChargeCtrl->CurProcess = eChgPro_ChgIdle;
          pChargeCtrl->Param = 0;
        }
      }


    }

    if(eChgPro_ChgIdle != pChargeCtrl->CurProcess)
      return;

    osDelay(100);
  }
}

