

#include "Thd_Charge_B.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Drv_ImdJyc.h"
#include "Memory.h"

void ChgProChgRecognizeEx_B(StructChargeCtrl_B *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CRM_SendTick = 0;
  u8  CrmRecog;
  u32 CcStatusChkTick = 0;

//  if(ImdValue_B.Vaild)
//    ImdWrite_B(0x0017, 0x0003);

  memset(&BemMsg_B, 0, sizeof(BemMsg_B));
  memset(&CemMsg_B, 0, sizeof(CemMsg_B));
  memset(&BstMsg_B, 0, sizeof(BstMsg_B));
  memset(&CstMsg_B, 0, sizeof(CstMsg_B));

  BrmMsg_B.Valid = 0;
  BemMsg_B.Valid = 0;
  BmsCanInit_B();
  osDelay(20);
//  if(ImdValue_B.Vaild)
//    ImdWrite_B(0x0017, 0x0003);

  ChargeTimerSet_B(eSwSta_Off);
  BmsPowerSet_B(eSwSta_On);
  LockSet_B(eSwSta_On);
  FanSet_B(eSwSta_On);
  ImdWorkSet_B(eSwSta_Off);
  DrainResistSet_B(eSwSta_Off);
  DcOutSet_B(eSwSta_Off);
  DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);

  CrmRecog = 0x00;
  CRM_Send_B(CrmRecog);
  CRM_SendTick = GetSystemTick();
  BrmMsg_B.RecvTick = GetSystemTick();
  CemMsg_B.Cem.Value.Brm = 0;

  while(1)
  {
    if((0 != CRM_SendTick) && ((GetSystemTick() - CRM_SendTick) > 250))
    {
      CRM_Send_B(CrmRecog);
      CRM_SendTick = GetSystemTick();
    }

    ChgPgnRecv_B(&PgnRecv);

    if(0 != BrmMsg_B.Valid)
    {//յBrm
      pChargeCtrl->CurProcess = eChgPro_B_ChgConfigure;
      pChargeCtrl->Param = 0;
    }
    else if((GetSystemTick() - BrmMsg_B.RecvTick) < (MsgTimeout_B_5S/2))
    {

    }
    else if((GetSystemTick() - BrmMsg_B.RecvTick) < (MsgTimeout_B_10S))
    {
      //BmsPowerSet_B(eSwSta_Off);
      CRM_SendTick = 0;
    }
    else
    {
      pChargeCtrl->CurProcess = eChgPro_B_ChgRecognize;
      pChargeCtrl->Param = 0;
    }

    if(0 == TCUCurChgRecd_B.TCUChargeEnable)
    {//ⲿƽ
      ChargeStopType_B = eChgStop_Reco_UserCancle;
      pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_B())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick_B * 2))
    {
      CcStatusChkTick = 0;
      ChargeStopType_B = eChgStop_Reco_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Emergency)
    {
      ChargeStopType_B = eChgStop_Reco_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Door)
    {
      ChargeStopType_B = eChgStop_Reco_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Contactor)
    {
      ChargeStopType_B = eChgStop_Reco_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.UniContactor)
    {
      ChargeStopType_B = eChgStop_Reco_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.InVolt)
    {
      ChargeStopType_B = eChgStop_Reco_InVolt;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.NoDcmod)
    {
      ChargeStopType_B = eChgStop_Reco_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Meter)
    {
      ChargeStopType_B = eChgStop_Reco_Meter;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_B_ChgRecognizeEx != pChargeCtrl->CurProcess)
      return;

    osDelay(25);
  }
}


