
#include "Thd_Lcd.h"
#include "Thd_InternetBsb.h"


#define ScrnPutBack_AB          ((u16)14)  //Aǹ  ״̬

#define BtnPutBack_AB_Cancle     ((u16)0x0019)
#define DataPutBack_AB_Counter   ((u16)0x0003)

#define TextPutBack_AB_CardNum       ((u16)0x4020)

#define DataPutBack_AB_ChgMin        ((u16)0x0006)
#define DataPutBack_AB_ChgEnergy     ((u16)0x0005)
#define DataPutBack_AB_Soc           ((u16)0x0023)

#define DataPutBack_AB_EmployMoney   ((u16)0x002F)
#define DataPutBack_AB_EnergyMoney   ((u16)0x000F)
#define DataPutBack_AB_ServeMoney    ((u16)0x0010)
#define DataPutBack_AB_TotalMoney    ((u16)0x0007)

#define VarPutBack_AB_Position       ((u16)0x003C)
void PutBackPaint_AB(void)
{
  char Str[64];
  u16 TempU16;

  LcdShowData16(VarPutBack_AB_Position, 3);

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", pCurChgRecd_AB->CardNum[0],pCurChgRecd_AB->CardNum[1],
            pCurChgRecd_AB->CardNum[2], pCurChgRecd_AB->CardNum[3], pCurChgRecd_AB->CardNum[4], pCurChgRecd_AB->CardNum[5],
            pCurChgRecd_AB->CardNum[6], pCurChgRecd_AB->CardNum[7], pCurChgRecd_AB->CardNum[8], pCurChgRecd_AB->CardNum[9]);
  LcdShowStr(TextPutBack_AB_CardNum, (u8*)&Str[0], 20);

  TempU16 = pCurChgRecd_AB->ChgTime/60;//GetChgMin();
  LcdShowData16(DataPutBack_AB_ChgMin, TempU16);
  TempU16 = pCurChgRecd_AB->ChgEnergy/10;
  LcdShowData16(DataPutBack_AB_ChgEnergy, TempU16);
  TempU16 = BcsMsg.CurSoc;
  LcdShowData16(DataPutBack_AB_Soc, TempU16);

  LcdShowData16(DataPutBack_AB_EmployMoney, pCurChgRecd_AB->EmployMoney);
  LcdShowData16(DataPutBack_AB_EnergyMoney, pCurChgRecd_AB->EnergyMoney);
  LcdShowData16(DataPutBack_AB_ServeMoney, pCurChgRecd_AB->ServeMoney);
  LcdShowData16(DataPutBack_AB_TotalMoney, pCurChgRecd_AB->TotalMoney);

  LcdShowNum(DataPutBack_AB_Counter, 25);
  LcdShowPage(ScrnPutBack_AB);
}

void PutBackIdle_AB(void)
{

}

#define UnCnnctTime   (2*1000)//2

void LcdProPutBack_AB(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u8 Time = 0;

  ChargeEnable_AB = 0;
  ChargePauseFlag = 0;
  BuzzerRun(1, 800, 100);

  LockSet_AB(eSwSta_Off);
  pCurChgRecd_AB->ChgStopNotetrl = 1;
  osDelay(500);
  pCurChgRecd_AB->ChgRecUpCtrl = 1;

  //pCurChgRecd_AB = NULL;

  TimeOutTick = 155;//31*100ms = 180;
  Time = 25;
  PutBackPaint_AB();

  while(1)
  {
    if(TimeOutTick > 0)
      TimeOutTick--;

    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnPutBack_AB_Cancle:    //"·ذ"
                pLcdCtrl->CurScreen = eLcdPro_MainMenu;
//                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnPutBack_AB);
                break;
            }
          }
          else
            LcdShowPage(ScrnPutBack_AB);
          break;

        default:
          break;
      }
    }

    if(TimeOutTick < 1)
    {
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }
    else if(TimeOutTick < 100)
    {
      if((0 == PillarError.Value.EleLock) && (0 == PillarError_B.Value.EleLock))
      {
        if(0 == pCurChgRecd_AB->RecordValid)
        {
          pLcdCtrl->CurScreen = eLcdPro_MainMenu;
          pLcdCtrl->Param = 0;
        }
      }
      else
      {
        LcdShowPage(18);
        LcdShowData16(VarPutBack_AB_Position, 3);
      }
    }

    if(eLcdPro_AB_PutBack != pLcdCtrl->CurScreen)
      return;

    Temp = TimeOutTick/10;
    if(Time != Temp)
    {
      Time = Temp;
      LcdShowNum(DataPutBack_AB_Counter, Time);
    }

    PutBackIdle_AB();

    osDelay(100);
  }
}



