
#include "Thd_Lcd.h"


#define ScrnBuildComm_B  ((u16)9)
#define BtnBuildComm_B_Cancel      ((u16)0x0901)

#define AnimBuildCommAddr_B_Start  ((u16)0x0020)

#define VarBulidComm_B_Position    ((u16)0x003C)
void BuildCommPaint_B(void)
{
  LcdShowData16(VarBulidComm_B_Position, 2);

  LcdShowData16(AnimBuildCommAddr_B_Start, 0);
  LcdShowPage(ScrnBuildComm_B);
}

void BuildCommIdle_B(void)
{

}

void LcdProBuildComm_B(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;

  ChargeStopType_B = eChgStop_None;
  memset(&BcpMsg_B ,0,sizeof(BcpMsg_B));
  memset(&BclMsg_B ,0,sizeof(BclMsg_B));
  memset(&BcsMsg_B ,0,sizeof(BcsMsg_B));
  memset(&BsmMsg_B ,0,sizeof(BsmMsg_B));
  memset(&BsdMsg_B ,0,sizeof(BsdMsg_B));
  memset(&BrmMsg_B ,0,sizeof(BrmMsg_B));

  if((0x88 == CurChgRecd_B.CardNum[0]) && (0x80 == (CurChgRecd_B.CardNum[1] & 0x80)))
    CurChgRecd_B.MoneyDecFlag = 0;
  else
    CurChgRecd_B.MoneyDecFlag = 2;   //0δۿ 1¿ۿ 2̨
  CurChgRecd_B.ChgStopType = 0;     //ֹͣ   //1ˢ 2Զ 4ǹ

  //CurChgRecd_B.ChgType = 0;      // 0=Ȼ 1=Զʱ磻2=Զ 3=Զ
  //CurChgRecd_B.ChgTypeParam = 0; //Բ0=Ȼ磨01=Զʱ䣨1s/bit2=Զ0.001Kwh/bit3=Զ1/bit

  CurChgRecd_B.ChgEnergy = 0;    //ۻ 0.001kWh/bit
  CurChgRecd_B.ChgTime = 0;      //ۻʱ 1s/bit

  //CurChgRecd_B.RespMaxChgEnergy = 0xFFFFFFFF;     //֤ɳ
  //CurChgRecd_B.RespMaxChgTime = 0xFFFFFFFF; //֤ɳʱ

  CurChgRecd_B.WipeStartTime = RtcGetTime();  //ˢʼʱ 0δˢ 0 ˢʱ׼ʱ

  CurChgRecd_B.WipeStopTime = 0;  //ˢʱ 0δˢ 0 ˢʱ׼ʱ
  CurChgRecd_B.ChgStartTime = RtcGetTime(); //翪ʼʱ 0δʼ 0翪ʼʱʱ
  CurChgRecd_B.ChgStopTime = RtcGetTime(); //ʱ 0δʼ 0ʱʱ

  CurChgRecd_B.StartMeterEnergy = MeterValue_B.Energy*10;  //ʼܱ 0.001kWh/bit
  CurChgRecd_B.StopMeterEnergy = MeterValue_B.Energy*10;   //ܱ 0.001kWh/bit

//  CurChgRecd_B.StartCardMoney = 0;    //翨
//  CurChgRecd_B.StopCardMoney = 0;    //翨
  CurChgRecd_B.EnergyMoney = 0;  //ѽ
  CurChgRecd_B.ServeMoney = 0;   //ѽ
  CurChgRecd_B.EmployMoney = 0;   //׮ռý
  CurChgRecd_B.TotalMoney = 0;   //ѽ

  CurChgRecd_B.ChgServerUpCtrl = 0;
  CurChgRecd_B.ChgRecUpCtrl = 0;

  CurChgRecd_B.RecordValid = 1;

  CurChgRecd_B.ChgStartNoteCtrl = 0;
  CurChgRecd_B.ChgStopNotetrl = 0;

  ChargeEnable_B = 1;
  ChargePauseFlag_B = 0;

  BuzzerRun(1, 800, 100);
  //IdleLedSet(eSwSta_Off);
  //ChgLedSet(eSwSta_On);
  ScreenChkTick = GetSystemTick();
  BuildCommPaint_B();

  TempChgRecdSaveToLog(&CurChgRecd_B, 2, 1);

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnBuildComm_B != Temp)
              LcdShowPage(ScrnBuildComm_B);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnBuildComm_B_Cancel:
                ChargeEnable_B = 0;
                //pLcdCtrl->CurScreen = eLcdPro_B_ChargeSummary;//eLcdPro_MainMenu;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_ChargeSummary);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnBuildComm_B);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    switch(ChargeCtrl_B.CurProcess)
    {
      case eChgPro_B_ChgRun:
      case eChgPro_B_WaitVoltChgRun:
        CurChgRecd_B.ChgStartNoteCtrl = 1;
        //pLcdCtrl->CurScreen = eLcdPro_B_ChargeSummary;
        pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_ChargeSummary);
        pLcdCtrl->Param = 0;
        break;
      case eChgPro_B_ChgStop:
      case eChgPro_B_CommError:
      case eChgPro_B_ChgBreak:
        //pLcdCtrl->CurScreen = eLcdPro_B_ChargeSummary;//eLcdPro_CommError;
        pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_ChargeSummary);
        pLcdCtrl->Param = 0;
        break;
      default:
        break;
    }

    if(ChargeStopType_B == eChgStop_ComBreak_CommError)
    {
      pLcdCtrl->CurScreen = eLcdPro_CommError;
      pLcdCtrl->Param = 2;
    }

    if(eLcdPro_B_BuildComm != pLcdCtrl->CurScreen)
      return;

    BuildCommIdle_B();

    osDelay(100);
  }
}



