
#include "Thd_Lcd.h"


#define ScrnCnctDetect_B          ((u16)7)  //Aǹ  ״̬

#define BtnCnctDetect_B_Cancle     ((u16)0x0701)
#define DataCnctDetect_B_Counter   ((u16)0x0002)

#define TxtCnctDetect_B_CardNum    ((u16)0x4020)
#define VarCnctDetect_B_CardMoney  ((u16)0x0003)

#define VarCnctDetect_B_Position   ((u16)0x003C)
void CnctDetectPaint_B(void)
{
  char Str[64];
  LcdShowData16(VarCnctDetect_B_Position, 2);


  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", CurChgRecd_B.CardNum[0],CurChgRecd_B.CardNum[1],
            CurChgRecd_B.CardNum[2], CurChgRecd_B.CardNum[3], CurChgRecd_B.CardNum[4], CurChgRecd_B.CardNum[5],
            CurChgRecd_B.CardNum[6], CurChgRecd_B.CardNum[7], CurChgRecd_B.CardNum[8], CurChgRecd_B.CardNum[9]);
  LcdShowStr(TxtCnctDetect_B_CardNum, (u8*)Str, strlen(Str)+1);

  LcdShowData32(VarCnctDetect_B_CardMoney, CurChgRecd_B.CardRespMoney);

  LcdShowNum(DataCnctDetect_B_Counter, 60);
  LcdShowPage(ScrnCnctDetect_B);
}

void CnctDetectIdle_B(void)
{

}

#define CnnctTime   (2*1000)//2

void LcdProCnctDetect_B(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u8 Time = 0,i,j;
  u32 CcStatusChkTick = 0;

  TimeOutTick = 610;//1810*100ms = 180;
  CnctDetectPaint_B();

  while(1)
  {
    if(TimeOutTick > 0)
      TimeOutTick--;

    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnCnctDetect_B_Cancle:    //"·ذ"
                //pLcdCtrl->CurScreen = eLcdPro_MainMenu;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnCnctDetect_B);
                break;
            }
          }
          else
            LcdShowPage(ScrnCnctDetect_B);
          break;

        default:
          break;
      }
    }

    if(eSwSta_On == CcStatusRead_B())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CnnctTime))
    {
      CcStatusChkTick = 0;
      if((0x88 == CurChgRecd.CardNum[0]) && (0x80 == (CurChgRecd.CardNum[1] & 0x80))
          && (0 != UserParam.LockCard))
      {
        pLcdCtrl->CurScreen = eLcdPro_LockCard;
        pLcdCtrl->Param = 0;
      }
      else
      {
        for(i=0;i<3;i++)
        {
          LockSet_B(eSwSta_On);
          osDelay(500);
          for(j=0;j<10;j++)
          {
            if(1 == UserParam.ChgFun.Value.EleLock)
              if(LockGet_B()!=eSwSta_On) break;
            osDelay(10);
          }
          if(j>=10) break;
          LockSet_B(eSwSta_Off);
          osDelay(500);
        }
        if(i>=3)
        {
          pLcdCtrl->CurScreen = eLcdPro_B_ElectLock;
          pLcdCtrl->Param = 0;
        }
        else
        {
          pLcdCtrl->CurScreen = eLcdPro_B_BuildComm;
          pLcdCtrl->Param = 0;
        }
      }
    }

    if(eLcdPro_B_CnctDetect != pLcdCtrl->CurScreen)
      return;

    if((TimeOutTick) < 1)
    {
//      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    Temp = TimeOutTick/10;
    if(Time != Temp)
    {
      Time = Temp;
      LcdShowNum(DataCnctDetect_B_Counter, Time);
    }

    CnctDetectIdle_B();

    osDelay(100);
  }
}








