
#include "Thd_Lcd.h"

#define ScrnSwipeCard_B               ((u16)12) //Aǹˢ

#define BtnSwipeCard_B_Cancel         ((u16)0x1201)
#define BtnSwipeCard_B_Enter          ((u16)0x1202)



#define TextSwipeCard_B_CardNum       ((u16)0x4020)

#define DataSwipeCard_B_ChgMin        ((u16)0x0006)
#define DataSwipeCard_B_ChgEnergy     ((u16)0x0005)
#define DataSwipeCard_B_Soc           ((u16)0x0023)

#define DataSwipeCard_B_EmployMoney   ((u16)0x002F)
#define DataSwipeCard_B_EnergyMoney   ((u16)0x0010)
#define DataSwipeCard_B_ServeMoney    ((u16)0x000F)
#define DataSwipeCard_B_TotalMoney    ((u16)0x0007)

#define TextSwipeCard_B_Tip           ((u16)0x4000)

#define InputSwipeCard_B_Pwd      ((u16)0x3008)

#define VarSwipeCard_B_Position   ((u16)0x003C)
void SwipeCardPaint_B(void)
{
  char Str[64];
  u16 TempU16;

  LcdShowData16(VarSwipeCard_B_Position, 2);

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", CurChgRecd_B.CardNum[0],CurChgRecd_B.CardNum[1],
            CurChgRecd_B.CardNum[2], CurChgRecd_B.CardNum[3], CurChgRecd_B.CardNum[4], CurChgRecd_B.CardNum[5],
            CurChgRecd_B.CardNum[6], CurChgRecd_B.CardNum[7], CurChgRecd_B.CardNum[8], CurChgRecd_B.CardNum[9]);
  LcdShowStr(TextSwipeCard_B_CardNum, (u8*)&Str[0], 20);

  TempU16 = CurChgRecd_B.ChgTime/60;//GetChgMin();
  LcdShowData16(DataSwipeCard_B_ChgMin, TempU16);
  TempU16 = CurChgRecd_B.ChgEnergy/10;
  LcdShowData16(DataSwipeCard_B_ChgEnergy, TempU16);
  TempU16 = BcsMsg_B.CurSoc;
  LcdShowData16(DataSwipeCard_B_Soc, TempU16);

  LcdShowData16(DataSwipeCard_B_EmployMoney, CurChgRecd_B.EmployMoney);
  LcdShowData16(DataSwipeCard_B_EnergyMoney, CurChgRecd_B.EnergyMoney);
  LcdShowData16(DataSwipeCard_B_ServeMoney, CurChgRecd_B.ServeMoney);
  LcdShowData16(DataSwipeCard_B_TotalMoney, CurChgRecd_B.TotalMoney);

  snprintf(Str, sizeof(Str), "ˢ㡣");
  LcdShowStr(TextSwipeCard_B_Tip, (u8*)Str, (strlen(Str)+1));

  LcdShowPage(ScrnSwipeCard_B);
}

void SwipeCardIdle_B(void)
{

}

extern void CloseKeyBoard(void);

#define GetCardTime   (2*1000)     //ȴˢʱ
#define TimeOutTime   (15*1000)    //15S  ˢ

void LcdProSwipeCard_B(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  EnumCardError CardRtn;
  u32 GetCardTick;
  u32 TimeOutTick;
  u32 ScreenChkTick;

  char Str[64];

  StructCardData CardDataTemp = {0};

  ChargePauseFlag_B = 1;

  //IdleLedSet(eSwSta_Off);

  //ChgLedSet(eSwSta_On);

  GetCardTick = GetSystemTick();
  TimeOutTick = GetSystemTick();
  SwipeCardPaint_B();//лҳ

  ScreenChkTick = GetSystemTick();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnSwipeCard_B != Temp)
              LcdShowPage(ScrnSwipeCard_B);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSwipeCard_B_Cancel:   //Aǹ簴ť  ذť
                TimeOutTick = GetSystemTick();
                //pLcdCtrl->CurScreen = eLcdPro_B_ChargeScreen;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_ChargeSummary);
                pLcdCtrl->Param = 0;
                break;
               case BtnSwipeCard_B_Enter:
                CurChgRecd_B.ChgStopType = 1;//ûֹͣ
                ChargeEnable_B = 0;
                pLcdCtrl->CurScreen = eLcdPro_B_PutBack;
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnSwipeCard_B);
                break;
            }
          }
          else if(InputSwipeCard_B_Pwd == Temp)
          {
            /*if((Frame.Ctrl.RdVar.Len < 4) || ((4 == Frame.Ctrl.RdVar.Len) &&  (00 == Frame.Ctrl.RdVar.Data[7])))
            {
            }
            else*/
            {
              //snprintf(Str, sizeof(Str), "%02X%02X", CurChgRecd_B.CardNum[0], CurChgRecd_B.CardNum[1]);
              //snprintf(&Str[4], sizeof(Str)-3, "%02X%02X", CurChgRecd_B.CardNum[8], CurChgRecd_B.CardNum[9]);
              //Str[3] = Str[5];
              //Str[4] = Str[6];
              //Str[6] = Str[7];
              if(0 == (memcmp("848", Frame.Ctrl.RdVar.Data, 3)))
              {
                GetCardTick = GetSystemTick();
                TimeOutTick = GetSystemTick();

                if(0 == CurChgRecd_B.ChgStopType)
                  CurChgRecd_B.ChgStopType = 1;//9;//Աֹͣ	Աֹͣ磬	9

                //pLcdCtrl->CurScreen = eLcdPro_B_PutBack;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_PutBack);

                pLcdCtrl->Param = 0;
              }
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - GetCardTick) > GetCardTime)  //ѯƬ״̬
    {
      if((0x88 == CurChgRecd_B.CardNum[0]) && (0x80 == (CurChgRecd_B.CardNum[1] & 0x80)))
      {
        CardRtn = ReaderMoneyDec(&CurChgRecd_B);
        switch(CardRtn)
        {
          case eCardErr_CheckId_0:
          case eCardErr_ReadCardNum:
          case eCardErr_CheckId_1:
          case eCardErr_ReadValue:
          case eCardErr_ValueDec:
          case eCardErr_CheckId_2:
            GetCardTick = GetSystemTick();
            TimeOutTick = GetSystemTick();
            snprintf(Str, sizeof(Str), "ˢʧܣԡ");
            LcdShowStr(TextSwipeCard_B_Tip, (u8*)Str, (strlen(Str)+1));
            BuzzerRun(2, 80, 80);
            break;
          case eCardErr_CardNumDiffer:
            GetCardTick = GetSystemTick();
            TimeOutTick = GetSystemTick();
            BuzzerRun(2, 80, 80);
            snprintf(Str, sizeof(Str), "Ųһ£ԡ");
            LcdShowStr(TextSwipeCard_B_Tip, (u8*)Str, (strlen(Str)+1));
            break;

          case eCardErr_WriteStatus:
          case eCardErr_Ok:
            GetCardTick = GetSystemTick();
            TimeOutTick = GetSystemTick();
            if(eCardErr_Ok == CardRtn)
              BuzzerRun(1, 80, 80);
            else
              BuzzerRun(3, 80, 80);

            if(0 == CurChgRecd_B.ChgStopType)
              CurChgRecd_B.ChgStopType = 1;//ûֹͣ	ûͨˢֶֹͣѡֹͣ	1

            CurChgRecd_B.MoneyDecFlag = 1;//½

            CurChgRecd_B.WipeStopTime = RtcGetTime();

            //pLcdCtrl->CurScreen = eLcdPro_B_PutBack;
            pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_PutBack);
            pLcdCtrl->Param = 0;
            break;
          default:
            break;
        }
      }
      else
      {
        CardRtn = ReaderGetCard(&CardDataTemp);
        switch(CardRtn)
        {
          case eCardErr_CheckId_0:
          case eCardErr_ReadCardNum:
          case eCardErr_CheckId_1:
          case eCardErr_ReadValue:
          case eCardErr_ValueDec:
          case eCardErr_CheckId_2:
            GetCardTick = GetSystemTick();
            TimeOutTick = GetSystemTick();
            snprintf(Str, sizeof(Str), "ˢʧܣԡ");
            LcdShowStr(TextSwipeCard_B_Tip, (u8*)Str, (strlen(Str)+1));
            BuzzerRun(2, 80, 80);
            break;
          case eCardErr_CardNumDiffer:
            GetCardTick = GetSystemTick();
            TimeOutTick = GetSystemTick();
            snprintf(Str, sizeof(Str), "Ųһ£ԡ");
            LcdShowStr(TextSwipeCard_B_Tip, (u8*)Str, (strlen(Str)+1));
            BuzzerRun(2, 80, 80);
            break;

          //case eCardErr_WriteStatus:
          case eCardErr_Ok:                       //Ƭȷ
            GetCardTick = GetSystemTick();
            TimeOutTick = GetSystemTick();
            if(0 != memcmp(CurChgRecd_B.CardNum, CardDataTemp.CardNum, 10))
            {
              snprintf(Str, sizeof(Str), "Ųһ£ԡ");
              LcdShowStr(TextSwipeCard_B_Tip, (u8*)Str, (strlen(Str)+1));
              BuzzerRun(2, 80, 80);
            }
            else
            {
              BuzzerRun(1, 80, 80);

              if(0 == CurChgRecd_B.ChgStopType)
                CurChgRecd_B.ChgStopType = 1;//ûֹͣ	ûͨˢֶֹͣѡֹͣ	1

              CurChgRecd_B.WipeStopTime = RtcGetTime();

              //pLcdCtrl->CurScreen = eLcdPro_B_PutBack;
              pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_PutBack);
              pLcdCtrl->Param = 0;
            }
            break;
          default:
            break;
        }
      }
    }

    if(eLcdPro_B_SwipeCard != pLcdCtrl->CurScreen)
    {
      ChargePauseFlag_B = 0;
      return;
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      //pLcdCtrl->CurScreen = eLcdPro_B_ChargeScreen;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_ChargeSummary);
      pLcdCtrl->Param = 0;
    }

    SwipeCardIdle_B();

    osDelay(200);
  }
}




