
#include "Thd_Lcd.h"


#define ScrnCardPwd           ((u16)5) //Aǹˢ
#define BtnCardPwd_Cancle     ((u16)0x0501)

#define TextCardPwd_CardNum   ((u16)0x4020)
#define DataCardPwd_Money     ((u16)0x0001)
#define TextCardPwd_Tip       ((u16)0x4000)

#define TextCardPwd_Pwd        ((u16)0x3000)
#define InputCardPwd_Pwd       ((u16)0x3008)

#define VarCardPwd_Position    ((u16)0x003C)
extern void CloseKeyBoard(void);

void CardPwdPaint(void)
{
  char Str[64] = {0};
  LcdShowData16(VarCardPwd_Position, UserParam.ChgFun.Value.Num_B);

  memset(Str, 0xFF, sizeof(Str));
  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", CardData.CardNum[0],CardData.CardNum[1],
    CardData.CardNum[2], CardData.CardNum[3], CardData.CardNum[4], CardData.CardNum[5],
    CardData.CardNum[6], CardData.CardNum[7], CardData.CardNum[8], CardData.CardNum[9]);
  LcdShowStr(TextCardPwd_CardNum, (u8*)Str, strlen(Str)+1);

  LcdShowData32(DataCardPwd_Money, CardData.CardMoney);

  snprintf(Str, sizeof(Str), "***");
  LcdWriteVar(TextCardPwd_Pwd, (u8*)Str, strlen(Str)+1);

  snprintf(Str, sizeof(Str), "롣");
  LcdShowStr(TextCardPwd_Tip, (u8*)Str, strlen(Str)+1);

  LcdShowPage(ScrnCardPwd);
}

void CardPwdIdle(void)
{

}

#define TimeOutTime   (30*1000)

void LcdProCardPwd(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;

  char Str[64] = {0};

  TimeOutTick = GetSystemTick();
  CardPwdPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnCardPwd_Cancle:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
//                pLcdCtrl->CurScreen = eLcdPro_MainMenu;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnCardPwd);
                break;
            }
          }
          else if(InputCardPwd_Pwd == Temp)
          {
            if((Frame.Ctrl.RdVar.Len < 4) || ((4 == Frame.Ctrl.RdVar.Len) &&  (00 == Frame.Ctrl.RdVar.Data[7])))
            {
              snprintf(Str, sizeof(Str), "***");
              LcdWriteVar(TextCardPwd_Pwd, (u8*)Str, strlen(Str)+1);
              snprintf(Str, sizeof(Str), "볤Ȳ㣬䡣");
              LcdShowStr(TextCardPwd_Tip, (u8*)Str, strlen(Str)+1);
            }
            else
            {
              snprintf(Str, sizeof(Str), "******");
              LcdWriteVar(TextCardPwd_Pwd, (u8*)Str, strlen(Str)+1);

              if((0x88 == CardData.CardNum[0]) && (0x80 == (CardData.CardNum[1] & 0x80)))
              {
                if(0 == memcmp(CardData.CardPwd, Frame.Ctrl.RdVar.Data, 6))
                {
                  memset(&CurChgRecd, 0, sizeof(CurChgRecd));
                  memcpy(CurChgRecd.CardNum, CardData.CardNum, 16);
                  memcpy(CurChgRecd.CardPwd, CardData.CardPwd, 6);
                  CurChgRecd.CardRespMoney = CardData.CardMoney;
                  CurChgRecd.StartCardMoney = CardData.CardMoney;
                  CurChgRecd.StopCardMoney = CardData.CardMoney;
                  CurChgRecd.CardValidFlag = 1;
                  pLcdCtrl->CurScreen = eLcdPro_CnctDetect;
                  pLcdCtrl->Param = 0;
                }
                else
                {
                  snprintf(Str, sizeof(Str), "䡣");
                  LcdShowStr(TextCardPwd_Tip, (u8*)Str, strlen(Str)+1);
                  BuzzerRun(3, 200, 100);
                }
              }
              else
              {
                memcpy(CardData.CardPwd, Frame.Ctrl.RdVar.Data, 6);
                pLcdCtrl->CurScreen = eLcdPro_CardSure;//eLcdPro_CnctDetect;
                pLcdCtrl->Param = 0;
              }
            }
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_CardPwd != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      TimeOutTick = GetSystemTick();
//      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    CardPwdIdle();

    osDelay(100);
  }
}



