

#include "Thd_Lcd.h"

#define ScrnLockCard      ((u16)8) //Aǹˢ

#define BtnLockCard_Cancle     ((u16)0x0801)
#define TextLockCard_Tip       ((u16)0x4000)

#define TextLockCard_CardNum   ((u16)0x4020)
#define DataLockCard_CardMoney ((u16)0x0003)

#define VarLockCard_Counter     ((u16)0x0002)

#define VarLockCard_Position    ((u16)0x003C)
void LockCardPaint(void)
{
  char Str[64] = {0};
  LcdShowData16(VarLockCard_Position, UserParam.ChgFun.Value.Num_B);

  LcdShowNum(VarLockCard_Counter, 15);

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", CardData.CardNum[0],CardData.CardNum[1],
    CardData.CardNum[2], CardData.CardNum[3], CardData.CardNum[4], CardData.CardNum[5],
    CardData.CardNum[6], CardData.CardNum[7], CardData.CardNum[8], CardData.CardNum[9]);
  LcdShowStr(TextLockCard_CardNum, (u8*)Str, strlen(Str)+1);

  LcdShowData32(DataLockCard_CardMoney, CardData.CardMoney);

  snprintf(Str, sizeof(Str), "磬ˢ");
  LcdShowStr(TextLockCard_Tip, (u8*)Str, strlen(Str)+1);
  LcdShowPage(ScrnLockCard);
}

void LockCardIdle(void)
{

}

#define GetCardTime   (2*1000)
#define TimeOutTime   (40*1000)

void LcdProLockCard(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  EnumCardError CardRtn;
  u32 GetCardTick;
  u32 TimeOutTick;
  char Str[64] = {0};

  u8 Time = 0;

  GetCardTick = GetSystemTick();
  TimeOutTick = 255;
  LockCardPaint();

  while(1)
  {
    if(TimeOutTick > 0)
      TimeOutTick--;

    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnLockCard_Cancle:  //A ǹ"" 
//                pLcdCtrl->CurScreen = eLcdPro_MainMenu;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnLockCard);
                break;
            }
          }
          break;

        default:
          break;
      }
    }
    if((GetSystemTick() - GetCardTick) > GetCardTime)
    {
      CardRtn = ReaderLockCard(&CardData);
      switch(CardRtn)
      {
        case eCardErr_CheckId_0:                 //
        case eCardErr_ReadCardNum:
        case eCardErr_CheckId_1:
        case eCardErr_ReadValue:
        case eCardErr_ValueDec:
        case eCardErr_CheckId_2:
          GetCardTick = GetSystemTick();
          snprintf(Str, sizeof(Str), "ˢʧܣˢ");
          LcdShowStr(TextLockCard_Tip, (u8*)Str, strlen(Str)+1);
          BuzzerRun(2, 80, 80);
          break;

        case eCardErr_Ok:                      //Ƭ֤OK
          GetCardTick = GetSystemTick();
          memset(&CurChgRecd, 0, sizeof(CurChgRecd));
          memcpy(CurChgRecd.CardNum, CardData.CardNum, 16);
          memcpy(CurChgRecd.CardPwd, CardData.CardPwd, 6);
          CurChgRecd.CardRespMoney = CardData.CardMoney;
          CurChgRecd.StartCardMoney = CardData.CardMoney;
          CurChgRecd.StopCardMoney = CardData.CardMoney;
          CurChgRecd.CardValidFlag = 1;
          BuzzerRun(1, 80, 80);

          pLcdCtrl->CurScreen = eLcdPro_BuildComm;
          pLcdCtrl->Param = 0;
          break;
        case eCardErr_CardNumDiffer:
          GetCardTick = GetSystemTick();
          snprintf(Str, sizeof(Str), "Ųһ£ˢ");
          LcdShowStr(TextLockCard_Tip, (u8*)Str, strlen(Str)+1);
          BuzzerRun(2, 80, 80);
          break;
        default:
          break;
      }
    }

    if(eLcdPro_LockCard != pLcdCtrl->CurScreen)
      return;

    if((TimeOutTick) < 1)
    {
//      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    Temp = TimeOutTick/10;
    if(Time != Temp)
    {
      Time = Temp;
      LcdShowNum(VarLockCard_Counter, Time);
    }

    LockCardIdle();

    osDelay(100);
  }
}



