
#include "Thd_Lcd.h"

#define ScrnSingleChargeScreen  ((u16)10)
#define BtnSinChargeScreen_Cancel      ((u16)0x1001)
#define BtnSinChargeScreen_Menu        ((u16)0x1002)

#define TxtSinChargeScreen_CardNum         ((u16)0x4020)//Aǹ翨
#define VarSinChargeScreen_CardMoney       ((u16)0x0003) //Aǹʣ

#define VarSinChargeScreenr_EmployRate     ((u16)0x002D)
#define VarSinChargeScreenr_FreeTime       ((u16)0x002E)

#define VarSinChargeScreenr_TotalMoney     ((u16)0x0007)
#define VarSinChargeScreen_energyRate      ((u16)0x0008)

#define DataSinChargeScreen_Volt               ((u16)0x0021)
#define DataSinChargeScreen_Currt              ((u16)0x0022)
#define DataSinChargeScreen_RemainMin          ((u16)0x0024)
#define DataSinChargeScreen_ChgMin             ((u16)0x0006)
#define DataSinChargeScreen_ChgEnergy          ((u16)0x0005)
#define DataSinChargeScreen_Soc                ((u16)0x0023)

#define TextSinChargeScreen_ChgStatus             ((u16)0x4120)
#define TextSinChargeScreen_DevStatus             ((u16)0x4140)

#define AnimSinChargeScreen_Charge             ((u16)0x001A)

void SinChargeScreenPaint(void)
{
  char Str[64];
  u32 Temp,Temp1;
  u16 TempU16;

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", CurChgRecd.CardNum[0],CurChgRecd.CardNum[1],
            CurChgRecd.CardNum[2], CurChgRecd.CardNum[3], CurChgRecd.CardNum[4], CurChgRecd.CardNum[5],
            CurChgRecd.CardNum[6], CurChgRecd.CardNum[7], CurChgRecd.CardNum[8], CurChgRecd.CardNum[9]);
  LcdShowStr(TxtSinChargeScreen_CardNum, (u8*)&Str[0], (strlen(Str)+1));
  LcdShowData32(VarSinChargeScreen_CardMoney, CurChgRecd.CardRespMoney);

  LcdShowData16(VarSinChargeScreenr_EmployRate, UserParam.EmployRate);
  LcdShowData16(VarSinChargeScreenr_FreeTime, UserParam.FreeTime);

  LcdShowData16(VarSinChargeScreenr_TotalMoney, CurChgRecd.TotalMoney);

  //ȡʣ
  Temp = RtcGetTime()%(24*3600);//Сʱ
  Temp1=Temp = Temp/1800;//30
  if((UserParam.EnergyTimeRate[Temp] > 0) && (UserParam.EnergyTimeRate[Temp] < 5))
    Temp = UserParam.EnergyTimeRate[Temp] - 1;
  else
    Temp = 0;

   if((UserParam.ServerTimeRate[Temp1] > 0) && (UserParam.ServerTimeRate[Temp1] < 5))
    Temp1 = UserParam.ServerTimeRate[Temp1] - 1;
  else
    Temp1 = 0;
  LcdShowData16(VarSinChargeScreen_energyRate, UserParam.EnergyRate[Temp] + UserParam.ServerRate2[Temp1]);

  TempU16 = CurChgRecd.ChgTime/60;//GetChgMin();
  LcdShowData16(DataSinChargeScreen_ChgMin, TempU16);
  TempU16 = CurChgRecd.ChgEnergy/10;
  LcdShowData16(DataSinChargeScreen_ChgEnergy, TempU16);
  TempU16 = BcsMsg.CurSoc;
  LcdShowData16(DataSinChargeScreen_Soc, TempU16);

  TempU16 = GetDcModuleVolt();
  LcdShowData16(DataSinChargeScreen_Volt, TempU16);
  TempU16 = GetDcModuleCurrt();
  LcdShowData16(DataSinChargeScreen_Currt, TempU16);
  TempU16 = BcsMsg.RemainMin;
  LcdShowData16(DataSinChargeScreen_RemainMin, TempU16);

  if((eChgPro_ChgIdle == ChargeCtrl.CurProcess)
      || (eChgPro_ChgStop == ChargeCtrl.CurProcess)
      || (eChgPro_ChgBreak == ChargeCtrl.CurProcess)
      || (eChgPro_CommError == ChargeCtrl.CurProcess))
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(AnimSinChargeScreen_Charge, TempU16);

  switch(ChargeStopType)
  {
//    case eChgStop_None:
//      snprintf(Str, sizeof(Str), "ڳ");
//      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
//      snprintf(Str, sizeof(Str), "");
//      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
//      break;

    case eChgStop_Shake_UserCancel:
    case eChgStop_Imd_UserCancel:
    case eChgStop_Reco_UserCancle:
    case eChgStop_Conf_UserCancel:
    case eChgStop_BmsReady_UserCancel:
    case eChgStop_PillarReady_UserCancel:
    case eChgStop_Start_UserCancel:
    case eChgStop_ComBreak_UserCancel:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ûȡ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Shake_CcOpen:
    case eChgStop_Imd_CcOpen:
    case eChgStop_Reco_CcOpen:
    case eChgStop_Conf_CcOpen:
    case eChgStop_BmsReady_CcOpen:
    case eChgStop_PillarReady_CcOpen:
    case eChgStop_Start_CcOpen:
    case eChgStop_Run_CcOpen:
    case eChgStop_ComBreak_CcOpen:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ӶϿ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Shake_EmerClose:
    case eChgStop_Imd_EmerClose:
    case eChgStop_Reco_EmerClose:
    case eChgStop_Conf_EmerClose:
    case eChgStop_BmsReady_EmerClose:
    case eChgStop_PillarReady_EmerClose:
    case eChgStop_Start_EmerClose:
    case eChgStop_Run_EmerClose:
    case eChgStop_ComBreak_EmerClose:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ͣť");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Conf_DoorOpen:
    case eChgStop_Reco_DoorOpen:
    case eChgStop_Run_DoorOpen:
    case eChgStop_Start_DoorOpen:
    case eChgStop_ComBreak_DoorOpen:
    case eChgStop_Imd_DoorOpen:
    case eChgStop_Shake_DoorOpen:
    case eChgStop_BmsReady_DoorOpen:
    case eChgStop_PillarReady_DoorOpen:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "׮Ŵ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Conf_Contactor:
    case eChgStop_Reco_Contactor:
    case eChgStop_Run_Contactor:
    case eChgStop_Start_Contactor:
    case eChgStop_ComBreak_Contactor:
    case eChgStop_Imd_Contactor:
    case eChgStop_Shake_Contactor:
    case eChgStop_BmsReady_Contactor:
    case eChgStop_PillarReady_Contactor:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ֱӴ쳣");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Conf_InVolt:
    case eChgStop_Reco_InVolt:
    case eChgStop_Run_InVolt:
    case eChgStop_Start_InVolt:
    case eChgStop_ComBreak_InVolt:
    case eChgStop_Imd_InVolt:
    case eChgStop_Shake_InVolt:
    case eChgStop_BmsReady_InVolt:
    case eChgStop_PillarReady_InVolt:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ѹ쳣");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Conf_NoDcmod:
    case eChgStop_Reco_NoDcmod:
    case eChgStop_Run_NoDcmod:
    case eChgStop_Start_NoDcmod:
    case eChgStop_ComBreak_NoDcmod:
    case eChgStop_Imd_NoDcmod:
    case eChgStop_Shake_NoDcmod:
    case eChgStop_BmsReady_NoDcmod:
    case eChgStop_PillarReady_NoDcmod:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "޳ģ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Conf_Meter:
    case eChgStop_Reco_Meter:
    case eChgStop_Run_Meter:
    case eChgStop_Start_Meter:
    case eChgStop_ComBreak_Meter:
    case eChgStop_Imd_Meter:
    case eChgStop_Shake_Meter:
    case eChgStop_BmsReady_Meter:
    case eChgStop_PillarReady_Meter:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ֱ쳣");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Conf_StartSoc98:
      snprintf(Str, sizeof(Str), "%d ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "Soc");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Conf_BatVoltOverPermitMax:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "صѹѹ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Conf_StartVoltOverPillarMax:
    case eChgStop_PillarReady_BatVoltOverPillarMax:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "صѹڳ׮ѹ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Start_BmsStop:
    case eChgStop_Run_BmsStop:
      snprintf(Str, sizeof(Str), "%d ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "Bmsֹͣ%02X %04X %02X", BstMsg.StopReason.Mult, BstMsg.StopTruble.Mult, BstMsg.StopFault.Mult);
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_Soc98:
      snprintf(Str, sizeof(Str), "%d ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "Ѿ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_ComBreak_CurtError:
      snprintf(Str, sizeof(Str), "%d ֹ%04X %04X", ChargeStopType, BemMsg.Bem.Mult, CemMsg.Cem.Mult);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "쳣");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_ComBreak_BmsStop:
      snprintf(Str, sizeof(Str), "%d ֹ%08X %08X", ChargeStopType, BemMsg.Bem.Mult, CemMsg.Cem.Mult);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "Bmsֹͣ%02X %04X %02X", BstMsg.StopReason.Mult, BstMsg.StopTruble.Mult, BstMsg.StopFault.Mult);
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Imd_BhmTimeOut:
    case eChgStop_ComBreak_CommError:
      snprintf(Str, sizeof(Str), "%d ֹ%08X %08X", ChargeStopType, BemMsg.Bem.Mult, CemMsg.Cem.Mult);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ͨŹ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Imd_IsolateError:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "׮Ե");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Run_SinglBatVoltOverPermitMax:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "صѹֵ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Run_SinglBatVolt:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "صѹ쳣");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_SocOver:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "SOC쳣");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_CurrtOver:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "س쳣");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_BatTempOver:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "¶ȹ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_BatIsolate:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ؾԵ쳣");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_Cc2Error:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "Ӽ쳣");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_BmsPause:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ͣʱ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Conf_ChgMaxVoltLessPillarMinVolt:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "ѹƥ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_PillarReady_BatVoltError:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_PillarReady_BatVoltMismatchBcpVolt:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "Bcpѹʵʲ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_VoltOutHighErr:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "׮ѹ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
    case eChgStop_Run_CurrtOutHighErr:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      snprintf(Str, sizeof(Str), "׮");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    case eChgStop_Run_UserCancel:
      snprintf(Str, sizeof(Str), "%d ֹ", ChargeStopType);
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));
      if(CurChgRecd.TotalMoney >= CurChgRecd.CardRespMoney)
        snprintf(Str, sizeof(Str), "");
      else
        snprintf(Str, sizeof(Str), "ûȡ");
      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;

    default:
      if(eChgPro_ChgIdle == ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "ֹͣ");
      else if (eChgPro_ChgStop == ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "");
      else if(eChgPro_ChgBreak == ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "ֹ");
      else if(eChgPro_CommError== ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "ֹ");
      else
        snprintf(Str, sizeof(Str), "ڳ");
      LcdShowStr(TextSinChargeScreen_ChgStatus, (u8*)Str, (strlen(Str)+1));

      if(1 == ChargeError.Value.IsolateError)
        snprintf(Str, sizeof(Str), "׮Ե");
      else if(1 == ChargeError.Value.IsolateWarn)
        snprintf(Str, sizeof(Str), "ԵС");
      else if(1 == ChargeError.Value.DrainResist)
        snprintf(Str, sizeof(Str), "йŵ辯");
      else if(eChgPro_ChgIdle == ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "鳵׮Ƿƥ");
      else if (eChgPro_ChgStop == ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "鳵׮Ƿƥ");
      else if(eChgPro_ChgBreak == ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "鳵׮Ƿƥ");
      else if(eChgPro_CommError== ChargeCtrl.CurProcess)
        snprintf(Str, sizeof(Str), "鳵׮Ƿƥ");
      else
        snprintf(Str, sizeof(Str), "");

      LcdShowStr(TextSinChargeScreen_DevStatus, (u8*)Str, (strlen(Str)+1));
      break;
  }

  LcdShowPage(ScrnSingleChargeScreen);
}

typedef struct
{
  u32 RePainTick;
}StructChargeScreenUpdate;

void SinChargeScreenUpdate(StructChargeScreenUpdate *pUpdate)
{
  if((GetSystemTick() - pUpdate->RePainTick) >= 1590)
  {
    pUpdate->RePainTick = GetSystemTick();

    SinChargeScreenPaint();
  }
}

u32 SinUnconnectTick;
#define UnconnectTime   (3500)//20S   //ⲻCC/CP Ͽֹͣ 

void LcdProSingleChargeScreen(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  StructChargeScreenUpdate Update;

  u32 BtnManageTick;
  u8  BtnManageCounter;

  StructTime Time;
  u32 TimeSynTick;

  u32 TempRecdTick;

  TempChgRecdSaveToLog(&CurChgRecd, 1, 1);
  TempRecdTick = GetSystemTick();

  //IdleLedSet(eSwSta_Off);
  //ChgLedSet(eSwSta_On);

  ScreenChkTick = GetSystemTick();

  SinChargeScreenPaint();
  Update.RePainTick = GetSystemTick();

  BtnManageTick = GetSystemTick();
  BtnManageCounter = 0;

  TimeSynTick = GetSystemTick();
  LcdGetRtc();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnSingleChargeScreen != Temp)
              LcdShowPage(ScrnSingleChargeScreen);
          }
          else if(eLcdRegAddr_Rtc == Frame.Ctrl.RdReg.Addr)
          {
            Time.Year = 2000 + BcdToHex(Frame.Ctrl.RdReg.Data[0]);          //  
            Time.Mon = BcdToHex(Frame.Ctrl.RdReg.Data[1] & 0x1F);      //  
            Time.Day = BcdToHex(Frame.Ctrl.RdReg.Data[2] & 0x3F);      //  
                    //Frame.Ctrl.RdReg.Data[3]
            Time.Hour = BcdToHex(Frame.Ctrl.RdReg.Data[4] & 0x3F);      //  Сʱ
            Time.Min = BcdToHex(Frame.Ctrl.RdReg.Data[5] & 0x7F);      //  
            Time.Sec = BcdToHex(Frame.Ctrl.RdReg.Data[6] &0x7F);      //  

            RtcSetTime(GetExtOrLcdStamp(&Time));
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSinChargeScreen_Cancel:
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_SwipeCard);
                //pLcdCtrl->CurScreen = eLcdPro_PutBack;
                pLcdCtrl->Param = 0;
                break;
              case BtnSinChargeScreen_Menu:
                if((GetSystemTick() - BtnManageTick) >= 1000)
                  BtnManageCounter = 0;
                else
                {
                  BtnManageCounter++;
                  if(BtnManageCounter > 2)
                  {
                    pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_BmsInfor);
                    pLcdCtrl->Param = 0;
                  }
                }
                BtnManageTick = GetSystemTick();
                break;
              default:
                LcdShowPage(ScrnSingleChargeScreen);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if(eSwSta_On != CcStatusRead())
    {
      if(0 == SinUnconnectTick)
        SinUnconnectTick = GetSystemTick();
    }
    else
      SinUnconnectTick = 0;
    if((0 != SinUnconnectTick) && (GetSystemTick() - SinUnconnectTick) > UnconnectTime)
    {
      CurChgRecd.ChgStopType = 4;//ǹֹͣ  "׮CC/CPźŶϿֱ׮CC1ȷ϶Ͽ"  4

      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_PutBack);
      pLcdCtrl->Param = 0;
    }

    //if((1 == CurChgRecd.CardValidFlag) && (CurChgRecd.TotalMoney >= CurChgRecd.CardRespMoney))
    if(CurChgRecd.TotalMoney >= (CurChgRecd.CardRespMoney - UserParam.BalanceMoney))
    {
      ChargeEnable = 0;
      CurChgRecd.ChgStopType = 5;//ֹͣ  ôﵽ˻ֹͣ  5
    }

    if(eLcdPro_SingleChargeScreen != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if((GetSystemTick() - TimeSynTick) >= RtcSynTime)
    {
      TimeSynTick = GetSystemTick();
      LcdGetRtc();
    }

    if((GetSystemTick() - TempRecdTick) > 60*1000)
    {
      TempChgRecdSaveToLog(&CurChgRecd, 1, 1);
      TempRecdTick = GetSystemTick();
    }

    SinChargeScreenUpdate(&Update);

    osDelay(100);
  }
}




