
#ifndef __THD_CHARGE_B_H__
#define __THD_CHARGE_B_H__
#include "Drv_TCUComm.h"
#include "Thd_TcuControl.h"


#include "Global.h"
#include "Drv_Adc.h"

#define CC_CheckTick_B    (100)
#define MsgTimeout_B_1S   (1000+200)
#define MsgTimeout_B_5S   (5000+500)
#define MsgTimeout_B_10S  (10*1000+3000)
#define MsgTimeout_B_60S  (60*1000+3000)
#define MsgTimeout_B_10M  (10*60*1000+3000)

typedef enum
{
  eChgPro_B_ChgIdle = 0,
  eChgPro_B_ShakeHand,

  eChgPro_B_ImdCheck,
  eChgPro_B_ChgRecognizeEx,

  eChgPro_B_ChgRecognize,
  eChgPro_B_ChgConfigure,
  eChgPro_B_WaitBmsReady,
  eChgPro_B_WaitPillarReady,
  eChgPro_B_ChgStart,
  eChgPro_B_ChgRun,
  eChgPro_B_WaitVoltChgRun,
  eChgPro_B_ChgStop,
  eChgPro_B_CommBreak,
  eChgPro_B_CommError,
  eChgPro_B_ChgBreak,
  eChgPro_B_Max,
}EnumChargeProcess_B;

typedef struct
{
  EnumChargeProcess_B CurProcess;
  //EnumChargeProcess_B AimStep;
  void *Param;
}StructChargeCtrl_B;

typedef void (*pChargeCtrlHandle_B)(StructChargeCtrl_B *pChgCtrl);


extern u8 ChargeEnable_B;
extern u8 ChargePauseFlag_B;
extern StructChargeCtrl_B ChargeCtrl_B;

extern s32 StartChgEnergy_B;
extern s32 StopChgEnergy_B;

extern EnumChgStopType ChargeStopType_B;

extern u8 CommErrorCount_B;
extern u32 CommErrFrame_B[4];

extern u32 ChargeTimeCount_B;//
extern void ChargeTimerSet_B(EnumSwitchStatus OnOff);
u16 GetChgMin_B(void);
extern u32 GetChgSec_B(void);
extern void CleanChgTimeCnt_B(void);


#endif

