#ifndef __THD_TCU_H__
#define __THD_TCU_H__

#include "Global.h"
#include "Drv_TCUComm.h"
#include "Thd_TcuControl.h"

#define CONNECT_NORMAL 0
#define CONNECT_TIMEOUT 1

typedef enum
{
  HeartStage      =0,//׶Ĭ
  VersionStage    = 1,
  ChageParamStage = 2,
  TimeStage        = 3,
  ServiceContralStage = 4,
  ElectLockStage   = 5,
  PowerControlStage = 6,
  ChgInfornQueryStage = 7,
}EnumTCUCommStage;

typedef struct
{
  EnumTCUCommStage CommStage;
  u8 ChgNum;
  u32 VersionRecvTime;
  u32 VersionSentTime;
  u8  VerChkVaild;

  u32 ParamRecvTime;
  u32 ParamSentTime;
  u8  ParamVaild;
  
  u32 TimeRecvTime;
  u32 TimeSentTime;
  
  u32 ServiceContralRecvTime;
  u32 ServiceContralSentTime;
  u8  ChargingServiceSetValue;//·ֵ
  u8  ServiceContralVaildValue;//·ʧԭ 0ɹ
  
  u32 ElectLockRecvTime;
  u32 ElectLockSentTime;
  u8  ElectLockSetValue;//·ֵ
  u8  ElectLockVaildValue;//·ʧԭ 0ɹ
  
  u32 PowerControlRecvTime;
  u32 PowerControlSentTime;
  u8  PowerControltype;
  u16 PowerControlParam;
  u8  PowerControlVaildValue;//ʵʧԭ
  	
  u32 ChgInfornQueryRecvTime;
  u32 ChgInfornQuerySentTime;
  
  u8  ConnectFlag;//0 δ 
  u8  HeartBeatVaild;//Ч־λ
  u8  HeartBeatErrCnt;
  u8  HeartBeatErrCnt_B;
  u16 HeartBeatNumCnt;
  u16 HeartBeatLoseCnt;
  
  u32 HeartBeatSendTime;
  u32 HeartBeatSendTime_B;
  u32 HeartBeatRecvTime;
  u32 HeartBeatRecvTime_B;

  u32 DCConInforSendTime;
  u32 DCConInforSendTime_B;
  
  u32 DCMeasuSendTime;
  u32 DCMeasuSendTime_B;
  u32 DCMeasuRecvTime;
  u32 DCMeasuRecvTime_B;
  u32 DCMeasuErrCnt;
  u32 DCMeasuErrCnt_B;
  
  UnionConEM ErrData;
  UnionConEM ErrData_B;
  
  u8 ConEMSendFlag;
  u8 ConEMSendFlag_B;

}StructTCUCommuStatus;

	
typedef struct
{
  u8 HeartPeriod;//
  u8 HeartErrCntMax;//
  u8 HeartTimeout;//
  u16 SignInPeriod;//
  
}StructTCUCommuParam;



extern StructTCUCommuStatus TCUCommuStatus;

extern void TCUComm(void const *argument);
#endif


