
#include "Thd_Lcd.h"
#include "Drv_TCUComm.h"
#include "Thd_TcuControl.h"

StructTCUCtrl TCUCtrl;


StructTCUChgRecd TCUCurChgRecd = {0};
StructTCUChgRecd TCUCurChgRecd_B = {0};
EnumTCUProcess GetTCUProcess(EnumTCUProcess LcdPro)
{
  static EnumTCUProcess historyLcdPro = eLcdPro_TCUMainMenu;
  static EnumTCUProcess historyLcdPro_B = eLcdPro_TCUMainMenu;
  EnumTCUProcess tempLcdProcess = eLcdPro_TCUMainMenu;

  tempLcdProcess = LcdPro;
  switch(LcdPro)
  {
    case eLcdPro_TCUMainMenu:
      if(eLcdPro_TCUChargeSummary == historyLcdPro)
      {
        historyLcdPro_B = eLcdPro_TCUMainMenu;
        tempLcdProcess = eLcdPro_TCUChargeSummary;
      }
      else if(eLcdPro_TCUChargeSummary_B == historyLcdPro_B)
      {
        historyLcdPro = eLcdPro_TCUMainMenu;
        tempLcdProcess = eLcdPro_TCUChargeSummary_B;
      }
      else
      {
        historyLcdPro = eLcdPro_TCUMainMenu;
        historyLcdPro_B = eLcdPro_TCUMainMenu;
        tempLcdProcess = eLcdPro_TCUMainMenu;
      }
      break;
   
    case eLcdPro_ChargeSummary:
       if(eLcdPro_TCUChargeSummary_B == historyLcdPro_B)
        tempLcdProcess = eLcdPro_TCUChargeSummary_AB;
      else
        tempLcdProcess =  eLcdPro_TCUChargeSummary;
    
    case eLcdPro_PutBack:

      historyLcdPro = LcdPro;

      break;
    case eLcdPro_B_ChargeSummary:
      if(eLcdPro_TCUChargeSummary == historyLcdPro)
        tempLcdProcess = eLcdPro_TCUChargeSummary_AB;
      else
        tempLcdProcess = eLcdPro_TCUChargeSummary_B;
    
    case eLcdPro_B_PutBack:

      historyLcdPro_B = LcdPro;
      break;
    default:
      tempLcdProcess = LcdPro;
      break;
  }
  return tempLcdProcess;
}


void TCUProMainMenu(StructTCUCtrl *pLcdCtrl)
{
 LockSet(eSwSta_Off);
 LockSet_B(eSwSta_Off);
 while(1)
 {
   if(eLcdPro_TCUMainMenu != pLcdCtrl->CurScreen)
      return;  
    osDelay(100);
 }
}
void TCUProPrstart(StructTCUCtrl *pLcdCtrl)
{
  while(1)
  {
   if(TCUCurChgRecd.StarChgResult== 1)//
   {
   	 TCUCurChgRecd.TCUChargeEnable = 1;
	   pLcdCtrl->CurScreen =eLcdPro_TCUBuildComm;
	   TCUCurChgRecd.StarChgResult= 0;
   }
   else if(TCUCurChgRecd.StarChgResult== 2)//ʧ
   {
   	 pLcdCtrl->CurScreen = GetTCUProcess(eLcdPro_TCUMainMenu);
	   TCUCurChgRecd.StarChgResult= 0;
   }
  if(eLcdPro_TCUPrstart!= pLcdCtrl->CurScreen)
    return;  
   osDelay(100);
  }
}
void TCUProPrstart_B(StructTCUCtrl *pLcdCtrl)
{
  while(1)
  {
   if(TCUCurChgRecd_B.StarChgResult== 1)//
   {
   	TCUCurChgRecd_B.TCUChargeEnable = 1;
  	pLcdCtrl->CurScreen = eLcdPro_TCUBuildComm_B;
	  TCUCurChgRecd_B.StarChgResult= 0;
   }
   else if(TCUCurChgRecd_B.StarChgResult== 2)//ʧ
   {
   	  pLcdCtrl->CurScreen = GetTCUProcess(eLcdPro_TCUMainMenu);
	  TCUCurChgRecd_B.StarChgResult= 0;
   }
  if(eLcdPro_TCUPrstart_B!= pLcdCtrl->CurScreen)
    return;  
   osDelay(100);
  }
}
void TCUBuildComm(StructTCUCtrl *pLcdCtrl)
{
  while(1)
  {
   if(eLcdPro_TCUBuildComm!= pLcdCtrl->CurScreen)
     return;  
   switch(ChargeCtrl.CurProcess)
    {
      case eChgPro_ChgRun:
      case eChgPro_WaitVoltChgRun:
        pLcdCtrl->CurScreen = GetTCUProcess(eLcdPro_TCUChargeSummary);
        pLcdCtrl->Param = 0;
	    TCUCurChgRecd.TCUStartCompresult = 1;//ɹ
	    TCUCurChgRecd.TCUChgStarCompNotetrl =1;//ʼ֡ͱ־
        break;
      case eChgPro_ChgStop://BMSֹͣ
      case eChgPro_CommError://ͨѶʧ
      case eChgPro_ChgBreak://Ӳ쳣
        TCUCurChgRecd.TCUStartCompresult = 2;//ʧ
        TCUCurChgRecd.TCUChgStarCompNotetrl =1;//ʼ֡ͱ־
        pLcdCtrl->CurScreen = GetTCUProcess(eLcdPro_TCUMainMenu);
        pLcdCtrl->Param = 0;
        break;
      default:
        break;
   	}
  }
}
void TCUBuildComm_B(StructTCUCtrl *pLcdCtrl)
{
  while(1)
  {
  if(eLcdPro_TCUBuildComm_B!= pLcdCtrl->CurScreen)
    return;

  switch(ChargeCtrl_B.CurProcess)
   {
     case eChgPro_ChgRun: 
     case eChgPro_WaitVoltChgRun:
       pLcdCtrl->CurScreen = GetTCUProcess(eLcdPro_TCUChargeSummary_B);
        pLcdCtrl->Param = 0;
	    TCUCurChgRecd_B.TCUStartCompresult = 1;//ɹ
	    TCUCurChgRecd_B.TCUChgStarCompNotetrl =1;//ʼ֡ͱ־
       break;
     case eChgPro_ChgStop://BMSֹͣ
     case eChgPro_CommError://ͨѶ
     case eChgPro_ChgBreak://Ӳ쳣
        TCUCurChgRecd_B.TCUStartCompresult = 2;//ʧ
        TCUCurChgRecd_B.TCUChgStarCompNotetrl =1;//ʼ֡ͱ־
        pLcdCtrl->CurScreen = GetTCUProcess(eLcdPro_TCUMainMenu);
        pLcdCtrl->Param = 0;
       break;
      default:
        break;
   }
 }
}


void TCUChargeSummary(StructTCUCtrl *pLcdCtrl)
{
  while(1)
  {
   if(eLcdPro_TCUChargeSummary!= pLcdCtrl->CurScreen)
    return;
   switch(ChargeCtrl.CurProcess)
   {
    case eChgPro_ChgStop://BMSֹͣ
    case eChgPro_CommError://ͨѶʧ
    case eChgPro_ChgBreak://Ӳ쳣
      TCUCurChgRecd.TCUChgStopCompNotetrl= 1;//ֹͣ֡
      pLcdCtrl->CurScreen = GetTCUProcess(eLcdPro_TCUMainMenu);
      pLcdCtrl->Param = 0;
    break;
    default:
    break;
   }
  }
}
void TCUChargeSummary_B(StructTCUCtrl *pLcdCtrl)
{
  while(1)
  {
   if(eLcdPro_TCUChargeSummary_B!= pLcdCtrl->CurScreen)
    return;
   switch(ChargeCtrl_B.CurProcess)
   {
    case eChgPro_ChgStop://BMSֹͣ
    case eChgPro_CommError://ͨѶʧ
    case eChgPro_ChgBreak://Ӳ쳣
      TCUCurChgRecd_B.TCUChgStopCompNotetrl= 1;//ֹͣ֡
      pLcdCtrl->CurScreen = GetTCUProcess(eLcdPro_TCUMainMenu);
      pLcdCtrl->Param = 0;
      
    break;
    default:
    break;
  }
 }
  
}
void TCUChargeSummary_AB(StructTCUCtrl *pLcdCtrl)
{
 while(1)
 {
  if(eLcdPro_TCUChargeSummary_AB!= pLcdCtrl->CurScreen)
    return;
   switch(ChargeCtrl.CurProcess)
   {
    case eChgPro_ChgStop://BMSֹͣ
    case eChgPro_CommError://ͨѶʧ
    case eChgPro_ChgBreak://Ӳ쳣
      TCUCurChgRecd.TCUChgStopCompNotetrl= 1;//ֹͣ֡
      pLcdCtrl->CurScreen = GetTCUProcess(eLcdPro_TCUMainMenu);
      pLcdCtrl->Param = 0;
    break;
    default:
    break;
   }
   switch(ChargeCtrl_B.CurProcess)
   {
    case eChgPro_ChgStop://BMSֹͣ
    case eChgPro_CommError://ͨѶʧ
    case eChgPro_ChgBreak://Ӳ쳣
      TCUCurChgRecd_B.TCUChgStopCompNotetrl= 1;//ֹͣ֡
      pLcdCtrl->CurScreen = GetTCUProcess(eLcdPro_TCUMainMenu);
      pLcdCtrl->Param = 0;
    break;
    default:
    break;
  }
 }
}
#if 0
void TCUChargeStop(StructTCUCtrl *pLcdCtrl)
{
 if(eLcdPro_TCUChargeStop!= pLcdCtrl->CurScreen)
    return;
}
void TCUChargeStopComp(StructTCUCtrl *pLcdCtrl)
{
 if(eLcdPro_TCUChargeStopComp!= pLcdCtrl->CurScreen)
    return;
}
void TCUChargeStop_B(StructTCUCtrl *pLcdCtrl)
{
 if(eLcdPro_TCUChargeStop_B!= pLcdCtrl->CurScreen)
    return;
}
void TCUChargeStopComp_B(StructTCUCtrl *pLcdCtrl)
{
 if(eLcdPro_TCUChargeStopComp_B!= pLcdCtrl->CurScreen)
    return;
}
#endif 	
const pTCUCtrlHandle TCUCtrlHandle[] =
{
  TCUProMainMenu,
  TCUProPrstart,
  TCUProPrstart_B,
  TCUBuildComm,
  TCUBuildComm_B,
  TCUChargeSummary,
  TCUChargeSummary_B,
  TCUChargeSummary_AB,
  
  TCUProMainMenu,
};



#if 0
vu32 RtcTimeCounter = 0;

extern vu32 RtcTimeCounter;

u32 RtcGetTime(void)
{
  return RtcTimeCounter;
}

/******************************************************************************
  : DateTimeSet
  : ʱڳʼ
  : TimeStamp ʱ
  : 
******************************************************************************/
void RtcSetTime(u32 TimeStamp)
{
  RtcTimeCounter = TimeStamp;
}

#define _DAY_SEC_        ((u32)(60*60*24))
#define _YEAR_SEC_       ((u32)(_DAY_SEC_ * 365))
#define _FOUR_YEAR_SEC_  ((u32)(_YEAR_SEC_ * 4 + _DAY_SEC_))

/******************************************************************************
  : StampToTime
  : ʱתʱ
  : TimeStamp -- תʱ
        pTimeBlock -- תʱṹָ
  : 
******************************************************************************/
void StampToTime(u32 TimeStamp, StructTime *pTimeBlock)
{
  const int MonDays[][13] =
  {
    {-1, 30, 58, 89, 119, 150, 180, 211, 242, 272, 303, 333, 364},
    {-1, 30, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365}
  };

  u8 LeapYearFlag = 0;                 /* is-current-year-a-leap-year flag */
  u32 TmpCount;
  u32 YearDay;

  TmpCount = TimeStamp / _FOUR_YEAR_SEC_;
  TimeStamp -= TmpCount * _FOUR_YEAR_SEC_;

  /*
  * Determine which year of the interval
  */
  TmpCount = (TmpCount * 4) + 70;         /* 1970, 1974, 1978,...,etc. */
  if(TimeStamp >= _YEAR_SEC_)
  {
    TmpCount++;                       /* 1971, 1975, 1979,...,etc. */
    TimeStamp -= _YEAR_SEC_;
    if(TimeStamp >= _YEAR_SEC_)
    {
      TmpCount++;                   /* 1972, 1976, 1980,...,etc. */
      TimeStamp -= _YEAR_SEC_;
      /*
      * Note, it takes 366 days-worth of seconds to get past a leap
      * year.
      */
      if(TimeStamp >= (_YEAR_SEC_ + _DAY_SEC_))
      {
        TmpCount++;           /* 1973, 1977, 1981,...,etc. */
        TimeStamp -= (_YEAR_SEC_ + _DAY_SEC_);
      }
      else
      {
        /*
        * In a leap year after all, set the flag.
        */
        LeapYearFlag = 1;
      }
    }
  }

  /*
  * TmpCount now holds the value for tm_year. TimeStamp now holds the
  * number of elapsed seconds since the beginning of that year.
  */
  pTimeBlock->Year = TmpCount + 1900;

  /*
  * Determine days since January 1 (0 - 365). This is the tm_yday value.
  * Leave TimeStamp with number of elapsed seconds in that day.
  */
  YearDay = TimeStamp / _DAY_SEC_;
  TimeStamp -= YearDay * _DAY_SEC_;

  /*
  * Determine months since January (0 - 11) and day of month (1 - 31)
  */
  for(TmpCount = 1; MonDays[LeapYearFlag][TmpCount] < YearDay; TmpCount++ )
  {
  }
  pTimeBlock->Mon = TmpCount;
  pTimeBlock->Day = YearDay - MonDays[LeapYearFlag][--TmpCount];

  /*
  *  Determine hours since midnight (0 - 23), minutes after the hour
  *  (0 - 59), and seconds after the minute (0 - 59).
  */
  pTimeBlock->Hour = TimeStamp / 3600;
  TimeStamp -= pTimeBlock->Hour * 3600;
  pTimeBlock->Min = TimeStamp / 60;
  pTimeBlock->Sec = TimeStamp - pTimeBlock->Min * 60;
}

/******************************************************************************
  : TimeToStamp
  : ʱתʱ
  : pTimeBlock -- תʱṹָ
  : 32λʱ
******************************************************************************/
u32 TimeToStamp(StructTime *pTimeBlock)
{
  u32 Year = pTimeBlock->Year;
  u32 Mon  = pTimeBlock->Mon;
  u32 Day  = pTimeBlock->Day;
  u32 Hour = pTimeBlock->Hour;
  u32 Min  = pTimeBlock->Min;
  u32 Sec  = pTimeBlock->Sec;

  if(0 >= (int)(Mon -= 2))
  {    /* 1..12 -> 11,12,1..10 */
    Mon += 12;      /* Puts Feb last since it has leap day */
    Year -= 1;
  }

  return (
          (
           (
            (Year/4 - Year/100 + Year/400 + 367*Mon/12 + Day) + Year*365 - 719499
           )*24 + Hour /* now have hours */
          )*60 + Min /* now have minutes */
         )*60 + Sec; /* finally seconds */
}
 u32 GetExtOrLcdStamp(StructTime *pTime)
{
  u32 TimeStamp_LcdRtc;
  u32 TimeStamp_ExtRtc;
  u32 Temp;

  u32 LcdRtcDiffVal;
  u32 ExtRtcDiffVal;

  TimeStamp_LcdRtc = TimeToStamp(pTime);
  Temp = RtcGetTime();
  if((Temp < (TimeStamp_LcdRtc - 1800)) || (Temp > (TimeStamp_LcdRtc + 1800)))//Ļʱ쳣
  {
    RtcExtGetTime(pTime);
    TimeStamp_ExtRtc = TimeToStamp(pTime);
    if((Temp < (TimeStamp_ExtRtc - 1800)) || (Temp > (TimeStamp_ExtRtc + 1800)))//ⲿʱʱ쳣
    {
      if(Temp > TimeStamp_LcdRtc)
      {
        LcdRtcDiffVal = Temp-TimeStamp_LcdRtc;
      }
      else
      {
        LcdRtcDiffVal = TimeStamp_LcdRtc-Temp;
      }
      if(Temp > TimeStamp_ExtRtc)
      {
        ExtRtcDiffVal = Temp-TimeStamp_ExtRtc;
      }
      else
      {
        ExtRtcDiffVal = TimeStamp_ExtRtc-Temp;
      }
      if(LcdRtcDiffVal > ExtRtcDiffVal)
      {
        LcdSetRtc(pTime);
        Temp = TimeStamp_ExtRtc;
      }
      else
      {
        Temp = TimeStamp_LcdRtc;
      }
    }
    else//ӽⲿʱ
    {
      LcdSetRtc(pTime);
      Temp = TimeStamp_ExtRtc;
    }
  }
  else
  {
    Temp = TimeStamp_LcdRtc;
  }
  return Temp;
}
#endif 
void Thd_TCUControl(void const *parameter)
{
  osDelay(1500);
  TCUCtrl.CurScreen =  eLcdPro_TCUMainMenu;
  TCUCtrl.Param = 0;
  while(1)
  {
    if(TCUCtrl.CurScreen < eLcdPro_TCUMax)
      TCUCtrlHandle[TCUCtrl.CurScreen](&TCUCtrl);
    else
    {
      TCUCtrl.CurScreen = eLcdPro_TCUMainMenu;
      TCUCtrl.Param = 0;
    }
    osDelay(100);
  }
}

